#define EBATWO
#define ADDON1
//#define ADDON2
#region using
using System;
using UnityEngine;
using System.Collections;
using System.Collections.Generic;
using SimpleJSON;
using System.Linq;
using System.Threading;
using System.Text.RegularExpressions;
using System.Reflection;
using MVR.FileManagementSecure;
#endregion

namespace Cotyounoyume{
	public class EBATCore : MVRScript
	{
		public EBATCore core;
		public float version = 2.90f;
		public bool enableTest = false;
		// public bool enableTest = true;
		public Atom atom;
		public Atom peeAtom;
		public Atom UIAtom;
		public SimpleJSON.JSONClass settingsRoot = new SimpleJSON.JSONClass();
		public SimpleJSON.JSONClass settings = new SimpleJSON.JSONClass();
		public SimpleJSON.JSONClass sceneSettings = new SimpleJSON.JSONClass();
		public string myPath;
		public bool maintenanceAlert = false;
		public float lastTouchingTime = 0f;
		public string gender;
		public bool orgasmModeOn = false;
		public bool addon1ModeOn = false;
		public bool addon2ModeOn = false;
		public float perSecondOffset = 2f;
		public float perSecondOffsetFreq = 0.5f;
		public float lastTime = 0f;
		public float lastTimeFreq = 0f;
		
		protected float openingTime;
		public float currentTime;
		public float calmingDownTime;
		public float calmingDownTimeOffset = 2;
		public float calmingDownTimeMinusOffset;
		public int calmingDownPlus;
		public bool isHot = false;
//		public int orgasmCount = 0;
		public int ecstasyScale = 5;
		
		public int curStage = -1;
		public int preStage = -1;
		protected string defaultSettingsPath = "Custom/Scripts/cotyounoyume/ExpressionBlushingAndTears/Config/defaultSettings.json";
		protected string currentSettingsPath = "Custom/Scripts/ExpressionBlushingAndTears_currentSettings.json";
		protected string myClassName = "EBATCore";

		public string pluginLabel;
		public bool disableLog = true;
		public int[] stageThresholdInGame;
		public int[] stageThreshold;
		public bool isBreathActive = false;
		
		public bool isDuringOrgasmTotal = false;
		public bool isDuringOrgasm = false;
		public bool isDuringAfterglow = false;
		public bool isEmbarassed = false;		
		public bool isFirstTerm = false;
		public bool isFirstWave = false;
//		public bool hasMultipleOrgasms = false;

		public float orgasmStrengthMax = 0f;
		public float afterglowStrengthMax = 0f;
		public int orgasmWaveCycleBigMax = 10;
		public int orgasmWaveCycleBigMin = 3;
		public int orgasmWaveCycleSmallMax = 4;
		public int orgasmWaveCycleSmallMin = 1;
		public int orgasmAfterglowCycleBigMax = 3;
		public int orgasmAfterglowCycleBigMin = 2;
		public int orgasmAfterglowCycleSmallMax = 1;
		public int orgasmAfterglowCycleSmallMin = 1;
		public float orgasmWaveCycleIntervalBigMax = 0.4f;
		public float orgasmWaveCycleIntervalSmallMax = 0.1f;
		public float orgasmAfterglowCycleIntervalBigMax = 0.8f;
		public float orgasmAfterglowCycleIntervalSmallMax = 0.2f;
		
		public bool armBinderByHandOnGlobal = true;
		public bool armBinderByBeamOnGlobal = false;
		public bool legBinderByHandOnGlobal = true;
		public bool legBinderByBeamOnGlobal = false;
		public bool oneArmEachOnGlobal = false;
		public bool coveringOnGlobal = true;
		public bool coveringWithHandsOnGlobal = true;
		public bool coveringWithLegsOnGlobal = true;
		public bool coveringMouthOnGlobal = true;
		public bool collisionFailureCheckOnGlobal = true;
		public bool collisionAutoFixOnGlobal = false;
		public bool collisionControlOnGlobal = true;
		public string myName = "";
		public string myNameOld = "";
		public bool isNameChanged = false;
		
		public bool collisionFailure = false;
		
		public bool bellyBoneOn  = true;
		public bool bellyMorphOn = true;
		
		public Blushing blushing;
		public Tears tears;
		public EyesControl eyesControl;
		public Belly belly;
		public Etc etc;
		public BodyMorph bodyMorph;
		public WorldUI worldUi;
		public Sound sound;
		public CustomUI customUi;
		public Expression2 expression2;
		public Guess guess;
		public HeadController headController;
		public CustomUnityAssetItem customUnityAssetItem;
		public ManController manController;
		public AddonTakeControlItem addonTakeControl;
		public CollisionFailureDetector collisionFailureDetector;
		public ParentAngleChecker parentAngleChecker;
		public TriggersForExternalLinkage triggersForExternalLinkage;
		public BodyPartLocator bodyPartLocator;
		
		public Hint hint;
		public SoundExternalLinkage soundExternalLinkage;
		public ExternalLinkage externalLinkage;
		
		public bool menuOnGlobal = true;
		// public bool sensitiveTriggerOnGlobal = true;
		public List<Atom> generatedAtoms = new List<Atom>();
		public List<string> generatedAtomNames = new List<string>();
		public Dictionary<string, Atom> generatedAtomsDictionary = new Dictionary<string, Atom>();
		public List<GameObject> generatedGameObjects = new List<GameObject>();
		public List<string> generatedGameObjectNames = new List<string>();
		public Dictionary<string, GameObject> generatedGameObjectsDictionary = new Dictionary<string, GameObject>();
		
		public Atom commonMemory;
		public Atom trunk;
		public Atom trunkHead;
		public Atom trunkLow;
		public Atom floor;
		public float homingDelay = 1.0f;
		public float homingDelaySlow = 2.0f;
		public SphereCollider labiaCollider = null;
		public bool collider2xOnGlobal = false;
		public float assetScale = 1.0f;
		
		public bool NeedForNotification = false;
		public bool isUnderControl = false;
		public bool vammoanLinkOnGlobal = false;
		
		public bool wasInWorldUi = false;
		public bool wasMinimized = false;
		public int loadStatus = 0;
		public Quaternion rotIni;
		public List<string> cuas;
		public Dictionary<string, int> HitCountMap = new Dictionary<string, int>();
		public List<string> HitCountList = new List<string>();
		public int ListCount = 10;

		public Dictionary<string, string> stageMap = new Dictionary<string, string>();
		public Dictionary<string, string> levelMap = new Dictionary<string, string>();
		public string stageHeat  = "cool";
		public string stageLevel = "Lv1";
		public bool IsLoadedBeforeStartup = false;
		public bool hasCommonMemory = false;
		public bool InitDone = false;
		public string memoryAtomName = "EBAT_Common_Memory";
		public bool fistLockL = false;
		public bool fistLockR = false;
		public bool nowLoading = false;
		public bool DisableTriggerOn = false;
		public float MouthCoverRatio = 0.1f;

		public bool speedRandomizerOnGlobal = true;
		public float randomSpeedMin = 0.5f;
		public float randomSpeedMax = 2.0f;

#if	(EBATWO)
		public Orgasm orgasm;
#endif
#if	(ADDON1)
		public AddonManager1 addonManager1;
		public WorldUIAddon1 worldUIAddon1;
#endif
#if	(ADDON2)
		public AddonManager2 addonManager2;
		public WorldUIAddon2 worldUIAddon2;
#endif
				
		public override void Init(){
			try{
				Logger("Init: start");
				this.core = this;
                if (containingAtom.type != "Person"){
                    SuperController.LogError("This plug-in have to be added to person type atom.");
                    return;
                }
				atom = containingAtom;
				
				InitializeStageHeat();
				IsLoadedBeforeStartup = SuperController.singleton.isLoading;
				
				myName = atom.name;
				myPath = Utility.GetPluginPath(this as MVRScript, atom);
				gender = Utility.GetGender(atom);
				
				if(ConfigFileExist() == false){
					LoadSettingsEBATCore("default");
					SaveConfig();
				}else{
					LoadSettingsEBATCore("current");				
				}

				StartConstructors();

				LoadSettingsAfterEBATCore();
				Logger("Init: end");
			}catch (Exception e){
				LoggerE(e);
			}
		}
		
		public bool HasUnknownError()
		{
			return expression2.IsFmmWrong();
		}
		
		
		public bool ConfigFileExist(){
			try{
				if(FileManagerSecure.FileExists(currentSettingsPath)){
					return true;
				}else{
					return false;
				}
			}catch (Exception e){
				LoggerE(e);
				return false;
			}
		}
		
		public void StartConstructorUnconstrained(){
			blushing                 = new Blushing(this);
			tears                    = new Tears(this);
			bodyMorph                = new BodyMorph(this);
			eyesControl              = new EyesControl(this);
			belly                    = new Belly(this);
			etc                      = new Etc(this);
			sound                    = new Sound(this);
			expression2              = new Expression2(this);
			guess                    = new Guess(this);
			headController           = new HeadController(this);
			customUnityAssetItem     = new CustomUnityAssetItem(this);
			collisionFailureDetector = new CollisionFailureDetector(this);
			soundExternalLinkage     = new SoundExternalLinkage(this);
			manController            = new ManController(this);
			addonTakeControl         = new AddonTakeControlItem(this);			
			hint                     = new Hint(this);
			parentAngleChecker       = new ParentAngleChecker(this);
			triggersForExternalLinkage = new TriggersForExternalLinkage(this);
			bodyPartLocator          = new BodyPartLocator(this);
			externalLinkage          = new ExternalLinkage(this);
		}
		
		public void SetParameterForAddon(){
			DoOrgasmFunction("ModeOn");
			DoAddonManager1Function("ModeOn");
			DoAddonManager2Function("ModeOn");			
		}
		
		public void StartConstructorForAddons(){
			DoOrgasmFunction("Construct");
			DoAddonManager1Function("Construct");
			DoAddonManager2Function("Construct");
		}
		
		public void StartConstructorForUI(){
			customUi    = new CustomUI(this);
			worldUi     = new WorldUI(this, 0.001f);
			DoAddonManager1Function("ConstructWorldUi");
			DoAddonManager2Function("ConstructWorldUi");
		}
		
		public void LoadSettingsEBATCore(string type){
			try{
				defaultSettingsPath = myPath + "/" + "Config/defaultSettings.json";
				string path = (type == "default") ? defaultSettingsPath : currentSettingsPath;
				settingsRoot = SuperController.singleton.LoadJSON(path) as JSONClass;
				pluginLabelJSON.val = settingsRoot["Common"]["General"]["Label"];
				settings = (gender == "Female") ? settingsRoot["Female"].AsObject : settingsRoot["Male"].AsObject;

				if(version != settingsRoot["Common"]["General"]["Version"].AsFloat){
					AddSettingsNew();
					NeedForNotification = true;
				}
				
				pluginLabel = settingsRoot["Common"]["General"]["Label"];
				disableLog = settingsRoot["Common"]["General"]["Debug Message Off"].AsBool;
				if(settingsRoot["Female"].AsObject.HasKey("Blush")){
					settingsRoot["Female"].Remove("Blush");
				}
				if(settingsRoot["Male"].AsObject.HasKey("Blush")){
					settingsRoot["Male"].Remove("Blush");
				}

				menuOnGlobal = settings["General"]["Display UI Menu"].AsBool;
				// sensitiveTriggerOnGlobal = settings["General"]["Sensitive Trigger"].AsBool;
				ecstasyScale = settings["General"]["Ecstasy Scale"].AsInt;
				collider2xOnGlobal = settings["General"]["2x Collider Radius"].AsBool;
				vammoanLinkOnGlobal = settings["General"]["Use VAMMoan for Sound"].AsBool;
				armBinderByHandOnGlobal = settings["General"]["Armbinder By Hand"].AsBool;
				armBinderByBeamOnGlobal = settings["General"]["Armbinder By Beam"].AsBool;
				legBinderByHandOnGlobal = settings["General"]["Legbinder By Hand"].AsBool;
				legBinderByBeamOnGlobal = settings["General"]["Legbinder By Beam"].AsBool;
				coveringOnGlobal = settings["General"]["Covering Action"].AsBool;
				coveringWithHandsOnGlobal = settings["General"]["Cover with Hands"].AsBool;
				coveringWithLegsOnGlobal  = settings["General"]["Close Legs"].AsBool;
				coveringMouthOnGlobal     = settings["General"]["Cover Mouth"].AsBool;
				oneArmEachOnGlobal = settings["General"]["Select One Arm Each"].AsBool;
				collisionFailureCheckOnGlobal = settings["General"]["Collision Failure Check"].AsBool;
				collisionAutoFixOnGlobal = settings["General"]["Collision Auto Fix"].AsBool;
				collisionControlOnGlobal = settings["General"]["CUA Collision"].AsBool;
				speedRandomizerOnGlobal = settings["General"]["CUA Speed Randomizer"].AsBool;
				

				bellyMorphOn = settings["General"]["Shivering during climax(morph)"].AsBool;
				bellyBoneOn = settings["General"]["Shivering during climax(bone)"].AsBool;
				assetScale = settings["General"]["CustomUnityAsset Scale"].AsFloat;
				MouthCoverRatio = settings["General"]["Mouth Cover Event Ratio"].AsFloat;
				randomSpeedMin = settings["General"]["CUA Random Speed Min"].AsFloat;
				randomSpeedMax = settings["General"]["CUA Random Speed Max"].AsFloat;

				InitializeStageThreshold();								
			}catch(Exception e){
				LoggerE(e);
			}
		}

		public void InitializeStageThreshold()
		{
			stageThreshold = new int[6];
			stageThreshold[0] = 0;
			stageThresholdInGame = new int[6];
			stageThresholdInGame[0] = 0;

			for(int i = 0; i < 6; i++){
				stageThreshold[i] = settings["StageThreshold"][("Threshold" + i)]["Value"].AsInt;
				stageThresholdInGame[i] = stageThreshold[i] * ecstasyScale;
			}
		}

		public void StartConstructors()
		{
			StartConstructorUnconstrained();
			StartConstructorForAddons();
			SetParameterForAddon();
			//				SetupMemoryAtom();
			StartConstructorForUI();
		}

		public void LoadSettingsAfterEBATCore()
		{
			LoadSettingsOtherClasses();
			customUi.SetupUIVariables();
			customUi.OverwriteVariableWithSavedata();
		}

		public void AddSettingsNew(){
			SimpleJSON.JSONClass defaultSettingsRoot = SuperController.singleton.LoadJSON(defaultSettingsPath) as JSONClass;
			foreach (var key in defaultSettingsRoot.Keys){
				JSONNode jsn1 = defaultSettingsRoot[key];
				JSONNode jsn2 = settingsRoot[key];
				SyncJSON(key, jsn1, jsn2);
			}
		}
		
		public void SyncJSON(string keyOrig, JSONNode jsn1, JSONNode jsn2){
			if(jsn1 is JSONClass){
				JSONClass jsc1 = jsn1 as JSONClass;
				foreach(var key in jsc1.Keys){
					JSONNode newjsn1 = jsc1[key];
					JSONNode newjsn2 = jsn2[key];
					if((keyOrig == "General" && key == "Label") ||
					   (keyOrig == "General" && key == "Version")){
						jsn2[key] = newjsn1;
					}else if(newjsn2 == null){
						jsn2.Add(key, newjsn1);
					}else{
						SyncJSON(key, jsn1[key], jsn2[key]);
					}
				}
			}else if(jsn1 is JSONArray){
				JSONArray jsa1 = jsn1 as JSONArray;
				for(int key = 0; key < jsn1.Count; key++){
					string keyStr = key.ToString();
					JSONNode newjsn1 = jsa1[key];
					JSONNode newjsn2 = jsn2[key];
					if(newjsn2 == null){
						jsn2.Add(keyStr, newjsn1);
					}else{
						SyncJSON(keyStr, jsn1[keyStr], jsn2[keyStr]);
					}
				}				
			}else{
				if(jsn1.Count > 0){
					Info("ERROR: unknown JSONNode: key:" + keyOrig + ", value:" + jsn1.ToString());				
				}
			}
		}
		
		public void LoadSettingsOtherClasses(){
			try{
				blushing.DisableLog = disableLog;
				tears.DisableLog = disableLog;
				bodyMorph.disableLog = disableLog;
				eyesControl.disableLog = disableLog;
				belly.disableLog = disableLog;
				headController.disableLog = disableLog;
				etc.disableLog = disableLog;
				sound.disableLog = disableLog;
				
				expression2.LoadSettings();
				blushing.LoadSettings();
				tears.LoadSettings();
				bodyMorph.LoadSettings();
				eyesControl.LoadSettings();
				belly.LoadSettings();
				etc.LoadSettings();
				sound.LoadSettings();
				customUnityAssetItem.LoadSettings();
				customUi.LoadSettings();
				worldUi.LoadSettings();
				guess.LoadSettings();
				headController.LoadSettings();
				addonTakeControl.LoadSettings();
				manController.LoadSettings();

				DoOrgasmFunction("LoadSettings");
				DoAddonManager1Function("LoadSettings");
				DoAddonManager2Function("LoadSettings");

			}catch (Exception e){
				LoggerE(e);
			}
		}

		public void ResetThreshold(){
			for(int i = 0; i < 6; i++){
				stageThresholdInGame[i] = stageThreshold[i] * ecstasyScale;
			}
		}

		public bool HasCommonMemory(){
			hasCommonMemory = GetCUAAtom(memoryAtomName, false) != null;
			return hasCommonMemory;
		}

		public void Start(){
			try{
				Logger("Start: start");
				Logger("IsLoadedBeforeStartup: " + IsLoadedBeforeStartup);
				hasCommonMemory = HasCommonMemory();
				Logger("HasCommonMemory: " + hasCommonMemory);

				SetupMemoryAtom();
				ApplySettings();
				
				
				customUi.InitExpandState(false);
				customUi.SetupUI();
				
				CleaningUnnecessaryAtoms();

				worldUi.MakeWorldUI();
				
				Transform pelvisRT      = Utility.GetTransformFromTargetBodyname(core.atom, "pelvis");
				Transform labiaTriggerT = Utility.GetTransformFromTargetBodyname(core.atom, "LabiaTrigger");
				parentAngleChecker.RegisterPair(labiaTriggerT, pelvisRT, "LabiaTrigger");
				
				openingTime = Time.time;
				int startValue = (int)customUi.jsGauge.val;
				//logger("startValue:" + startValue);
				SetGauge(startValue);
				if(startValue > stageThresholdInGame[1]){
					OnErogenousZoneTouch("ByScript");
				}
				isBreathActive = false;
				
				MaintenanceSequence();
//				belly.storePositionAndRotation();
//				headController.storePositionAndRotation();
				blushing.UnequipBlush();
				tears.UnequipTearsAll();
				bodyMorph.StopBodyMorph();
				expression2.StopExpression();
				Logger("Start: end");
			}catch (Exception e){
				LoggerE(e);
			}			
		}

		
		public void ApplySettings(){
			try{
				if(collider2xOnGlobal && CheckLabiaTriggerNormal()){
					ToggleDoublingColliderSize();
				}else if(!collider2xOnGlobal && !CheckLabiaTriggerNormal()){
					ToggleDoublingColliderSize();
				}

				// if(sensitiveTriggerOnGlobal){
				// 	SubscribeAllTrigger();
				// }else{
				// 	UnsubscribeAllTrigger();
				// }
				
				CheckLabiaTriggerNormal();

				blushing.ApplySettings();
				tears.ApplySettings();
				bodyMorph.ApplySettings();
				eyesControl.ApplySettings();
				sound.ApplySettings();
				belly.ApplySettings();
				headController.ApplySettings();
				etc.ApplySettings();
				worldUi.ApplySettings();
				addonTakeControl.ApplySettings();
				manController.ApplySettings();
				guess.ApplySettings();
				
				DoOrgasmFunction("ApplySettings");
				DoAddonManager1Function("ApplySettings");
				DoAddonManager2Function("ApplySettings");
				
			}catch (Exception e){
				LoggerE(e);
			}
		}
		
		public void VersionCheck(){
			if(NeedForNotification){
				hint.VersionCheckHint();
				NeedForNotification = false;
				SaveConfig();
			}
				
			pluginLabel = settingsRoot["Common"]["General"]["Label"];			
		}
		
		
		public void MaintenanceSequence(){
			try{
				ResetTriggers();
				RegisterActions();
				
				blushing.Maintenance();
				tears.Maintenance();
				bodyMorph.Maintenance();
				eyesControl.Maintenance();
				belly.Maintenance();
				headController.Maintenance();
				etc.Maintenance();
			}catch (Exception e){
				LoggerE(e);
			}
		}
		
		public void EmbarrassALittle(int level = 2){
			if(GetGauge() < stageThresholdInGame[level]){
				SetGauge(stageThresholdInGame[level]);
			}
			OnErogenousZoneTouch("ByScript");			
		}
		
		public void DoOrgasmFunction(string func){
#if (EBATWO)
			if(func == "Construct"){
				orgasm = new Orgasm(this);
			}else if(func == "ModeOn"){
				orgasmModeOn = true;
			}else if(func == "LoadSettings"){
				orgasm.LoadSettings();
			}else if(func == "ApplySettings"){
				orgasm.ApplySettings();				
			}else if(func == "Manage"){
				orgasm.Manage();				
			}else if(func == "OnDestroy"){
				orgasm.OnDestroy();				
			}else if(func == "OrgasmCheck"){
				orgasm.OrgasmCheck();
			}else if(func == "Update"){
				orgasm.Update();
			}else if(func == "OrgasmControl"){
				orgasm.OrgasmControl();
			}else if (func == "MakeHerOrgasm"){
				orgasm.MakeHerOrgasm();
			}else if (func == "StopHerOrgasm"){
				orgasm.StopHerOrgasm();
			}else if(func == "OrgasmStart"){
				orgasm.OrgasmStart();
			}else if(func == "OrgasmFinish"){
				orgasm.OrgasmFinish();
			}else if(func == "SingleWave"){
				orgasm.SingleWaveStart();
			}
#endif
		}
		
		public void DoAddonManager1Function(string func){
#if (ADDON1)
			if(func == "Construct"){
				addonManager1 = new AddonManager1(this);
			}else if(func == "ConstructWorldUi"){
				addonManager1.DoWorldUIAddon1Function("Construct");
			}else if(func == "ModeOn"){
				addon1ModeOn = true;
			}else if(func == "LoadSettings"){
				addonManager1.LoadSettings();
			}else if(func == "ApplySettings"){
				addonManager1.ApplySettings();	
			}else if(func == "AddonClothSimApplySettings"){
				addonManager1.DoWorldUIAddon1Function("AddonClothSimApplySettings");
			}else if(func == "Manage"){
				addonManager1.Manage(currentTime);				
			}else if(func == "OnDestroy"){
				addonManager1.OnDestroy();				
			}else if(func == "OnOrgasmStart"){
				addonManager1.OnOrgasmStart();				
			}else if(func == "OnOrgasmStop"){
				addonManager1.OnOrgasmStop();				
			}else if(func == "OnUndressAndRemoveClick"){
				addonManager1.DoWorldUIAddon1Function("OnUndressAndRemoveClick");
			}else if(func == "OnUndressClick"){
				addonManager1.DoWorldUIAddon1Function("OnUndressClick");
			}else if(func == "OnUndressForceClick"){
				addonManager1.DoWorldUIAddon1Function("OnUndressForceClick");
			}else if(func == "OnReverseClick"){
				addonManager1.DoWorldUIAddon1Function("OnReverseClick");
			}else if(func == "OnUndressAndReverseClick"){
				addonManager1.DoWorldUIAddon1Function("OnUndressAndReverseClick");
			}else if(func == "OnUndressRevStrongClick"){
				addonManager1.DoWorldUIAddon1Function("OnUndressRevStrongClick");
			}else if(func == "OnAltSkinWrapClick"){
				addonManager1.DoWorldUIAddon1Function("OnAltSkinWrapClick");
			}else if(func == "OnUndressStopClick"){
				addonManager1.DoWorldUIAddon1Function("OnUndressStopClick");
			}else if(func == "OnUndressRecoverClick"){
				addonManager1.DoWorldUIAddon1Function("OnUndressRecoverClick");
			}else if(func == "OnExposeBreastsClick"){
				addonManager1.DoWorldUIAddon1Function("OnExposeBreastsClick");
			}else if(func == "OnExposeBreastsStrongClick"){
				addonManager1.DoWorldUIAddon1Function("OnExposeBreastsStrongClick");
			}else if(func == "OnPullUpSkirtClick"){
				addonManager1.DoWorldUIAddon1Function("OnPullUpSkirtClick");
			}else if(func == "OnUndressRemoveClick"){
				addonManager1.DoWorldUIAddon1Function("OnUndressRemoveClick");
			}else if(func == "OnUndressOpt1Click"){
				addonManager1.DoWorldUIAddon1Function("OnUndressOpt1Click");
			}else if(func == "OnUndressOpt2Click"){
				addonManager1.DoWorldUIAddon1Function("OnUndressOpt2Click");
			}else if(func == "OnUndressOpt3Click"){
				addonManager1.DoWorldUIAddon1Function("OnUndressOpt3Click");
			}else if(func == "OnUndressOpt4Click"){
				addonManager1.DoWorldUIAddon1Function("OnUndressOpt4Click");
			}else{
				Info("In EBATCore: Unknown command: " + func);
			}	
#endif
		}
		
		public void DoAddonManager2Function(string func, string var1 = "", int var2 = 0){
#if (ADDON2)
			try{
				if(func == "Construct"){
					addonManager2 = new AddonManager2(this);
				}else if(func == "ConstructWorldUi"){
					addonManager2.DoWorldUIAddon2Function("Construct");
				}else if(func == "ReadMemory"){
					addonManager2.worldUIAddon2.ReadMemory();
				}else if(func == "MakeButtonStructures"){
					addonManager2.worldUIAddon2.MakeButtonStructures();
				}else if(func == "ModeOn"){
					addon2ModeOn = true;
				}else if(func == "LoadSettings"){
					addonManager2.LoadSettings();
				}else if(func == "ApplySettings"){
					addonManager2.ApplySettings();				
				}else if(func == "Manage"){
					addonManager2.Manage(currentTime);				
				}else if(func == "Update"){
					addonManager2.Update(currentTime);				
				}else if(func == "UpdateCovering"){
					addonManager2.UpdateCovering();				
				}else if(func == "OnDestroy"){
					addonManager2.OnDestroy();				
				}else if(func == "OnOrgasmStart"){
					addonManager2.OnOrgasmStart();				
				}else if(func == "SendParameterToCUA"){
					addonManager2.addonCua.SendParameterToCUA(var2);
				}else if(func == "OnOrgasmStop"){
					addonManager2.OnOrgasmStop();				
				}else if(func == "OnStageChangeStageUp"){
					addonManager2.OnStageChange(true);
				}else if(func == "OnStageChangeStageDown"){
					addonManager2.OnStageChange(false);
				// }else if(func == "LabelSwitchOnLoad"){
				// 	addonManager2.DoWorldUIAddon2Function("LabelSwitchOnLoad");
				}else if(func == "RecoveryCUAs"){
					DoDelayedAction(addonManager2.addonCua.RecoveryCUAs, 2.0f);
					DoDelayedAction(addonManager2.addonCua.SendParameterToCUA, 2.5f);
					DoDelayedAction(addonManager2.addonCua.ResizeCUAs, 3.0f);
				}else if(func == "LabelSwitch"){
					addonManager2.DoWorldUIAddon2Function("LabelSwitch");
				}else if(func == "SetAssetScale"){
					addonManager2.addonCua.SetAssetScale();
				}else if(func == "RemoveMenuBodyAddon"){
					addonManager2.DoWorldUIAddon2Function("RemoveMenuBodyAddon");
				}else if(func == "ExpandAddon2All"){
					addonManager2.DoWorldUIAddon2Function("ExpandAddon2All");
				}else if(func == "CollapseAddon2All"){
					addonManager2.DoWorldUIAddon2Function("CollapseAddon2All");
				}else if(func == "MakeMenuBodyAddon"){
					addonManager2.DoWorldUIAddon2Function("MakeMenuBodyAddon");
				}else if(func == "RemoveMenuBodyAddon"){
					addonManager2.DoWorldUIAddon2Function("RemoveMenuBodyAddon");
				}else if(func == "SpeedRandomizer"){
					addonManager2.addonCua.SpeedRandomizer();
				}else if(func == "RemoveCUAs"){
					addonManager2.addonCua.RemoveCUAs();
				}else if(func == "GetCUAs"){
					addonManager2.addonCua.GetCUAs();
				}else if(func == "RecallCUAs"){
					addonManager2.addonCua.RecallCUAs();
					DoDelayedAction(addonManager2.addonCua.ResizeCUAs, 1.0f);
				}else if(func == "ResizeCUAs"){
					DoDelayedAction(addonManager2.addonCua.ResizeCUAs, 0.5f);

				}else if(func == "ToggleCoveringActions"){
					addonManager2.worldUIAddon2.OnConfigXClickCommon("C:Covering Actions");					
				}else if(func == "ToggleCoverWithHands"){
					addonManager2.worldUIAddon2.OnConfigXClickCommon("C:Cover With Hands");					
				}else if(func == "ToggleCloseLegs"){
					addonManager2.worldUIAddon2.OnConfigXClickCommon("C:Close Legs");
				}else if(func == "ToggleCoverMouth"){
					addonManager2.worldUIAddon2.OnConfigXClickCommon("C:Cover Mouth");

				}else if(func == "CoverWithHands"){
					addonManager2.addonCovering.CoverTargetArms(temporary:true);
				}else if(func == "CoverWithHandsUU"){
					addonManager2.addonCovering.CoverTargetArms(specific:"rNipple:lNipple", temporary:true);
				}else if(func == "CoverWithHandsUL"){
					addonManager2.addonCovering.CoverTargetArms(specific:"rNipple:LabiaTrigger", temporary:true);
				}else if(func == "CoverWithHandsLL"){
					addonManager2.addonCovering.CoverTargetArms(specific:"LabiaTrigger:LabiaTrigger", temporary:true);
				}else if(func == "CloseLegs"){
					addonManager2.addonCovering.CoverTargetLegs(temporary:true);
				}else if(func == "CoverMouth"){
					addonManager2.addonCovering.MoveHandToMouthIfNeeded(temporary:true);
				}else if(func == "CoveringTargetsForUndress"){
					addonManager2.addonCovering.CoveringTargetsForUndress();
				}else if(func == "OnBackupPoseClick"){
					core.addonManager2.worldUIAddon2.OnBackupPoseClick();
				}else if(func == "OnRecoverPoseClick"){
					core.addonManager2.worldUIAddon2.OnRecoverPoseClick();

				}else if(func == "MoveHandToMouthIfNeeded"){
					core.addonManager2.addonCovering.MoveHandToMouthIfNeeded();

				}else if(func == "OnHoldMouth1Click"){
					core.addonManager2.worldUIAddon2.OnHoldMouth1Click();
				}else if(func == "OnHoldMouth2Click"){
					core.addonManager2.worldUIAddon2.OnHoldMouth2Click();
				}else if(func == "OnStopHoldMouthClick"){
					core.addonManager2.worldUIAddon2.OnStopHoldMouthClick();
					
				}else if(func == "OnHoldArmsClick"){
					core.addonManager2.worldUIAddon2.OnHoldArmsClick("HandL");
					core.addonManager2.worldUIAddon2.OnHoldArmsClick("HandR");
				}else if(func == "OnHoldArmLClick"){
					core.addonManager2.worldUIAddon2.OnHoldArmsClick("HandL");
				}else if(func == "OnHoldArmRClick"){
					core.addonManager2.worldUIAddon2.OnHoldArmsClick("HandR");

				}else if(func == "OnLockArmsSideClick"){
					core.addonManager2.worldUIAddon2.OnLockArmsSideClick("HandL");
					core.addonManager2.worldUIAddon2.OnLockArmsSideClick("HandR");
				}else if(func == "OnLockArmLSideClick"){
					core.addonManager2.worldUIAddon2.OnLockArmsSideClick("HandL");
				}else if(func == "OnLockArmRSideClick"){
					core.addonManager2.worldUIAddon2.OnLockArmsSideClick("HandR");

				}else if(func == "OnLockArmsBackClick"){
					core.addonManager2.worldUIAddon2.OnLockArmsBackClick("HandL");
					core.addonManager2.worldUIAddon2.OnLockArmsBackClick("HandR");
				}else if(func == "OnLockArmLBackClick"){
					core.addonManager2.worldUIAddon2.OnLockArmsBackClick("HandL");
				}else if(func == "OnLockArmRBackClick"){
					core.addonManager2.worldUIAddon2.OnLockArmsBackClick("HandR");

				}else if(func == "OnLockArmsUpClick"){
					core.addonManager2.worldUIAddon2.OnLockArmsUpClick("HandL");
					core.addonManager2.worldUIAddon2.OnLockArmsUpClick("HandR");
				}else if(func == "OnLockArmLUpClick"){
					core.addonManager2.worldUIAddon2.OnLockArmsUpClick("HandL");
				}else if(func == "OnLockArmRUpClick"){
					core.addonManager2.worldUIAddon2.OnLockArmsUpClick("HandR");

				}else if(func == "OnStopLockArmsClick"){
					core.addonManager2.worldUIAddon2.OnStopLockArmsClick("both");
				}else if(func == "OnStopLockArmLClick"){
					core.addonManager2.worldUIAddon2.OnStopLockArmsClick("left");
				}else if(func == "OnStopLockArmRClick"){
					core.addonManager2.worldUIAddon2.OnStopLockArmsClick("right");

				}else if(func == "OnArmBinderByHandClick"){
					core.addonManager2.worldUIAddon2.OnConfigXClickCommon("C:ArmBinder[Hand]");
				}else if(func == "OnArmBinderByBeamClick"){
					core.addonManager2.worldUIAddon2.OnConfigXClickCommon("C:ArmBinder[Beam]");
					
				}else if(func == "OnHoldLegsClick"){
					core.addonManager2.worldUIAddon2.OnHoldLegsClick();
				}else if(func == "OnOpenLegsUpClick"){
					core.addonManager2.worldUIAddon2.OnOpenLegsUpClick();
				}else if(func == "OnOpenLegsWidelyClick"){
					core.addonManager2.worldUIAddon2.OnOpenLegsWidelyClick();
				}else if(func == "OnOpenLegsSlightlyClick"){
					core.addonManager2.worldUIAddon2.OnOpenLegsSlightlyClick();
				}else if(func == "OnStopOpeningLegsClick"){
					core.addonManager2.worldUIAddon2.OnStopOpeningLegsClick();
				}else if(func == "OnLiftUpKneeClick"){
					core.addonManager2.worldUIAddon2.OnLiftUpKneeClick();
				}else if(func == "OnLiftUpKneesClick"){
					core.addonManager2.worldUIAddon2.OnLiftUpKneesClick();
				}else if(func == "OnLegSplitClick"){
					core.addonManager2.worldUIAddon2.OnLegSplitClick();
				}else if(func == "OnLegSplitMoreClick"){
					core.addonManager2.worldUIAddon2.OnLegSplitMoreClick();
				}else if(func == "OnLegBinderByHandClick"){
					core.addonManager2.worldUIAddon2.OnConfigXClickCommon("C:LegsBinder[Hand]");
				}else if(func == "OnLegBinderByBeamClick"){
					core.addonManager2.worldUIAddon2.OnConfigXClickCommon("C:LegsBinder[Beam]");

				// }else if(func == "OnCoveringActionsClick"){
				// 	core.addonManager2.worldUIAddon2.OnCoveringActionClick("All");
				// }else if(func == "OnCoverWithHandsActionClick"){
				// 	core.addonManager2.worldUIAddon2.OnCoveringActionClick("Hands");
				// }else if(func == "OnCloseLegsActionClick"){
				// 	core.addonManager2.worldUIAddon2.OnCoveringActionClick("Legs");
				// }else if(func == "OnCoverMouthActionClick"){
				// 	core.addonManager2.worldUIAddon2.OnCoveringActionClick("Mouth");
					
				}else if(func == "OnSummonHandRv2Click"){
					core.addonManager2.worldUIAddon2.OnSummonHandRv2Click();
				}else if(func == "OnSummonHandLv2Click"){
					core.addonManager2.worldUIAddon2.OnSummonHandLv2Click();
				}else if(func == "OnSummonTentacle1v2Click"){
					core.addonManager2.worldUIAddon2.OnSummonTentacle1v2Click();
				}else if(func == "OnSummonMouthClick"){
					core.addonManager2.worldUIAddon2.OnSummonMouthClick();
				}else if(func == "OnSummonMouth1LClick"){
					core.addonManager2.worldUIAddon2.OnSummonMouth1LClick();
				}else if(func == "OnSummonMouth1RClick"){
					core.addonManager2.worldUIAddon2.OnSummonMouth1RClick();
				}else if(func == "OnSummonWMNZClick"){
					core.addonManager2.worldUIAddon2.OnSummonWMNZClick();
				}else if(func == "OnSummonTwinDildoClick"){
					core.addonManager2.worldUIAddon2.OnSummonTwinDildoClick();
				}else if(func == "OnStopAllClick"){
					core.addonManager2.worldUIAddon2.OnStopAllClick();
				}else if(func == "ChangeCollisionControls"){
					core.addonManager2.addonCua.ChangeCollisionAndModelControls();
				}else{
					Info("In EBATCore: Unknown command: " + func);
				}
			}catch(Exception e){
				Utility.LoggerE(e);
			}
#endif	
		}		
		
		public void SaveConfig(){
			try{
				SuperController.singleton.SaveJSON(settingsRoot, currentSettingsPath);
			}catch (Exception e){
				LoggerE(e);
			}
		}
		
		public void SetGauge(int value){
			try{
			
			if((int)customUi.jsGauge.val > stageThresholdInGame[5] * 1.2){
				value = (int)(stageThresholdInGame[5] * 1.2);
			}
			customUi.jsGauge.val = value;
			if((int)customUi.jsGauge.val > 0){
				calmingDownTime = currentTime + calmingDownTimeOffset + calmingDownTimeMinusOffset;
			}else{
				calmingDownTime = currentTime + 3600 * 24;
			}
			if(GetStage() >= 2){
				isHot = true;
			}else{
				isHot = false;
			}
			StageChangingCheck();
			if(!core.GetMemoryBool("isPaused")){
				if(worldUi != null && worldUi.uiGaugeSlider != null){
					worldUi.uiGaugeSlider.slider.value = (int)customUi.jsGauge.val;
				}
			}
			customUi.jsGauge.val = customUi.jsGauge.val;
			
			}catch(Exception e){
				core.LoggerE(e);
			}
		}
		
		public int GetGauge(){
			return (int)customUi.jsGauge.val;
		}
		
		public void IncrementGauge(int value = 1){
			int cnt = (int)customUi.jsGauge.val + value;
			SetGauge(cnt);
		}
		
		public void DecrementGauge(){
			if(isDuringOrgasm){
				return;
			}
			int fragment = (int)((currentTime - lastTouchingTime)/10);
			fragment = (fragment < 0) ? 0 : fragment;
			if(lastTouchingTime == 0f){
				fragment = 0;
				lastTouchingTime = currentTime;
			}
			int cnt = (int)customUi.jsGauge.val - (1 + fragment) * ecstasyScale - calmingDownPlus;
			SetGauge(cnt);
		}

		public float GetElapsedTime()
		{
			return currentTime - lastTouchingTime;
		}
		
		public void RegisterActions(){
			try{
//				RegisterActionPair("LipTrigger", "OnLipTouch", "Lip");
//				RegisterStartActionPair("MouthTrigger", "OnMouthTouch", "Mouth");				
//				RegisterStartActionPair("ThroatTrigger", "OnThroatTouch", "Throat");				
				RegisterStartActionPair("lNippleTrigger", "OnNippleLTouch", "NippleL");
				RegisterStartActionPair("rNippleTrigger", "OnNippleRTouch", "NippleR");
				RegisterStartActionPair("LabiaTrigger", "OnLabiaTouch", "Labia");
				RegisterStartActionPair("VaginaTrigger", "OnVaginaTouch", "Vagina");
				RegisterStartActionPair("DeepVaginaTrigger", "OnVaginaDeepTouch", "VaginaDeep");
				RegisterStartActionPair("DeeperVaginaTrigger", "OnVaginaDeeperTouch", "VaginaDeeper");
				
//				RegisterEndActionPair("MouthTrigger", "OnMouthTouchEnd", "Mouth");
//				RegisterEndActionPair("ThroatTrigger", "OnThroatTouchEnd", "Throat");				
				RegisterEndActionPair("lNippleTrigger", "OnNippleLTouchEnd", "NippleL");
				RegisterEndActionPair("rNippleTrigger", "OnNippleRTouchEnd", "NippleR");
				RegisterEndActionPair("LabiaTrigger", "OnLabiaTouchEnd", "Labia");
				RegisterEndActionPair("VaginaTrigger", "OnVaginaTouchEnd", "Vagina");
				RegisterEndActionPair("DeepVaginaTrigger", "OnVaginaDeepTouchEnd", "VaginaDeep");
				RegisterEndActionPair("DeeperVaginaTrigger", "OnVaginaDeeperTouchEnd", "VaginaDeeper");
			}catch (Exception e){
				LoggerE(e);
			}
		}
		
		public void RegisterEndActionPair(string collisionTrigger, string action, string position){
			RegisterStartActionPair(collisionTrigger, action, position, "end");
		}
		
		public void RegisterStartActionPair(string collisionTrigger, string action, string position, string type = "start"){
			try{
				if(type == "start"){
					JSONStorableAction tmpAction = new JSONStorableAction(action, () =>{
						OnErogenousZoneTouch(position);
					});
					RegisterAction(tmpAction);
				}else{
					JSONStorableAction tmpAction = new JSONStorableAction(action, () =>{
						OnErogenousZoneTouchEnd(position);
					});
					RegisterAction(tmpAction);
				}
				CreateTrigger(collisionTrigger, action, type);
			}catch (Exception e){
				LoggerE(e);
			}
		}
		
		public void ResetTriggers() {
			try{
				var table = new Dictionary<string, int>{
//					{"OnLipTouch", 1},
					{"OnMouthTouch", 1},
					{"OnThroatTouch", 1},
					{"OnNippleLTouch", 1},
					{"OnNippleRTouch", 1},
					{"OnLabiaTouch", 1},
					{"OnVaginaTouch", 1},
					{"OnVaginaDeepTouch", 1},
					{"OnVaginaDeeperTouch", 1}
				};
				var tableEnd = new Dictionary<string, int>{
//					{"OnLipTouch", 1},
					{"OnMouthTouchEnd", 1},
					{"OnThroatTouchEnd", 1},
					{"OnNippleLTouchEnd", 1},
					{"OnNippleRTouchEnd", 1},
					{"OnLabiaTouchEnd", 1},
					{"OnVaginaTouchEnd", 1},
					{"OnVaginaDeepTouchEnd", 1},
					{"OnVaginaDeeperTouchEnd", 1}
				};
//				string[] cTriggerNames = {"LipTrigger", "MouthTrigger", "ThroatTrigger","rNippleTrigger", "lNippleTrigger", "LabiaTrigger", "VaginaTrigger", "DeepVaginaTrigger", "DeeperVaginaTrigger"};
				string[] cTriggerNames = {"MouthTrigger", "ThroatTrigger","rNippleTrigger", "lNippleTrigger", "LabiaTrigger", "VaginaTrigger", "DeepVaginaTrigger", "DeeperVaginaTrigger"};
				foreach(string cTriggerName in cTriggerNames){
					Logger("cTriggerName = " + cTriggerName);
					CollisionTrigger cTrigger = atom.GetStorableByID(cTriggerName) as CollisionTrigger;
					JSONClass triggerClass = cTrigger.trigger.GetJSON();
					JSONArray triggerArray = triggerClass["startActions"].AsArray;
					for (int i=0;i< triggerArray.Count;i++) {
						Logger("triggerArray[" + i + "][name]=" + triggerArray[i]["name"].Value);
						if (table.ContainsKey(triggerArray[i]["name"].Value)){
							triggerArray.Remove(i);
						}
					}
					JSONArray triggerArrayEnd = triggerClass["endActions"].AsArray;
					for (int i=0;i< triggerArrayEnd.Count;i++) {
						if (tableEnd.ContainsKey(triggerArrayEnd[i]["name"].Value)){
							triggerArrayEnd.Remove(i);
						}
					}
					cTrigger.trigger.RestoreFromJSON(triggerClass);
				}
			}catch (Exception e){
				LoggerE(e);
			}
		}
		
		public void TriggerDeactivate(){
			string[] cTriggerNames = {"MouthTrigger", "ThroatTrigger","rNippleTrigger", "lNippleTrigger", "LabiaTrigger", "VaginaTrigger", "DeepVaginaTrigger", "DeeperVaginaTrigger"};
//			float rnd = UnityEngine.Random.Range(0.0f, 1.0f);
			foreach(string cTriggerName in cTriggerNames){
				CollisionTrigger cTrigger = atom.GetStorableByID(cTriggerName) as CollisionTrigger;
//				if(rnd < 0.25){
					cTrigger.trigger.active = false;
					cTrigger.trigger.transitionInterpValue = 0f;
//				}
			}
		}
		
		public void CreateTrigger(string triggerCollisionTriggerName, string scriptTriggerName, string type){
			try{
				CollisionTrigger cTrigger = atom.GetStorableByID(triggerCollisionTriggerName) as CollisionTrigger;
				cTrigger.enabled = true;
				TriggerActionDiscrete startTrigger;
				if(type == "start"){
					startTrigger=cTrigger.trigger.CreateDiscreteActionStartInternal();
				}else{
					startTrigger=cTrigger.trigger.CreateDiscreteActionEndInternal();					
				}
				startTrigger.name = scriptTriggerName;
				startTrigger.receiverAtom = atom;
				startTrigger.receiver = GetPluginStorableById(atom, myClassName);
				startTrigger.receiverTargetName = scriptTriggerName;
			}catch (Exception e){
				LoggerE(e);
			}
		}
	
		// Function taken from VAMDeluxe's code
		static JSONStorable GetPluginStorableById(Atom atom, string id){
			return Utility.GetPluginStorableById(atom, id);
		}
		
		public void DisableTriggerTemporary(float timer = 0.5f){
			DisableTriggerOn = true;
			DoDelayedAction(() => DisableTriggerOn = false, timer);
		}

		public void OnErogenousZoneTouch(string zone){ 
			try{
				currentTime = Time.time;
				if(core.GetMemoryBool("isPaused")){
					return;
				}
				if(DisableTriggerOn) return;
//				collisionFailureDetector.registerActiveResult(zone);
				
				Logger("Touch: " + zone);
				isEmbarassed = false;
				lastTouchingTime = currentTime;
				sound.PlaySound("moan", Time.time);
				UpdateAll();			

				calmingDownPlus = 0;
				calmingDownTimeMinusOffset = 0;
				int value = CalcZoneMap(zone);
				// Utility.Debug($"zone:{zone}, value:{value}");
				IncrementGauge(value);
				StageChangingCheck();
				
				if(isBreathActive == false){
					isBreathActive = true;
				}
				
				headController.PickAction();
				DoOrgasmFunction("OrgasmCheck");
			}catch (Exception e){
				LoggerE(e);
			}
		}
		
		public void OnErogenousZoneTouchEnd(string zone){ 
			
		}
		
		public int CalcZoneMap(string zone){
			int stage = GetStage();
			int value = 0;
			if(!HitCountMap.ContainsKey(zone)) HitCountMap.Add(zone, 0);
			HitCountMap[zone]++;
			HitCountList.Add(zone);
			if(zone == "Mouth" || zone == "Throat"){
				if(stage <= 2){
					value = 3;
				}else if(stage <= 4){
					value = 1;
				}else{
					value = 0;
				}
			}else if(zone.StartsWith("Nipple")){
				if(stage <= 2){
					value = 2;
				}else if(stage <= 4){
					value = 1;
				}else{
					value = 1;
				}
			}else if(zone == "Labia" || zone == "Vagina"){
				if(stage <= 2){
					value = 1;
				}else if(stage <= 4){
					value = 2;
				}else{
					value = 2;
				}
			}else if(zone == "VaginaDeep" || zone == "VaginaDeeper"){
				if(stage <= 2){
					value = 1;
				}else if(stage <= 4){
					value = 2;
				}else{
					value = 3;
				}
			}else if(zone == "ByScript"){
				value = 1;
			}
			return value;
		}

		public void RemakeHitCountList()
		{
			var newList = new List<string>();
			if(core.HitCountList.Count < ListCount) return;

			for(int i = HitCountList.Count - ListCount; i < HitCountList.Count; i++){
			newList.Add(HitCountList[i]);
			}
			HitCountList = newList;
		}
		
		public void RefreshEBATVisual(bool isStageChanged = false){
			if(isStageChanged)
			{
				tears.UnequipClothes(preStage);
				tears.EquipClothes(curStage);
			}
			tears.ChangeTearsEquipment();
			blushing.ChangeBlushEquipment();
			stageHeat = GetStageHeat();
			stageLevel = GetStageLevel();
			int cuaStage = GetCUAStage();
			DoAddonManager2Function("SendParameterToCUA", var2:cuaStage);
		}
		
		public void OnStageChange(bool isStageUp){
			try{
				RefreshEBATVisual(true);
				
				if(vammoanLinkOnGlobal){
					soundExternalLinkage.PlayByIntensity();
				}

				worldUi.UpdateStatus();
				if(addonTakeControl.autoStopOnGlobal){
					addonTakeControl.AutoStopPlugins();
				}

				if(isStageUp){
					DoAddonManager2Function("OnStageChangeStageUp");
				}else{
					DoAddonManager2Function("OnStageChangeStageDown");
				}
			}catch (Exception e){
				LoggerE(e);
			}			
		}
		
		public int GetCUAStage(){
			int cuaStage;
			int stage = GetStage();
			if(stage < 2){
				cuaStage = 0;
			}else if(stage < 3){
				cuaStage = 1;
			}else if(stage < 5){
				cuaStage = 2;
			}else{
				cuaStage = 3;
			}
			return cuaStage;
		}
		
		public void StageChangingCheck(){
			try{
				if(curStage != GetStage()){
					preStage = curStage;
					curStage = GetStage();
					bool isStageUp = (preStage < curStage);
					Logger("stage changed: " + preStage + " => " + curStage);
					
					OnStageChange(isStageUp);
					if(!isHot && !isStageUp){
						OnCalmDown();
					}
				}
			}catch(Exception e){
				LoggerE(e);
			}
		}
		
		public bool IsOrgasmFunctionEnabled(){
			bool flag = false;
#if (EBATWO)
			flag = true;
#endif
			return flag;
		}
		
		
		public void UpdateAll(){
			try{
				expression2.Update();
				bodyMorph.Update(currentTime);
				eyesControl.Update();
				DoAddonManager2Function("UpdateCovering");
				RefreshEBATVisual();
			}catch (Exception e){
				LoggerE(e);
			}
		}
			
		public float GetTime(){
			return Time.time;
		}
		
		public bool IsLoaded(){
			return (loadStatus == 9);
		}
		
		public void CheckLoadStatus(){
			if(loadStatus < 2){
				customUi.jsLoaded.SetVal(false);
				if(loadStatus == 1 && !SuperController.singleton.isLoading && SuperController.singleton.render){
					loadStatus = 2;
				}else if(loadStatus == 0 && SuperController.singleton.isLoading){
					loadStatus = 1;
				}else{
					if(SuperController.singleton.render){
						loadStatus = 2;
					}
				}
				
				if(loadStatus == 2){
					// DoAddonManager2Function("LabelSwitchOnLoad");
					DoAddonManager2Function("RecoveryCUAs");
					DoAddonManager1Function("AddonClothSimApplySettings");
					triggersForExternalLinkage.SetJSActions();
					loadStatus = 9;
					customUi.jsLoaded.SetVal(true);

					OnLoadDone();
					Logger("load done.");
					OnStageChange(true);
					
				}
			}
		}
		
		public void OnLoadDone(){
			externalLinkage.OnLoadDone();
			core.addonManager1.addonClothSim.OnLoadDone();
		}

        public void Update(){
            try{

				if(!IsLoaded()){
					CheckLoadStatus();
					return;
				}
				
				if(Time.time > currentTime + 10){
					currentTime = Time.time;
					Logger("start plug-in or load scene.");
					MaintenanceSequence();
				}
				
				if(GetMemoryBool("isPaused")){
					return;
				}
				
				string currentName = atom.name;
				if(myName != currentName){
					Logger("old name:" + myName + ", new name:" + currentName);
					maintenanceAlert = true;
				}
				
				if(maintenanceAlert){
					maintenanceAlert = false;
					OnNameChanged();
					return;
				}
				
				currentTime = Time.time;
				PerSecondCheck();
				PerSecondCheckFreq();

				if(calmingDownTime < currentTime){
					DecrementGauge();
				}
				
				DoOrgasmFunction("OrgasmControl");
				blushing.Manage();
				tears.Manage();
				bodyMorph.Manage(currentTime);
				expression2.Manage();
				eyesControl.Manage(currentTime);
				belly.Manage(currentTime);
				headController.Manage(currentTime);
				addonManager1.Manage(currentTime);
				DoAddonManager2Function("Manage");
				collisionFailureDetector.Update();
				guess.Manage();
				addonTakeControl.Manage(currentTime);
				manController.Manage(currentTime);

#if (EBATWO)				
				if(expression2.isExpressionActive == false && blushing.IsActive == false && tears.IsActive == false){
					if(isDuringOrgasm == false && GetGauge() < stageThresholdInGame[1]){
						SetGauge(0);
						StageChangingCheck();
					}
				}
				
				if(IsOrgasmFunctionEnabled() == false &&
					lastTouchingTime + LongestDurationTime() < currentTime && GetGauge() < stageThresholdInGame[1]){
					SetGauge(0);
					StageChangingCheck();
				}
#endif				
			}catch (Exception e){
				LoggerE(e);
			}
		}

		public void OnNameChanged(){
			StartCoroutine(OnNameChangedCoroutine());
		}
		
		public IEnumerator OnNameChangedCoroutine(){
			myNameOld = myName;
			myName = atom.uid;
			SetupMemoryAtom();
			
			
			for(int i = 0; i < 2000; i++){
				Atom tmpatom = SuperController.singleton.GetAtomByUid(memoryAtomName + " " + myName);
				if(tmpatom != null){ break; }
				yield return new WaitForSeconds(0.1f);
			}
			isNameChanged = true;
			DoAddonManager2Function("GetCUAs");
			
			yield return new WaitForSeconds(0.1f);
			
			DoAddonManager2Function("RemoveCUAs");
			ResetMemoryAtom();
//			CopyMemoryFromOldToNew(myNameOld, myName);
			guess.RemoveTrunks();
			
			yield return new WaitForSeconds(0.1f);
			
			DoAddonManager2Function("RecallCUAs");
			RemoveCUA(memoryAtomName);
			guess.CreateTrunks();
			
			yield return new WaitForSeconds(0.1f);
			
			DoAddonManager2Function("LabelSwitch");
			
			yield return null;
			
			cuas = null;
			myNameOld = myName;
			myName = atom.uid;
			isNameChanged = false;
		}

		public void CopyMemoryFromOldToNew(string oldName, string newName){
			try{
				Atom oldAtom = SuperController.singleton.GetAtomByUid(memoryAtomName + " " + oldName);
				Atom newAtom = SuperController.singleton.GetAtomByUid(memoryAtomName + " " + newName);
				JSONClass jsc = oldAtom.GetJSON();
				newAtom.RestoreFromJSON(jsc);
				core.worldUi.worldUIBase.DefaultCanvasPosition(core.UIAtom.mainController.transform);
			}catch(Exception e){
				core.LoggerE(e);
			}
		}

		public void PerSecondCheck(){
			if(lastTime + perSecondOffset < currentTime){
				lastTime = currentTime;
				PerSecondCheckImpl();
			}
		}
		
		public void PerSecondCheckFreq(){
			if(lastTimeFreq + perSecondOffsetFreq < currentTime){
				lastTimeFreq = currentTime;
				PerSecondCheckImplFreq();
			}
		}
		
		public void PerSecondCheckImpl(){
			RefreshEBATVisual();
			parentAngleChecker.Recovery();
			worldUi.WorldUIControlIfNeeded();
			MemorizeUIPosition();
			bodyPartLocator.CheckSphereCollidersSkew();
			if(addon2ModeOn && GetStage() == 5){
				DoAddonManager2Function("SpeedRandomizer");
			}
		}
		
		public void PerSecondCheckImplFreq(){
			worldUi.WorldUIControlIfNeeded();
			if(SuperController.singleton.isLoading){
				if(!nowLoading){
					nowLoading = true;
					OnLoadingStart();
				}
			}else{
				if(nowLoading){
					nowLoading = false;
					OnLoadingEnd();
				}
			}
		}
		
		public void OnLoadingStart(){
			// Utility.Debug($"load start");
			
		}

		public void OnLoadingEnd(){
			// Utility.Debug($"load end");
			
		}

		public void MemorizeUIPosition(){
			if(UIAtom != null && UIAtom.mainController != null){
				string[] keys = {"x", "y", "z"};
				foreach(var key in keys){
					var name = "UI Position." + key;
					var value = 0f;
					if(key == "x") value = UIAtom.mainController.transform.position.x;
					if(key == "y") value = UIAtom.mainController.transform.position.y;
					if(key == "z") value = UIAtom.mainController.transform.position.z;
					if(HasMemoryFloat(name)){
						SetMemoryFloat(name, value);
					}else{
						SetMemoryFloat(name, value);
						ChangeDefaultValueFloat(name, 0f);
					}
				}
				
				string[] keys2 = {"x", "y", "z", "w"};
				foreach(var key in keys2){
					var name = "UI Rotation." + key;
					var value = 0f;
					if(key == "x") value = UIAtom.mainController.transform.rotation.x;
					if(key == "y") value = UIAtom.mainController.transform.rotation.y;
					if(key == "z") value = UIAtom.mainController.transform.rotation.z;
					if(key == "w") value = UIAtom.mainController.transform.rotation.w;
					if(HasMemoryFloat(name)){
						SetMemoryFloat(name, value);
					}else{
						SetMemoryFloat(name, value);
						ChangeDefaultValueFloat(name, 0f);
					}
				}
				
			}
		}
		
		public float LongestDurationTime(){
			float eTime = expression2.fmm.peakTimeOffset + expression2.fmm.finishTimeOffset;
			float bTime = blushing.BlushClosingTimeOffset;
			float tTime = tears.TearsClosingTimeOffset;
			float tmpTime = (eTime > bTime) ? eTime : bTime;
			float result = (tmpTime > tTime) ? tmpTime : tTime;
			return result;
		}
		
		public void SetStage(int stage){
			SetGauge(stageThresholdInGame[stage]);
		}
		
		public int GetStage(){
			try{
				int currentGauge = (int)customUi.jsGauge.val;
				for (int stage = 0; stage <= 5; stage++)
				{
					if (stage == 5) { return stage; }
					if (currentGauge < stageThresholdInGame[stage + 1]) { return stage; }
				}
				return 0;
			}catch (Exception e){
				LoggerE(e);
				return -1;
			}
		}


		public void Logger(string str)
		{
			Utility.Logger(str);
			// if(!disableLog){
			// 	SuperController.LogMessage(str);
			// }
		}
		
		public void LoggerE(Exception e){
			Utility.LoggerE(e);
			// var kex = e as KeyNotFoundException;
			// if(kex != null){
			// 	SuperController.LogMessage("+++ KeyNotFoundException:" + e);
			// }else{
			// 	SuperController.LogMessage("*** Exception:" + e);
			// }
		}

		public void Debug(string str)
		{
			Utility.Debug(str);
		}

		public void Info(string str)
		{
			Utility.Info(str);
		}

		public virtual IEnumerator CreateAtom(string atomType, string prefix, Action<Atom> onAtomCreated, bool keep=false)
        {
            //  need to wait a bit before creating if we are just loading into the scene, as the previous atom may have not been fully destroyed!!
//            yield return new WaitForSeconds(1.0f);
            yield return new WaitForSeconds(0.1f);

            string atomId = GenerateAtomName(prefix, atom.uid);
            Atom tmpatom = SuperController.singleton.GetAtomByUid(atomId);
            if (tmpatom == null)
            {
                yield return SuperController.singleton.AddAtomByType(atomType, atomId);
                tmpatom = SuperController.singleton.GetAtomByUid(atomId);
            }

            if (tmpatom != null)
            {
                if (keep == false)
                {
                    generatedAtoms.Add(tmpatom);
					generatedAtomNames.Add(prefix);
					generatedAtomsDictionary.Add(atomId, tmpatom);
                }
                onAtomCreated(tmpatom);
            }
        }
		
		public string GenerateAtomName(string prefix, string suffix)
        {
            return prefix + " " + suffix;
        }

		public string GetAtomId(string cuaName){
			if(isNameChanged){
				return GenerateAtomName(cuaName, myNameOld);	
			}else{
				return GenerateAtomName(cuaName, myName);			
			}
		}

		public Atom GetCUAAtom(string cuaName, bool useDictionary = true){
			string atomId = GetAtomId(cuaName);
			if(useDictionary){
				if(generatedAtomsDictionary.ContainsKey(atomId)){
					return generatedAtomsDictionary[atomId];
				}
			}else{
				return Utility.GetCustomUnityAssetByName(cuaName);
			}
			return null;
		}		

		public void RemoveCUA(string cuaName){
			Atom cuaAtom = GetCUAAtom(cuaName);
			string atomId = GetAtomId(cuaName);
			if(cuaAtom != null){
				SuperController.singleton.RemoveAtom(cuaAtom);
				generatedAtomsDictionary.Remove(atomId);
			}else{
				Logger("Can't RemoveCUA: cuaName: " + cuaName + " is null");
			}
			
			Atom cua = SuperController.singleton.GetAtomByUid(atomId);
			if(cua != null){
				SuperController.singleton.RemoveAtom(cua);
			}
		}
		
		public bool CheckLabiaTriggerNormal(){
			if(gender == "Male"){ return false; };
			
			if(labiaCollider == null){
				SphereCollider[] cols = atom.GetComponentsInChildren<SphereCollider>();
				foreach(var col in cols){
					if(col.name == "LabiaTrigger"){
						labiaCollider = col;
					}
				}
			}
			
			bool result = true;
			if(labiaCollider.radius >= 0.06f){
				result = false;
			}
			return result;
		}
		
		public void ToggleDoublingColliderSize(){
			Dictionary<string, float> collisionSize = new Dictionary<string, float>(){
				{"LabiaTrigger", 0.030f},
				{"VaginaTrigger", 0.040f},
				{"DeepVaginaTrigger", 0.035f},
				{"DeeperVaginaTrigger", 0.035f},
			};
			SphereCollider[] cols = atom.GetComponentsInChildren<SphereCollider>();
			foreach(var col in cols){
				if(col.name.StartsWith("Labia") || col.name.StartsWith("Vagina") || col.name.StartsWith("Deep")){
					if(collider2xOnGlobal){
						col.radius = collisionSize[col.name] * 2;
					}else{
						col.radius = collisionSize[col.name];						
					}
				}
			}			
		}
		
		public virtual IEnumerator CreateGameObject(string name, PrimitiveType type, Action<GameObject> onGameObjectCreated){
			GameObject tmpObj = GetGameObject(name);
			if(tmpObj != null){
				RemoveGameObject(name);
			}
			yield return new WaitForSeconds(0.1f);
			
			tmpObj = GameObject.CreatePrimitive(type);
			if(tmpObj != null){
				RegisterGameObject(name, tmpObj);
				onGameObjectCreated(tmpObj);
			}else{
				Info("UnknownError: can't create gameObject:" + name);
			}
			yield return null;
		}

		public GameObject GetGameObject(string name){
			if(generatedGameObjectsDictionary.ContainsKey(name)){
				return generatedGameObjectsDictionary[name];
			}
			return null;
		}
		
		public void RemoveGameObject(string name, bool keepName = false){
			try{
				if(generatedGameObjectsDictionary.ContainsKey(name)){
					GameObject obj = generatedGameObjectsDictionary[name];
					generatedGameObjects.Remove(obj);
					Destroy(obj);
					generatedGameObjectsDictionary.Remove(name);
					if(keepName == false){
						generatedGameObjectNames.Remove(name);
					}
				}
			}catch(Exception e){
				LoggerE(e);
			}
		}
		
		public void RegisterGameObject(string name, GameObject tmpObj){
			try{
				if(generatedGameObjectsDictionary.ContainsKey(name)){
					RemoveGameObject(name);
				}
				generatedGameObjects.Add(tmpObj);
				generatedGameObjectNames.Add(name);
				generatedGameObjectsDictionary.Add(name, tmpObj);
			}catch(Exception e){
				Info("UnknownError: name:" + name + " exists.");
				Info("Irregular GameObject:" + generatedGameObjectsDictionary[name]);
				LoggerE(e);
			}
		}

		public void RemoveGameObjectAll(){
			try{
				foreach(var name in generatedGameObjectNames){
					RemoveGameObject(name, true);
				}
				generatedGameObjectNames.Clear();
			}catch(Exception e){
				LoggerE(e);
			}
		}
		
		public void RemoveGameObjectByName(string prefix){
			try{
				List<string> tmpList = new List<string>();
				foreach(var name in generatedGameObjectNames){
					if(name.StartsWith(prefix)){
						RemoveGameObject(name, true);
						tmpList.Add(name);
					}
				}
				foreach(var name in tmpList){
					generatedGameObjectNames.Remove(name);
				}
				tmpList.Clear();
//				generatedGameObjectNames.Clear();
			}catch(Exception e){
				LoggerE(e);
			}
		}
		
		public void DoSequencialAction(List<Action> acts, List<float> intervals){
			StartCoroutine(DoSequencialActionCoroutine(acts, intervals));
		}
		
		public IEnumerator DoSequencialActionCoroutine(List<Action> acts, List<float> intervals){
			for(int i = 0; i < acts.Count; i++){
				acts[i]();
				yield return new WaitForSeconds(intervals[i]);
			}
		}
		
		public IEnumerator DoDelayedActionCoroutine(Action act, float delay){
			yield return new WaitForSeconds(delay);
			act();
		}
		
		public void DoDelayedAction(Action act, float delay = 1.0f){
			StartCoroutine(DoDelayedActionCoroutine(act, delay));
		}
		
		public void DoDoubleAction(Action act, float interval = 0.1f){
			List<Action> acts = new List<Action>(){
				act, act,
			};
			List<float>  intervals = new List<float>(){
				interval, interval,
			};
			DoSequencialAction(acts, intervals);
		}
		
		public void OnDestroy(){
			belly.OnDestroy();
			headController.OnDestroy();
			collisionFailureDetector.OnDestroy();
			RemoveGameObjectAll();
			FinishSequence();
			worldUi.OnDestroy();
			
			expression2.OnDestroy();
			tears.OnDestroy();
			blushing.OnDestroy();
			bodyMorph.OnDestroy();
			sound.OnDestroy();
			addonTakeControl.OnDestroy();
			manController.OnDestroy();
			
			DoAddonManager1Function("OnDestroy");
			DoAddonManager2Function("OnDestroy");
			customUi.OnDestroy();

            generatedAtoms.ForEach((atom) =>
            {
				if (atom == null) { return; }
				if (!atom.name.Contains(memoryAtomName)) {
	                SuperController.singleton.RemoveAtom(atom);
				}
            });
            generatedAtoms.Clear();
			
            generatedGameObjects.ForEach((gobj) =>
            {
				if (gobj == null) { return; }
				Destroy(gobj);
            });
            generatedGameObjects.Clear();
			
			generatedAtomNames.Clear();
			generatedAtomsDictionary.Clear();
			generatedGameObjectNames.Clear();
			generatedGameObjectsDictionary.Clear();
			stageMap.Clear();
		}
		
		public void OnCalmDown(){
			HitCountMap.Keys.ToList<string>().ForEach((zone) => HitCountMap[zone] = 0);
		}
		
		public void OnOrgasmStart()
		{
			addonTakeControl.OnOrgasmStart();
			manController.OnOrgasmStart();
			
			worldUi.OnOrgasmStart();
			addonManager1.OnOrgasmStart();
			DoAddonManager2Function("OnOrgasmStart");
		}
		
		public void OnOrgasmStop()
		{
			addonTakeControl.OnOrgasmStop();
			manController.OnOrgasmStop();
			
			worldUi.OnOrgasmStop();
			addonManager1.OnOrgasmStop();
			DoAddonManager2Function("OnOrgasmStop");
		}
		
		public void FinishSequence(){
			expression2.StopExpression();
			tears.UnequipTearsAll();
//			blushing.RemoveBlushing();
			bodyMorph.StopBodyMorph();			
		}

		public void CleaningUnnecessaryAtoms(){
			foreach(var atom in SuperController.singleton.GetAtoms()){
				string atomName = atom.uid;
				if(atomName.StartsWith("EBAT_UI_")){
					if(atom != UIAtom){
						SuperController.singleton.RemoveAtom(atom);
					}
				}else if(atomName.StartsWith("EBAT_Pee_")){
					if(atom != peeAtom){
						SuperController.singleton.RemoveAtom(atom);
					}
				}
			}			
		}

		public void SubscribeAllTrigger(){
			string[] triggerNames = {
				"LabiaTrigger", "VaginaTrigger", "DeepVaginaTrigger", "DeeperVaginaTrigger",
			};
			foreach(var name in triggerNames){
				collisionFailureDetector.Subscribe(name);
			}
		}

		public void UnsubscribeAllTrigger(){
			string[] triggerNames = {
				"LabiaTrigger", "VaginaTrigger", "DeepVaginaTrigger", "DeeperVaginaTrigger",
			};
			foreach(var name in triggerNames){
				collisionFailureDetector.Unsubscribe(name);
			}			
		}

		public string GetStageLevel(){
			string stageName = Utility.ResolveStageName(GetStage(), (int)customUi.jsOrgasmCount.val);
			return levelMap[stageName];
		}
		
		public string GetStageHeat(){
			string stageName = Utility.ResolveStageName(GetStage(), (int)customUi.jsOrgasmCount.val);
			if(stageMap == null || !stageMap.ContainsKey(stageName)) InitializeStageHeat();
			return stageMap[stageName];
		}

		public void InitializeStageHeat()
		{
			stageMap = new Dictionary<string, string>(){
				{"Stage<3:OrgasmCount<99", "cool"},
				{"Stage<5:OrgasmCount<99", "cool"},
				{"Stage=5:OrgasmCount<01", "hot"},
				{"Stage=5:OrgasmCount<03", "hot"},
				{"Stage=5:OrgasmCount<06", "veryHot"},
				{"Stage=5:OrgasmCount<09", "veryHot"},
				{"Stage=5:OrgasmCount<99", "nymphomania"},
			};

			levelMap = new Dictionary<string, string>(){
				{"Stage<3:OrgasmCount<99", "Lv1"},
				{"Stage<5:OrgasmCount<99", "Lv2"},
				{"Stage=5:OrgasmCount<01", "Lv3"},
				{"Stage=5:OrgasmCount<03", "Lv4"},
				{"Stage=5:OrgasmCount<06", "Lv5"},
				{"Stage=5:OrgasmCount<09", "Lv6"},
				{"Stage=5:OrgasmCount<99", "Lv7"},
			};
		}

		public void SetupMemoryAtom(){
			if(GetCUAAtom(memoryAtomName, false) != null){
				commonMemory = GetCUAAtom(memoryAtomName, false);
			}else{
				StartCoroutine(MakeMemoryAtomCoroutine(memoryAtomName));
			}
		}
		
		public IEnumerator MakeMemoryAtomCoroutine(string name){
			core.customUnityAssetItem.SummonAtomOnly(name, "head");
			for(int i = 0; i < 2000; i++){
				if(commonMemory != null){ break; }
				commonMemory = GetCUAAtom(name);
				yield return new WaitForSeconds(0.1f);
			}
			if(commonMemory == null){
				Logger("EBAT MakeMemoryAtomCoroutine ERROR: can't create commonMemoryAtom.");
				yield break;
			}
			
			if(Utility.HasThisPlugin(atom, "ExpressionBlushingAndTears/PAUSED")){
				core.SetMemoryBool("isPaused", true);
			}
			yield return null;
		}
		
		public void ResetMemoryAtom(){
			StartCoroutine(ResetMemoryAtomCoroutine());
		}
		
		public IEnumerator ResetMemoryAtomCoroutine(){
			commonMemory = null;
			RemoveCUA(memoryAtomName);
			for(int i = 0; i < 2000; i++){
				if(GetCUAAtom(memoryAtomName, false) == null){ break; }
				yield return new WaitForSeconds(0.1f);
			}
			
			StartCoroutine(MakeMemoryAtomCoroutine(memoryAtomName));
			
			for(int i = 0; i < 2000; i++){
				if(commonMemory != null){ break; }
				commonMemory = GetCUAAtom(name);
				yield return new WaitForSeconds(0.1f);
			}
			core.worldUi.InitMemory();
			yield return new WaitForSeconds(0.1f);
			
			core.worldUi.RemoveMenuBody();
			core.worldUi.worldUIBase.DefaultCanvasPosition(core.UIAtom.mainController.transform);
			core.worldUi.MakeMenuBody();
			yield return null;
		}
		
		public bool NeedReadFromLoadJson(){
			return (hasCommonMemory && IsLoadedBeforeStartup && !InitDone);
		}
		
		public void ChangeDefaultValueBool(string param, bool value){
			if(commonMemory == null){
				core.Logger("EBAT ChangeDefaultValueBool: ERROR: can't find commonMemory.");
				return;
			}
			
			Utility.ChangeDefaultValueBool(commonMemory, param, value, false);
		}
		
		public bool GetMemoryBool(string param){
			if(commonMemory == null){
				core.Logger("EBAT GetMemoryBool: ERROR: can't find commonMemory.");
				return false;
			}
			
			return Utility.GetMemoryBool(commonMemory, param, NeedReadFromLoadJson(), false);
		}
		
		
		public bool HasMemoryBool(string param){
			if(commonMemory == null){
				core.Logger("EBAT HasMemoryBool: ERROR: can't find commonMemory.");
				return false;
			}
			
			return Utility.HasMemoryBool(commonMemory, param, NeedReadFromLoadJson(), false);
		}
		
		public void SetMemoryBoolIfNull(string param, bool value){
			if(commonMemory == null){
				core.Logger("EBAT SetMemoryBoolIfNull: ERROR: can't find commonMemory.(param = " + param + ")");
				return;
			}
			
			Utility.SetMemoryBoolIfNull(commonMemory, param, NeedReadFromLoadJson(), value, false);
		}
		
		public void SetMemoryBool(string param, bool value){
			if(commonMemory == null){
				core.Logger("EBAT SetMemoryBool: ERROR: can't find commonMemory.(param = " + param + ")");
				return;
			}
			
			Utility.SetMemoryBool(commonMemory, param, NeedReadFromLoadJson(), value, false);
		}
		
		
		public void ChangeDefaultValueFloat(string param, float value){
			if(commonMemory == null){
				core.Logger("EBAT ChangeDefaultValueFloat: ERROR: can't find commonMemory.");
				return;
			}
			
			Utility.ChangeDefaultValueFloat(commonMemory, param, value, false);
		}
		
		public float GetMemoryFloat(string param){
			if(commonMemory == null){
				core.Logger("EBAT GetMemoryFloat: ERROR: can't find commonMemory.");
				return -1.0f;
			}
			
			return Utility.GetMemoryFloat(commonMemory, param, NeedReadFromLoadJson(), false);
		}
		
		public bool HasMemoryFloat(string param){
			if(commonMemory == null){
				core.Logger("EBAT HasMemoryFloat: ERROR: can't find commonMemory.");
				return false;
			}
			
			return Utility.HasMemoryFloat(commonMemory, param, NeedReadFromLoadJson(), false);
		}
		
		public void SetMemoryFloatIfNull(string param, float value){
			if(commonMemory == null){
				core.Logger("EBAT SetMemoryFloatIfNull: ERROR: can't find commonMemory.");
				return;
			}
			
			Utility.SetMemoryFloatIfNull(commonMemory, param, NeedReadFromLoadJson(), value, false);
		}
		
		public void SetMemoryFloat(string param, float value){
			if(commonMemory == null){
				core.Logger("EBAT SetMemoryFloatIfNull: ERROR: can't find commonMemory.");
				return;
			}
			
			Utility.SetMemoryFloat(commonMemory, param, NeedReadFromLoadJson(), value, false);
		}
		
		public void DeleteMemoryFloat(string param){
			if(commonMemory == null){
				core.Logger("EBAT SetMemoryFloatIfNull: ERROR: can't find commonMemory.");
				return;
			}
			
			Utility.DeleteMemoryFloat(commonMemory, param, false);
		}


		public void ChangeDefaultValueString(string param, string value){
			if(commonMemory == null){
				core.Logger("EBAT ChangeDefaultValueString: ERROR: can't find commonMemory.");
				return;
			}
			
			Utility.ChangeDefaultValueString(commonMemory, param, value, false);
		}
		
		public Atom GetCommonMemory(){
			var cm = GetCUAAtom(memoryAtomName, false);
			return cm;
		}

		public string GetMemoryString(string param){
			if(commonMemory == null){
				core.Logger("EBAT GetMemoryString: ERROR: can't find commonMemory.");
				return "";
			}
			
			return Utility.GetMemoryString(commonMemory, param, NeedReadFromLoadJson(), false);
		}
		
		
		public bool HasMemoryString(string param){
			if(commonMemory == null){
				core.Logger("EBAT HasMemoryString: ERROR: can't find commonMemory.");
				return false;
			}
			
			return Utility.HasMemoryString(commonMemory, param, NeedReadFromLoadJson(), false);
		}
		
		public void SetMemoryStringIfNull(string param, string value){
			if(commonMemory == null){
				core.Logger("EBAT SetMemoryStringIfNull: ERROR: can't find commonMemory.(param = " + param + ")");
				return;
			}
			

			Utility.SetMemoryStringIfNull(commonMemory, param, NeedReadFromLoadJson(), value, false);
		}
		
		public void SetMemoryString(string param, string value){
			if(commonMemory == null){
				core.Logger("EBAT SetMemoryString: ERROR: can't find commonMemory.(param = " + param + ")");
				return;
			}
			
			Utility.SetMemoryString(commonMemory, param, NeedReadFromLoadJson(), value, false);
		}


		public void FistHand(float strength){
			// Utility.Debug($"FistHand: fistLockL:{fistLockL}, fistLockR:{fistLockR}");
			if(!fistLockL) Utility.FistHand(core.atom, strength, "left");
			if(!fistLockR) Utility.FistHand(core.atom, strength, "right");
		}

		public void FistHandForce(float strength, string type){
			Utility.FistHand(core.atom, strength, type);
		}



		public void FistLock(string type, bool isOn){
			if(type == "left")  fistLockL = isOn;
			if(type == "right") fistLockR = isOn;
		}

		public void SurveyStorables(int lvl){
			List<string> ids = atom.GetStorableIDs();
			for(int i = 0; i < ids.Count; i++){
				JSONStorable js = atom.GetStorableByID(ids[i]);
				Info("id: " + ids[i] + ", storeId:" + js.storeId);
				List<string> names;
				
				if(lvl > 0){
					names = atom.GetStorableByID(ids[i]).GetBoolParamNames();
					for(int j = 0; j < names.Count; j++){
						SuperController.LogMessage("  bool: " + names[j]);
					}
				}
					
				if(lvl > 1){
					names = atom.GetStorableByID(ids[i]).GetAllParamAndActionNames();
					for(int j = 0; j < names.Count; j++){
						SuperController.LogMessage("  ParamAndAction: " + names[j]);
					}					
				}

				if(lvl > 1){
					names = atom.GetStorableByID(ids[i]).GetAllFloatAndColorParamNames();
					for(int j = 0; j < names.Count; j++){
						SuperController.LogMessage("  FloatAndColorParam: " + names[j]);
					}
				}
			}
		}



	}
	
}

