#region using
using System;
using UnityEngine;
using System.Collections;
using System.Collections.Generic;
using SimpleJSON;
using System.Linq;
using System.Threading;
using System.Text.RegularExpressions;
#endregion

namespace Cotyounoyume{
    public class SessionPluginForEBAT : MVRScript
    {
		#region common or UI Properties
		private float lastCheckTime = 0.0f;
		private float currentTime = 0.0f;
		private float checkIntervalTime = 3.0f;
		
		private string pattern = "ExpressionBlushingAndTears";
		private string url = "Custom/Scripts/cotyounoyume/ExpressionBlushingAndTears/PAUSED_ADD_ME.cslist";
		private bool isError = false;
		#endregion
		
		public SessionPluginForEBAT(){
		}
				
		public bool checkInterval(){
			currentTime = Time.time;
			if(currentTime > lastCheckTime + checkIntervalTime){
				lastCheckTime = currentTime;
				return true;
			}else{
				return false;
			}
		}
		
		public override void Init(){
			try{
                if (containingAtom.type == "Person")
                {
                    SuperController.LogError("***\n***\nThis plug-in have to be added to Session\n(You do not need to add this to the Person.)\n***\n***\n");
					isError = true;
                    return;
                }
			}catch (Exception e){
				Utility.LoggerE(e);
			}
		}
		
		public void Start(){
			try{
				if(isError){return;}
				url = Utility.GetEBATFilePath();
			}catch (Exception e){
				Utility.LoggerE(e);
			}
		}
		
		protected void Update(){
			if(isError){return;}
			try{
				if(SuperController.singleton.isLoading || SuperController.singleton.freezeAnimation){
					return;
				}
				if(!checkInterval()){
					return;
				}
				
				Atom atom = collectOneFemaleAtom();
				if(atom == null){ return; }
				
				if(Utility.ContainsThisPlugin(atom, pattern)){
					return;
				}else{
					Utility.AppendAndReloadPlugins(atom, url ,99);
				}
				
			}catch (Exception e){
				Utility.LoggerE(e);
			}
		}
		
		
		
		public Atom collectOneFemaleAtom(){
			int femaleCount = 0;
			Atom lastAtom = null;
            foreach (var atom in SuperController.singleton.GetAtoms())
            {
				if(atom.type == "Person" && Utility.IsFemale(atom)){
					lastAtom = atom;
					femaleCount++;
				}
            }
			
			return (femaleCount == 1) ? lastAtom : null;
		}
		
		public void FixedUpdate(){
		}

		public void OnDestroy(){
		}
		
	}
}