#region using
using System;
using UnityEngine;
using System.Collections;
using System.Collections.Generic;
using SimpleJSON;
using System.Linq;
using System.Threading;
using System.Text.RegularExpressions;
using MVR.FileManagementSecure;
using UnityEngine.UI;
#endregion

//namespace MVR.FileManagementSecure{
namespace Cotyounoyume{
	public class CustomUI
	{
		public EBATCore core;
		public Atom atom;
		
		public Expression2 expression2;
		public Blushing blushing;
		public Tears tears;
		public EyesControl eyesControl;
		public Belly belly;
		public Etc etc;
		public BodyMorph bodyMorph;
		public CustomUnityAssetItem customUnityAssetItem;
		public WorldUI worldUi;
		public Sound sound;
		public HeadController headController;
		public AddonTakeControlItem addonTakeControlItem;
		
		public SimpleJSON.JSONClass settingsRoot;
		public SimpleJSON.JSONClass settings;
		public int[] stageThresholdInGame;
		public int[] stageThreshold;
		
		public DAZMorph morphCurrent = null;
		public DAZMorph morphOld = null;
		public string filterCategory = "";
		public string filterName = "";
		public string choiceShowtype = "MorphAndPose";
		public string choiceCategory = "Pose/Head/Expressions/Custom";
		public string choiceName = "CTY_Special_01";
		
		public int FONTSIZE_NORMAL = 28;
		public int FONTSIZE_SMALL = 24;
		public int LENGTH_THRESHOLD = 30;
		
		public Color colorYellow = new Color(255f/255f, 255f/255f, 180f/255f);
		public Color colorRed    = new Color(255f/255f, 180f/255f, 180f/255f);
		public Color colorGreen  = new Color(180f/255f, 255f/255f, 180f/255f);
		public Color colorBlue   = new Color(180f/255f, 180f/255f, 255f/255f);
//		public float spacerOffset = 10f;
		
		public Dictionary<string, UIDynamic>                 dUISpacer = new Dictionary<string, UIDynamic>();
		public Dictionary<string, UIDynamicButton>           dUIButton = new Dictionary<string, UIDynamicButton>();		
		public Dictionary<string, UIDynamicToggle>           dUIToggle = new Dictionary<string, UIDynamicToggle>();
		public Dictionary<string, JSONStorableBool>          dJSToggle = new Dictionary<string, JSONStorableBool>();
		public Dictionary<string, UIDynamicSlider>           dUISlider = new Dictionary<string, UIDynamicSlider>();
		public Dictionary<string, JSONStorableFloat>         dJSSlider = new Dictionary<string, JSONStorableFloat>();
		public Dictionary<string, UIDynamicTextField>        dUIString = new Dictionary<string, UIDynamicTextField>();
		public Dictionary<string, JSONStorableString>        dJSString = new Dictionary<string, JSONStorableString>();
		public Dictionary<string, UIDynamicPopup>            dUIPopup  = new Dictionary<string, UIDynamicPopup>();
		public Dictionary<string, JSONStorableStringChooser> dJSPopup  = new Dictionary<string, JSONStorableStringChooser>();
		public Dictionary<string, InputField>                dInput    = new Dictionary<string, InputField>();
		public Dictionary<string, JSONStorableColor>         dJSColor  = new Dictionary<string, JSONStorableColor>();
		public Dictionary<string, UIDynamicColorPicker>      dUIColor  = new Dictionary<string, UIDynamicColorPicker>();
		public Dictionary<string, bool>                      dOpenState = new Dictionary<string, bool>();

		public Dictionary<string, string> condMap;
		public Dictionary<string, string> condMap2;
		public Dictionary<string, string> keyMap;
		public Dictionary<string, int> stageMap;
		public Dictionary<string, string> ExpreLevelDisp;
		public Dictionary<string, string> ExpreLevelValue;
		
		public Dictionary<string, string> variableTypeMap;
		public Dictionary<string, string> variableInSaveMap;
		
		public List<string> mCategoryBoth  = new List<string>();
		public List<string> mCategoryPose  = new List<string>();
		public List<string> mCategoryMorph = new List<string>();
		public Dictionary<string, List<string>> mMorphBoth  = new Dictionary<string, List<string>>();
		public Dictionary<string, List<string>> mMorphPose  = new Dictionary<string, List<string>>();
		public Dictionary<string, List<string>> mMorphMorph = new Dictionary<string, List<string>>();
		
		protected Color colorDefault = new Color(0.8f, 0.8f, 0.8f);
		protected Color colorTextDefault = new Color(0.199f, 0.199f, 0.199f);
		
		public JSONStorableString  jsSoundTypePersonal;
		public Dictionary<string, JSONStorableString> jsShortcutDic;

		public JSONStorableBool  jsUIMinimized;
		public JSONStorableBool  jsLoaded;
		public JSONStorableBool  jsUISmall;
		public JSONStorableBool  jsUICompact;
		public JSONStorableBool  jsUIBarOnly;
		public JSONStorableBool  jsUICollapse;
		public JSONStorableFloat jsGauge;
		public JSONStorableFloat jsOrgasmCount;
		public JSONStorableBool jsHasMultipleOrgasms;
		
		public JSONStorableFloat jsCanvasPositionX;
		public JSONStorableFloat jsCanvasPositionY;
		public JSONStorableFloat jsCanvasPositionZ;
		public JSONStorableFloat jsCanvasRotationX;
		public JSONStorableFloat jsCanvasRotationY;
		public JSONStorableFloat jsCanvasRotationZ;
		public JSONStorableFloat jsCanvasRotationW;		
		
		public List<string> stageOptions = new List<string>(){
			"Always", 
			"Stage 1",
			"Stage 2",
			"Stage 3",
			"Stage 4",
			"Stage 5",
		};
		
		public string[] expandsNames = {
				"Toggles for Main Features",
				"Toggles for WorldUI Shortcut",
				"Toggles for Undress",
				"Sliders for Head Controller",
				"Head Controller(HC) Menu",
				"Expression Manager(EM)",
				"Toggles for Orgasm Features",
				"Sliders for Main Features", "Sliders for Stage Thresholds", "Sliders for Orgasm Features",
				"Sound Menu",
				"AutoStop(AS) Menu",
				"[AS]AutoStop On/Off Settings",
				"[AS]Plugin Switching",
				"[AS]Plugin Registration",
				"[HC]Angle", "[HC]Event Firing Ratio", "[HC]Ratio By Stage",
				"[EM]Registering Facial Expressions", "[EM]Register expressions to the level", "[EM]Event firing ratio", 
				"Toggles for Addon2 Settings",
		};
		
		int shortcutMax = 8;

		public CustomUI(EBATCore core){
			this.core = core;
			this.atom = core.atom;
		}
		
		public void SetAlias(){
			this.expression2 = core.expression2;
			this.blushing = core.blushing;
			this.tears = core.tears;
			this.eyesControl = core.eyesControl;
			this.belly = core.belly;
			this.etc = core.etc;
			this.bodyMorph = core.bodyMorph;
			this.customUnityAssetItem = core.customUnityAssetItem;
			this.worldUi = core.worldUi;
			this.sound = core.sound;
			this.settingsRoot = core.settingsRoot;
			this.settings = core.settings;
			this.stageThresholdInGame = core.stageThresholdInGame;
			this.stageThreshold = core.stageThreshold;
			this.headController = core.headController;
			this.addonTakeControlItem = core.addonTakeControl;
		}
		
		public void LoadSettings(){
			variableTypeMap = new Dictionary<string, string>();
			variableInSaveMap = Utility.GetParameterInSave(core.atom);
			SetJSONStorage();
			InitShortcut();
			InitMap();
			SetAlias();
		}

		public void InitShortcut(){
			jsShortcutDic = new Dictionary<string, JSONStorableString>();
			for(int i = 0; i < shortcutMax; i++){
				var key = GetShortcutKey(i);
				var value = "";
				SetShortcut(key, value);
				// jsShortcutDic.Add(key, new JSONStorableString(key, ""));
			}

			if(!core.settingsRoot["Common"].AsObject.HasKey("Shortcut")){
				MakeShortcut();
			}
			ReadShortcut();
		}

		public bool ExistShortcut(string key){
			if(core.HasMemoryString(key)){
				return true;
			}else if(core.settingsRoot["Common"].AsObject.HasKey("Shortcut")){
				return true;
			}else{
				return false;
			}
		}

		public string GetShortcutKey(int num){
			return "Shortcut" + (num < 10 ? "0" : "") + (num + 1);
		}

		public void SetShortcut(string key, string value){
			if(!jsShortcutDic.ContainsKey(key)){
				jsShortcutDic.Add(key, new JSONStorableString(key, value));
				core.SetMemoryStringIfNull(key, value);
			}else{
				jsShortcutDic[key].val = value;
				core.SetMemoryStringIfNull(key, value);
			}
		}

		public void ReadShortcut(){
			// Utility.Debug($"HasCommonMemory:{core.HasCommonMemory()}");
			for(int i = 0; i < shortcutMax; i++){
				var OddEven = (i % 2) != 0;
				var key = GetShortcutKey(i);

				if(ExistShortcut(key)){
					var value = GetShortcutValue(key);
					// Utility.Debug($"route1, key:{key}, value:{value}");
					SetShortcut(key, value);
					// jsShortcutDic[key].val = core.settingsRoot["Common"]["Shortcut"][key].ToString();
				}else{
					// Utility.Debug($"route2");
					ClearShortcut(key);
				}
			}
		}

		public string GetShortcutValue(string key){
			if(core.HasMemoryString(key)){
				return core.GetMemoryString(key);
			}else if(core.settingsRoot["Common"]["Shortcut"].AsObject.HasKey(key)){
				return core.settingsRoot["Common"]["Shortcut"][key];
			}else if(jsShortcutDic.ContainsKey(key)){
				return jsShortcutDic[key].val;
			}else{
				return "";
			}
		}

		public void MakeShortcut(){
			for(int i = 0; i < shortcutMax; i++){
				var OddEven = (i % 2) != 0;
				var key = GetShortcutKey(i);
				ClearShortcut(key);
			}
		}

		public void ClearShortcut(string key){
			if(jsShortcutDic == null) return;
			if(!jsShortcutDic.ContainsKey(key)) return;
			var value = "";
			SetShortcut(key, value);
		}
		
		public void InitMap(){
			ExpreLevelDisp = new Dictionary<string, string>(){
				{"Lv1", "Lv1)Stage < 3"},
				{"Lv2", "Lv2)Stage < 5"},
				{"Lv3", "Lv3)Stage = 5 & Orgasm Count = 0"},
				{"Lv4", "Lv4)Stage = 5 & Orgasm Count < 3"},
				{"Lv5", "Lv5)Stage = 5 & Orgasm Count < 6"},
				{"Lv6", "Lv6)Stage = 5 & Orgasm Count < 9"},
				{"Lv7", "Lv7)Stage = 5 & Orgasm Count < 99"},
			};
			
			ExpreLevelValue = new Dictionary<string, string>(){
				{"Lv1", "Stage<3:OrgasmCount<99"},
				{"Lv2", "Stage<5:OrgasmCount<99"},
				{"Lv3", "Stage=5:OrgasmCount<01"},
				{"Lv4", "Stage=5:OrgasmCount<03"},
				{"Lv5", "Stage=5:OrgasmCount<06"},
				{"Lv6", "Stage=5:OrgasmCount<09"},
				{"Lv7", "Stage=5:OrgasmCount<99"},
			};
			
			condMap = new Dictionary<string, string>(){
				{"Cond1)Stage < 3 & Orgasm Count < 99", "Stage<3:OrgasmCount<99"},
				{"Cond2)Stage < 5 & Orgasm Count < 99", "Stage<5:OrgasmCount<99"},
				{"Cond3)Stage = 5 & Orgasm Count < 01", "Stage=5:OrgasmCount<01"},
				{"Cond4)Stage = 5 & Orgasm Count < 03", "Stage=5:OrgasmCount<03"},
				{"Cond5)Stage = 5 & Orgasm Count < 06", "Stage=5:OrgasmCount<06"},
				{"Cond6)Stage = 5 & Orgasm Count < 09", "Stage=5:OrgasmCount<09"},
				{"Cond7)Stage = 5 & Orgasm Count < 99", "Stage=5:OrgasmCount<99"},
			};
			
			condMap2 = new Dictionary<string, string>(){
				{"HC_RatioByStage_1", "Stage<3:OrgasmCount<99"},
				{"HC_RatioByStage_2", "Stage<5:OrgasmCount<99"},
				{"HC_RatioByStage_3", "Stage=5:OrgasmCount<01"},
				{"HC_RatioByStage_4", "Stage=5:OrgasmCount<03"},
				{"HC_RatioByStage_5", "Stage=5:OrgasmCount<06"},
				{"HC_RatioByStage_6", "Stage=5:OrgasmCount<09"},
				{"HC_RatioByStage_7", "Stage=5:OrgasmCount<99"},
			};
			
			keyMap = new Dictionary<string, string>(){
				{"Test: 1) Considering the Event Firing Ratio", "Stage<3:OrgasmCount<99"},
				{"Test: 2) Considering the Event Firing Ratio", "Stage<5:OrgasmCount<99"},
				{"Test: 3) Considering the Event Firing Ratio", "Stage=5:OrgasmCount<01"},
				{"Test: 4) Considering the Event Firing Ratio", "Stage=5:OrgasmCount<03"},
				{"Test: 5) Considering the Event Firing Ratio", "Stage=5:OrgasmCount<06"},
				{"Test: 6) Considering the Event Firing Ratio", "Stage=5:OrgasmCount<09"},
				{"Test: 7) Considering the Event Firing Ratio", "Stage=5:OrgasmCount<99"},
				{"Test: 1) Ignoring the Event Firing Ratio", "Stage<3:OrgasmCount<99"},
				{"Test: 2) Ignoring the Event Firing Ratio", "Stage<5:OrgasmCount<99"},
				{"Test: 3) Ignoring the Event Firing Ratio", "Stage=5:OrgasmCount<01"},
				{"Test: 4) Ignoring the Event Firing Ratio", "Stage=5:OrgasmCount<03"},
				{"Test: 5) Ignoring the Event Firing Ratio", "Stage=5:OrgasmCount<06"},
				{"Test: 6) Ignoring the Event Firing Ratio", "Stage=5:OrgasmCount<09"},
				{"Test: 7) Ignoring the Event Firing Ratio", "Stage=5:OrgasmCount<99"},
			};
			
			stageMap = new Dictionary<string, int>(){
				{"Always", 0},
				{"Stage 1", 1},
				{"Stage 2", 2},
				{"Stage 3", 3},
				{"Stage 4", 4},
				{"Stage 5", 5},
			};
		}
		
		public void SetJSONStorage(){
			jsSoundTypePersonal = new JSONStorableString("Sound Type(Personal)", "default");

			core.RegisterString(jsSoundTypePersonal);
			// jsGauge             = new JSONStorableFloat("Gauge", 0f, 0f, 1000f);
			jsGauge             = new JSONStorableFloat("Gauge", 0f, 0f, 1600f*1.2f);
			jsOrgasmCount       = new JSONStorableFloat("OrgasmCount", 0f, 0f, 1000f);
			jsHasMultipleOrgasms = new JSONStorableBool("HasMultipleOrgasms", false);
			
			jsUIMinimized = new JSONStorableBool("isMinimized" , false);
			jsLoaded     = new JSONStorableBool("IsLoaded"  , false);
			jsUISmall    = new JSONStorableBool("isSmall"   , false);
			jsUICompact  = new JSONStorableBool("isCompact" , false);
			jsUIBarOnly  = new JSONStorableBool("isBarOnly" , false);
			jsUICollapse = new JSONStorableBool("isCollapse", false);
			RegisterType("IsLoaded", "bool");
			RegisterType("Gauge", "special");
			RegisterType("OrgasmCount", "special");
			RegisterType("HasMultipleOrgasms", "bool");
			
			RegisterType("isSmall", "bool");
			RegisterType("isMinimized", "bool");
			RegisterType("isCompact", "bool");
			RegisterType("isBarOnly", "bool");
			RegisterType("isCollapse", "bool");
			
			core.RegisterBool(jsUICompact);
			core.RegisterBool(jsUISmall);
			core.RegisterBool(jsUIMinimized);
			core.RegisterBool(jsUIBarOnly);
			core.RegisterBool(jsUICollapse);
			core.RegisterBool(jsLoaded);
			core.RegisterFloat(jsGauge);
			core.RegisterFloat(jsOrgasmCount);
		}		
		
		public void OverwriteVariableWithSavedata(){
			if(variableInSaveMap == null){
				return;
			}
			
			foreach(KeyValuePair<string, string> kvp in variableInSaveMap){
				if (!variableTypeMap.ContainsKey(kvp.Key)) { continue; }

				string key = kvp.Key;
				string type = variableTypeMap[key];
				string value = variableInSaveMap[key].ToString().Replace("\"", String.Empty);
				string rawValue = variableInSaveMap[key];

				if (type == "bool") {
					bool bValue = System.Convert.ToBoolean(value);
					if (dJSToggle.ContainsKey(key)) {
						dJSToggle[key].SetVal(bValue);
					}
				} else if (type == "float") {
					float fValue = (float)System.Convert.ToDouble(value);
					if (dJSSlider.ContainsKey(key)) {
						dJSSlider[key].SetVal(fValue);
					}
				} else if (type == "string") {
					string str = value;
					if (dJSString.ContainsKey(key)) {
						dJSString[key].SetVal(str);
					}
				}
				else if (type == "color")
				{
					if (key == "Blush Color")
					{
						if (dJSColor.ContainsKey(key))
						{
							blushing.CurrentColor = Utility.ConvertHSVtoRGB(Utility.ConvertJSNtoHSV(rawValue));
							blushing.SetBlushColor(blushing.CurrentColor);
							dJSColor[key].SetColor(Utility.ConvertHSVtoRGB(Utility.ConvertJSNtoHSV(rawValue)));
						}
					}
				}
				else if(type == "special"){
						
					if(key == "Gauge"){
						int iValue = (int)System.Convert.ToDouble(value);
						jsGauge.val = iValue;
					}else if(key == "OrgasmCount"){
						int iValue = (int)System.Convert.ToDouble(value);
						jsOrgasmCount.val = iValue;
					}
				}
			}
		}
		
		public void RegisterType(string name, string type){
			if(variableTypeMap.ContainsKey(name)){
				if(variableTypeMap[name] == type){
//					core.Info("ERROR: name:" + name + " exists. (Safe: same type)");
				}else{
					//core.Info("ERROR: name:" + name + " exists. (Unsafe: different type)");					
				}
			}else{
				variableTypeMap.Add(name, type);
			}
		}
		
		public void MakeVariableToggle(string name, bool initial){
			JSONStorableBool jsb = new JSONStorableBool(name, initial, (bool toggle) => {ToggleAny(name);});
			core.RegisterBool(jsb);
			if(dJSToggle.ContainsKey(name)) dJSToggle[name] = jsb;
			else dJSToggle.Add(name, jsb);
			
			RegisterType(name, "bool");
		}
		
		public void MakeVariablePopup(string name, List<string> options, string initial, string displayName = ""){
			displayName = (displayName == "") ? name : displayName;
			JSONStorableStringChooser jssc = new JSONStorableStringChooser(name, options, initial, displayName, (string choice) => {SelectAny(name, choice);});
			core.RegisterStringChooser(jssc);
			if(dJSPopup.ContainsKey(name)) dJSPopup[name] = jssc;
			else dJSPopup.Add(name, jssc);
			
			RegisterType(name, "popup");
		}
		
		public void MakeVariableString(string name, string text){
			JSONStorableString jss = new JSONStorableString(name, text);
			core.RegisterString(jss);
			if(dJSString.ContainsKey(name)) dJSString[name] = jss;
			else dJSString.Add(name, jss);			
		}
		
		public void MakeVariableSliderNoFunc(string displayName, float initial, float min, float max){
			JSONStorableFloat jsf = new JSONStorableFloat(displayName, initial, min, max);
			core.RegisterFloat(jsf);
			if(dJSSlider.ContainsKey(displayName)) dJSSlider[displayName] = jsf;
			else dJSSlider.Add(displayName, jsf);
			
			RegisterType(displayName, "float");
		}		
		
		public void MakeVariableSlider(string displayName, float initial, float min, float max, string name1, string name2, string name3, string name4){
			JSONStorableFloat jsf = new JSONStorableFloat(displayName, initial, (float value) => {
				SetValueToSettings(value.ToString(), name1, name2, name3, name4);
				if(displayName.StartsWith("Default Canvas")){
					worldUi.worldUIBase.ResetCanvasPosition();
				}
				if(displayName.EndsWith(":Frequency")){
					string[] pattern = {":"};
					string[] words = displayName.Split(pattern, StringSplitOptions.None);
					string lvl = words[0];
					core.expression2.dLvlVsRatioTable[lvl] = value;
					core.expression2.MakeSPRatioTable();
				}
			}, min, max);
			
			core.RegisterFloat(jsf);
			if(dJSSlider.ContainsKey(displayName)) dJSSlider[displayName] = jsf;
			else dJSSlider.Add(displayName, jsf);						
			RegisterType(displayName, "float");
		}

		public void MakeVariableColor(string displayName, Color color)
		{
			JSONStorableColor jsc = new JSONStorableColor(displayName, Utility.ConvertRGBtoHSV(blushing.CurrentColor), (h, s, v) => { PickColorAny(displayName); });
			core.RegisterColor(jsc);
			if (dJSColor.ContainsKey(displayName)) dJSColor[displayName] = jsc;
			else dJSColor.Add(displayName, jsc);
			RegisterType(displayName, "color");
		}


		public void SetValueToSettings(string value, string name1, string name2, string name3, string name4, string name5 = ""){
			if(name5 != ""){
				core.settingsRoot[name1][name2][name3][name4][name5] = value;	
			}else if(name4 != ""){
				core.settingsRoot[name1][name2][name3][name4] = value;	
			}else if(name3 != ""){
				core.settingsRoot[name1][name2][name3] = value;
			}else if(name2 != ""){
				core.settingsRoot[name1][name2] = value;					
			}else{
				core.Info("Unknown error in SetValueToSettings.");
			}
		}
		
		public void UnsetValueToSettings(string value, string name1, string name2, string name3, string name4, string name5 = ""){
			try{
				
			if(name5 != ""){
				core.settingsRoot[name1][name2][name3][name4][name5].Remove(value);	
			}else if(name4 != ""){
				core.settingsRoot[name1][name2][name3][name4].Remove(value);	
			}else if(name3 != ""){
				core.settingsRoot[name1][name2][name3].Remove(value);
			}else if(name2 != ""){
				core.settingsRoot[name1][name2].Remove(value);
			}else{
				core.Info("Unknown error in SetValueToSettings.");
			}
			
			}catch(Exception e){
				core.LoggerE(e);
			}

		}
		
		public void MakeVariableSlider(string displayName, float initial, float min, float max, string category, string name1, string name2){
			JSONStorableFloat jsf = new JSONStorableFloat(displayName, initial, (float value) => {
				if(displayName.StartsWith("Face ") || displayName.StartsWith("Glance") || displayName.StartsWith("Turn")){
					SetSliderValueAlt(displayName, value);
				}else if(displayName.StartsWith("Cond")){
					SetSliderValueAlt2(displayName, value);
				}else if(displayName.StartsWith("HC_RatioByStage_")){
					SetSliderValueAlt3(displayName, value);
				}else{
					SetSliderValue(displayName, value);					
				}
				settings[category][name1][name2] = value.ToString();
//				SaveConfig();
			}, min, max);
			
			core.RegisterFloat(jsf);
			if(dJSSlider.ContainsKey(displayName)) dJSSlider[displayName] = jsf;
			else dJSSlider.Add(displayName, jsf);						
			RegisterType(displayName, "float");
		}
		
		public void MakeVariableSlider(string displayName, float initial, float min, float max, string category, string name){
			JSONStorableFloat jsf = new JSONStorableFloat(displayName, initial, (float value) => {
				if(displayName.StartsWith("Face ") || displayName.StartsWith("Glance")){
					SetSliderValueAlt(displayName, value);					
				}else if(displayName.StartsWith("Cond")){
					SetSliderValueAlt2(displayName, value);
				}else{
					SetSliderValue(displayName, value);					
				}
				settings[category][displayName] = value.ToString();
//				SaveConfig();
			}, min, max);
			
			core.RegisterFloat(jsf);
			if(dJSSlider.ContainsKey(displayName)) dJSSlider[displayName] = jsf;
			else dJSSlider.Add(displayName, jsf);			
			RegisterType(displayName, "float");
		}
		
		public void SelectAny(string name, string choice){
			string normalizedChoice = "";
			if(name == "DefaultBlushType" || name == "Blush Type"){
				normalizedChoice = choice;
				blushing.BlushTypeDefault = normalizedChoice;				
				if(!blushing.BlushOn) blushing.UnequipBlush(); else blushing.ChangeBlushEquipment();
				
			}else if(name == "DefaultTearsType" || name == "Tears Type"){
				normalizedChoice = choice;
				tears.TearsTypeDefault = normalizedChoice;
				tears.SetTearsType(choice);
			}else if(name == "DefaultSoundType" || name == "Sound Type(Default)"){
				normalizedChoice = choice;
				sound.soundTypeDefault = normalizedChoice;
			}else if(name == "PersonalSoundType" || name == "Sound Type(Personal)"){
				normalizedChoice = choice;
				jsSoundTypePersonal.val = choice;
				sound.UpdateSound();
			}else if(name == "Show Type"){
				PopupSelectShwoType(choice);
			}else if(name == "Morph Category"){
				PopupSelectCategory(choice);
			}else if(name == "Morph Name"){
				choiceName = choice;
				MorphNameUpdate(choice);
			}else if(name.StartsWith("SPEXPOPU:")){
				PopupSelectEyesDirection(name, choice);
			}else if(name.StartsWith("Timing:")){
				normalizedChoice = stageMap[choice].ToString();
				core.addonTakeControl.AutoStopPlugins();
			}
			
			if(name == "PersonalSoundType" || name == "Sound Type(Personal)"){ // for no settings types
			}else if(name.StartsWith("Timing:")){
				string[] words = name.Split(':');
				settingsRoot["Common"]["PTMC Timing"][words[1]] = normalizedChoice.ToString();
			}else if(name.StartsWith("Shortcut")){
				if(core.settingsRoot["Common"]["Shortcut"].AsObject.HasKey(name) && jsShortcutDic.ContainsKey(name)){
					SetShortcut(name, choice);
					// settingsRoot["Common"]["Shortcut"][name] = choice;
					// jsShortcutDic[name].val = choice;
					worldUi.ReloadMenu();
				}
			}else{ // for settings types
				settings["General"][name] = normalizedChoice;
//				SaveConfig();
			}
		}
		
		public bool GetToggleValue(string name){
			bool result = false;
			if(name == "TearsOn" || name == "Tears On") 
				result = tears.TearsOn;
			else if(name == "DroolOn" || name == "Drool On")
				result =  tears.DroolOn;
			else if(name == "ExpressionOn" || name == "Expression On")
				result =  expression2.expressionOnGlobal;
			else if(name == "BlushOn" || name == "Blush On")				
				result =  blushing.BlushOn;
			else if(name == "EyesControlOn" || name == "Eyes Control On") 		
				result =  eyesControl.eyecontrolOnGlobal;
			else if(name == "EyesRollupOn" || name == "Eyes Rollup On")			
				result =  eyesControl.eyecontrolRollupOnGlobal;
			else if(name == "SoundOn" || name == "Sound On") 				
				result =  sound.soundOnGlobal;
			else if(name == "Use VAMMoan for Sound")
				result =  core.vammoanLinkOnGlobal;
			else if(name == "NippleErectionOn" || name == "Nipple Erection On") 	
				result =  bodyMorph.nippleErectionOnGlobal;
			else if(name == "ClitorisErectionOn" || name == "Clitoris Erection On")	
				result =  bodyMorph.clitorisErectionOnGlobal;
			else if(name == "Head Motion On")	
				result =  headController.headMotionOnGlobal;
			else if(name == "2x Collider Radius")
				result =  core.collider2xOnGlobal;
			else if(name == "PeeingOn" || name == "Peeing On")				
				result =  customUnityAssetItem.peeingOnGlobal;
			else if(name == "AutoExpressionsOff" || name == "Auto Expression Off") 	
				result =  etc.autoExpressionOffGlobal;
			else if(name == "AutoBlinkOff" || name == "Auto Blink Off")			
				result =  etc.autoBlinkOffGlobal;

			else if(name == "Armbinder By Hand") 
				result =  core.armBinderByHandOnGlobal;
			else if(name == "Armbinder By Beam")
				result =  core.armBinderByBeamOnGlobal;
			else if(name == "Legbinder By Hand")
				result =  core.legBinderByHandOnGlobal;
			else if(name == "Legbinder By Beam")
				result =  core.legBinderByBeamOnGlobal;
			else if(name == "Covering Actions All")
				result =  core.coveringOnGlobal;
			else if(name == "Cover with Hands")
				result =  core.coveringWithHandsOnGlobal;
			else if(name == "Close Legs")
				result =  core.coveringWithLegsOnGlobal;
			else if(name == "Cover Mouth")
				result =  core.coveringMouthOnGlobal;
			else if(name == "Select One Arm Each")
				result =  core.oneArmEachOnGlobal;
			else if(name == "CUA Collision")
				result =  core.collisionControlOnGlobal;
			else if(name == "CUA Speed Randomizer")
				result =  core.speedRandomizerOnGlobal;
			else if(name == "Collision Failure Check")
				result =  core.collisionFailureCheckOnGlobal;
			else if(name == "Collision Auto Fix")
				result =  core.collisionAutoFixOnGlobal;
			else if(name == "Shivering during climax(morph)")
				result =  core.bellyMorphOn;
			else if(name == "Shivering during climax(bone)")
				result =  core.bellyBoneOn;
			else if(name == "OnOff:AutoStop Other Plugins")
				result =  addonTakeControlItem.autoStopOnGlobal;
			else if(name == "OnOff:Stop Morph Control by non-plugins")
				result =  addonTakeControlItem.autoStopMorphOnGlobal;
			else if(name == "OnOff:Stop Head Control by non-plugins")
				result =  addonTakeControlItem.autoStopHeadOnGlobal;
			else if(name == "OnOff:Stop Body Control by non-plugins")
				result =  addonTakeControlItem.autoStopBodyOnGlobal;
			// else if(name == "Sensitive Trigger")
			// 	result =  core.sensitiveTriggerOnGlobal;
			else if(name == "Penis Support")
				result =  core.manController.penisSupportOnGlobal;
			else if(name == "HeadMotionOff During Possession")
				result =  core.headController.headMotionStopDuringPossessionOnGlobal;
			else if(name == "Forced Undress")
				result =  core.addonManager1.forcedUndressOnGlobal;			
			else if(name == "Reverse Gravity")
				result =  core.addonManager1.undressReverseOnGlobal;			
			else if(name == "Undress Detach")
				result =  core.addonManager1.undressDetachOnGlobal;			
			else if(name == "Undress CUAs Exclude Head")
				result =  core.addonManager1.addonCUAUndresser.excludeHeadOnGlobal;
			else if(name == "Alter SkinWrap to ClothSim")
				result =  core.addonManager1.wrapAlterToSimOnGlobal;			
			else if(name == "Hold Clothes containing NGWords")
				result = core.addonManager1.holdNGWordsOnGlobal ;				
			else if(name == "Hold Clothes with ClothSim"     )
				result = core.addonManager1.holdClothSimOnGlobal;				
			else if(name == "Hold Clothes with AlterSkinWrap")
				result = core.addonManager1.holdSkinWrapOnGlobal;				
			else if(name == "UIMenuOn" || name == "Display UI Menu")				
				result =  core.menuOnGlobal;
			else if(name == "DebugMessageOff" || name == "Debug Message Off")
				result =  core.disableLog;
			return result;
		}
		
		public void ToggleExternal(string name, bool isForce = false, bool value = false){
			bool current = GetToggleValue(name);
			if(!dJSToggle.ContainsKey(name)){
				core.Info("unknown name:" + name);
				return;
			}
			
			if(isForce){
				if(dJSToggle[name].val != value){
					dJSToggle[name].SetVal(value);
				}
			}else{
				// ToggleAny(name);
				dJSToggle[name].SetVal(!current);			
			}
		}
		
		public void ToggleAny(string name){
			if(name == "TearsOn" || name == "Tears On") 					
				ToggleAnyAlias(ref tears.TearsOn, name);
			else if(name == "DroolOn" || name == "Drool On")				
				ToggleAnyAlias(ref tears.DroolOn, name);
			else if(name == "ExpressionOn" || name == "Expression On")
				ToggleAnyAlias(ref expression2.expressionOnGlobal, name);
			else if(name == "BlushOn" || name == "Blush On")				
				ToggleAnyAlias(ref blushing.BlushOn, name);
			else if(name == "EyesControlOn" || name == "Eyes Control On") 		
				ToggleAnyAlias(ref eyesControl.eyecontrolOnGlobal, name);
			else if(name == "EyesRollupOn" || name == "Eyes Rollup On")			
				ToggleAnyAlias(ref eyesControl.eyecontrolRollupOnGlobal, name);
			else if(name == "SoundOn" || name == "Sound On") 				
				ToggleAnyAlias(ref sound.soundOnGlobal, name);
			else if(name == "Use VAMMoan for Sound")
				ToggleAnyAlias(ref core.vammoanLinkOnGlobal, name);				
			else if(name == "NippleErectionOn" || name == "Nipple Erection On") 	
				ToggleAnyAlias(ref bodyMorph.nippleErectionOnGlobal, name);
			else if(name == "ClitorisErectionOn" || name == "Clitoris Erection On")	
				ToggleAnyAlias(ref bodyMorph.clitorisErectionOnGlobal, name);
			else if(name == "Head Motion On")	
				ToggleAnyAlias(ref headController.headMotionOnGlobal, name);
			else if(name == "2x Collider Radius")
				ToggleAnyAlias(ref core.collider2xOnGlobal, name);
			else if(name == "PeeingOn" || name == "Peeing On")				
				ToggleAnyAlias(ref customUnityAssetItem.peeingOnGlobal, name);
			else if(name == "AutoExpressionsOff" || name == "Auto Expression Off") 	
				ToggleAnyAlias(ref etc.autoExpressionOffGlobal, name);
			else if(name == "AutoBlinkOff" || name == "Auto Blink Off")			
				ToggleAnyAlias(ref etc.autoBlinkOffGlobal, name);
			else if(name == "AutoStop OtherPlugins")
				ToggleAnyAlias(ref addonTakeControlItem.autoStopOnGlobal, name);
			// else if(name == "Sensitive Trigger")
			// 	ToggleAnyAlias(ref core.sensitiveTriggerOnGlobal, name);				
			else if(name == "Penis Support")
				ToggleAnyAlias(ref core.manController.penisSupportOnGlobal, name);				
			else if(name == "HeadMotionOff During Possession")
				ToggleAnyAlias(ref core.headController.headMotionStopDuringPossessionOnGlobal, name);				
			else if(name == "Forced Undress")
				ToggleAnyAlias(ref core.addonManager1.forcedUndressOnGlobal, name);				
			else if(name == "Reverse Gravity")
				ToggleAnyAlias(ref core.addonManager1.undressReverseOnGlobal, name);				
			else if(name == "Undress Detach")
				ToggleAnyAlias(ref core.addonManager1.undressDetachOnGlobal, name);				
			else if(name == "Undress CUAs Exclude Head")
				ToggleAnyAlias(ref core.addonManager1.addonCUAUndresser.excludeHeadOnGlobal, name);				
			else if(name == "Alter SkinWrap to ClothSim")
				ToggleAnyAlias(ref core.addonManager1.wrapAlterToSimOnGlobal, name);				
			else if(name == "Hold Clothes containing NGWords")
				ToggleAnyAlias(ref core.addonManager1.holdNGWordsOnGlobal , name);				
			else if(name == "Hold Clothes with ClothSim"     )
				ToggleAnyAlias(ref core.addonManager1.holdClothSimOnGlobal, name);				
			else if(name == "Hold Clothes with AlterSkinWrap")
				ToggleAnyAlias(ref core.addonManager1.holdSkinWrapOnGlobal, name);
			else if(name == "Armbinder By Hand")
				ToggleAnyAlias(ref core.armBinderByHandOnGlobal, name);
			else if(name == "Armbinder By Beam") 
				ToggleAnyAlias(ref core.armBinderByBeamOnGlobal, name);
			else if(name == "Legbinder By Hand") 
				ToggleAnyAlias(ref core.legBinderByHandOnGlobal, name);
			else if(name == "Legbinder By Beam")
				ToggleAnyAlias(ref core.legBinderByBeamOnGlobal, name);
			else if(name == "Covering Actions All")
				ToggleAnyAlias(ref core.coveringOnGlobal, name);
			else if(name == "Cover with Hands")
				ToggleAnyAlias(ref core.coveringWithHandsOnGlobal, name);
			else if(name == "Close Legs")
				ToggleAnyAlias(ref core.coveringWithLegsOnGlobal, name);
			else if(name == "Cover Mouth")
				ToggleAnyAlias(ref core.coveringMouthOnGlobal, name);
			else if(name == "Select One Arm Each")
				ToggleAnyAlias(ref core.oneArmEachOnGlobal, name);
			else if(name == "CUA Collision")
				ToggleAnyAlias(ref core.collisionControlOnGlobal, name);
			else if(name == "CUA Speed Randomizer")
				ToggleAnyAlias(ref core.speedRandomizerOnGlobal, name);
			else if(name == "Collision Failure Check")
				ToggleAnyAlias(ref core.collisionFailureCheckOnGlobal, name);
			else if(name == "Collision Auto Fix")
				ToggleAnyAlias(ref core.collisionAutoFixOnGlobal, name);
			else if(name == "UIMenuOn" || name == "Display UI Menu")				
				ToggleAnyAlias(ref core.menuOnGlobal, name);
			else if(name == "DebugMessageOff" || name == "Debug Message Off")
				ToggleAnyAlias(ref core.disableLog, name);
			else if(name.StartsWith("OnOrNot:"))
				ToggleStatusOnly(name);
			else if(name == "OnOff:AutoStop Other Plugins")
				ToggleAnyAlias(ref core.addonTakeControl.autoStopOnGlobal, name);
			else if(name == "OnOff:Stop Morph Control by non-plugins")
				ToggleAnyAlias(ref core.addonTakeControl.autoStopMorphOnGlobal, name);
			else if(name == "OnOff:Stop Head Control by non-plugins")
				ToggleAnyAlias(ref core.addonTakeControl.autoStopHeadOnGlobal, name);
			else if(name == "OnOff:Stop Body Control by non-plugins")
				ToggleAnyAlias(ref core.addonTakeControl.autoStopBodyOnGlobal, name);
			else if(name.StartsWith("ListOrNot:"))
				ToggleStatusForAutoStopEditingMenu(name);			
			else if(name.StartsWith("SPEXTOGL:"))
				ToggleStatusForSpecialExpression(name);			
			else if(name == "Shivering during climax(morph)")
				ToggleAnyAlias(ref core.bellyMorphOn, name);
			else if(name == "Shivering during climax(bone)")
				ToggleAnyAlias(ref core.bellyBoneOn, name);
			else if(name.StartsWith("BodyMorph:"))
				ToggleStatusForOtherBodyMorph(name);			
		}

		public void ToggleStatusForOtherBodyMorph(string name){
			string[] pattern = {":"};
			string[] words = name.Split(pattern, StringSplitOptions.None);
			string morphName = words[1];
			if(!dJSToggle.ContainsKey(name) || dJSToggle[name].toggle == null){
				return;
			}
			
			bool isOn = dJSToggle[name].toggle.isOn;
			core.settings["BodyMorphOnOff"][morphName] = isOn.ToString();
			core.bodyMorph.UpdateOtherMorphsStatus();
		}
		
		public void ToggleStatusForAutoStopEditingMenu(string name){
			string[] pattern = {":"};
			string[] words = name.Split(pattern, StringSplitOptions.None);
			string pluginName = words[1];
			bool isOn = dJSToggle[name].toggle.isOn;
			if(isOn){
				if(core.addonTakeControl.IsPluginListed(pluginName)){
					//nop
				}else{
					core.settingsRoot["Common"]["Plugins that might Confilict"].Add(pluginName);
					core.settingsRoot["Common"]["PTMC On/Off"][pluginName] = "true";
					core.settingsRoot["Common"]["PTMC Timing"][pluginName] = "5";
					core.addonTakeControl.MakePluginIDTable();
					string djsName = "OnOrNot:" + pluginName; 
					if(!dJSToggle.ContainsKey(djsName)){
						MakeVariableToggle("OnOrNot:" + pluginName, true);
					}
				}
				dUIToggle[name].backgroundColor = Color.white;
			}else{
				if(core.addonTakeControl.IsPluginListed(pluginName)){
					int num = Utility.GetIndexFromJSONArray(core.settingsRoot["Common"]["Plugins that might Confilict"].AsArray, pluginName);
					core.settingsRoot["Common"]["Plugins that might Confilict"].AsArray.Remove(num);
					core.settingsRoot["Common"]["PTMC On/Off"].Remove(pluginName);
					core.settingsRoot["Common"]["PTMC Timing"].Remove(pluginName);
				}else{
					//nop
				}
				dUIToggle[name].backgroundColor = Color.gray;
			}
		}
		
		public void ToggleStatusForSpecialExpression(string name){
			string[] pattern = {":"};
			string[] words = name.Split(pattern, StringSplitOptions.None);
			string lvl = words[1];
			string morphName = words[2];
			bool isOn = dJSToggle[name].toggle.isOn;
			string sIsOn = (isOn) ? "True" : "False";
			core.settingsRoot["Common"]["SpecialExpression"]["LevelVsExpression"][lvl][morphName] = sIsOn;
			core.expression2.dLvlVsExprTable[lvl][morphName] = isOn;
			core.expression2.UpdateSPLevelTable();
		}
			
		public void ToggleStatusOnly(string name){
			string[] pattern = {":"};
			string[] words = name.Split(pattern, StringSplitOptions.None);
			if(dJSToggle.ContainsKey(name) && dJSToggle[name].toggle != null){
				core.settingsRoot["Common"]["PTMC On/Off"][words[1]] = dJSToggle[name].toggle.isOn.ToString();
			}
		}
		
		public void ToggleAnyAlias(ref bool x, string name){
			ToggleAnyBase(ref x, name);
			ToggleAnyAdditional(ref x, name);
		}
		
		public void ToggleAnyBase(ref bool x, string name){
			x = !x;
			if(name == "DebugMessageOff" || name == "Debug Message Off"){
				settingsRoot["Common"]["General"][name] = x ? "true" : "false";
			}else if(name.StartsWith("OnOff")){
				string[] pattern = {":"};
				string[] words = name.Split(pattern, StringSplitOptions.None);
				string newName = "[AS]" + words[1];
				core.settingsRoot["Common"]["AutoStop On/Off"][newName] = x ? "true" : "false";
			}else{
				settings["General"][name] = x ? "true" : "false";
			}
//			SaveConfig();			
		}
		
		public void ToggleAnyAdditional(ref bool x, string name){

			if (name == "Tears On") tears.ChangeTearsEquipment();
			else if (name == "Drool On") tears.ChangeTearsEquipment();
			else if (name == "Expression On") if (x) expression2.Update(); else expression2.StopExpression();
			else if (name == "Blush On") if (x) blushing.ChangeBlushEquipment(); else blushing.UnequipBlush();
			else if (name == "Eyes Control On") if (x) eyesControl.EyesControlOn(); else eyesControl.EyesControlOff();
			//			else if(name == "Eyes Rollup On")			//nop
			//			else if(name == "Sound On") 				//nop
			else if (name == "Use VAMMoan for Sound") core.soundExternalLinkage.CheckLinkForCustomUI();
			else if (name == "Nipple Erection On") if (x) bodyMorph.Update(Time.time); else bodyMorph.StopBodyMorph();
			else if (name == "Clitoris Erection On") if (x) bodyMorph.Update(Time.time); else bodyMorph.StopBodyMorph();
			else if (name == "Head Motion On") if (x) ToggleExternal("OnOff:Stop Head Control by non-plugins", isForce: true, value: true); else ToggleExternal("OnOff:Stop Head Control by non-plugins", isForce: true, value: false);
			//			else if(name == "AutoStop OtherPlugins")	//nop
			//			else if(name == "Penis Support")	//nop
			//			else if(name == "Alter SkinWrap")	//nop

			else if (name == "Armbinder By Hand") core.DoAddonManager2Function("LabelSwitch");
			else if (name == "Armbinder By Beam") core.DoAddonManager2Function("LabelSwitch");
			else if (name == "Legbinder By Hand") core.DoAddonManager2Function("LabelSwitch");
			else if (name == "Legbinder By Beam") core.DoAddonManager2Function("LabelSwitch");
			else if (name == "Covering Actions All")   core.DoAddonManager2Function("LabelSwitch");
			else if (name == "Cover with Hands")  core.DoAddonManager2Function("LabelSwitch");
			else if (name == "Close Legs")        core.DoAddonManager2Function("LabelSwitch");
			else if (name == "Cover Mouth")       core.DoAddonManager2Function("LabelSwitch");
			else if (name == "Select One Arm Each")   core.DoAddonManager2Function("LabelSwitch");
			else if (name == "Collision Failure Check")   core.DoAddonManager2Function("LabelSwitch");
			else if (name == "Collision Auto Fix")   core.DoAddonManager2Function("LabelSwitch");
			else if(name == "CUA Collision")   {
				core.DoAddonManager2Function("LabelSwitch");
				core.DoAddonManager2Function("ChangeCollisionControls");
			}
			else if(name == "CUA Speed Randomizer"){
				core.DoAddonManager2Function("LabelSwitch");
			}

			else if (name == "Forced Undress") core.addonManager1.addonClothSim.SetUndressOptions();
			else if (name == "Reverse Gravity") core.addonManager1.addonClothSim.SetUndressOptions();
			else if (name == "Undress Detach") core.addonManager1.addonClothSim.SetUndressOptions();
			// else if (name == "Undress CUAs Exclude Head") //nop

			else if (name == "Alter SkinWrap to ClothSim") core.addonManager1.addonClothSim.SetRemoveOptions();
			else if (name == "Hold Clothes containing NGWords") core.addonManager1.addonClothSim.SetRemoveOptions();
			else if (name == "Hold Clothes with ClothSim") core.addonManager1.addonClothSim.SetRemoveOptions();
			else if (name == "Hold Clothes with AlterSkinWrap") core.addonManager1.addonClothSim.SetRemoveOptions();
			else if (name == "Peeing On") if (x) worldUi.OnPeeButtonClick(); else { }
			else if (name == "2x Collider Radius") core.ToggleDoublingColliderSize();
			else if (name == "Auto Expressions Off") atom.GetStorableByID("AutoExpressions").SetBoolParamValue("enabled", (!x));
			else if (name == "Auto Blink Off") atom.GetStorableByID("EyelidControl").SetBoolParamValue("blinkEnabled", (!x));
			else if (name == "Display UI Menu") if (x) worldUi.MakeWorldUI(); else worldUi.RemoveMenuAll();
			// else if (name == "Sensitive Trigger") if (x) core.SubscribeAllTrigger(); else core.UnsubscribeAllTrigger();
			//			else if(name == "HeadMotionOff During Possession")	//nop

			else if (name == "Debug Message Off")
			{
				x = !x;
				blushing.DisableLog = x;
				core.Logger("disableLog: " + core.disableLog);
			}
			
			ChangeButtonColoring();
			if(core.menuOnGlobal && !core.worldUi.IsMinimized() && !core.worldUi.IsPaused()){
				worldUi.ReloadMenu();
			}
		}

		public void ChangeButtonColoring(){
			if(!core.menuOnGlobal){
				if(dUIToggle.ContainsKey("Display UI Menu")){
					dUIToggle["Display UI Menu"].backgroundColor = new Color(1f, 0.7f, 0.9f, 1f);
				}
			}else{
				if(dUIToggle.ContainsKey("Display UI Menu")){
					dUIToggle["Display UI Menu"].backgroundColor = Color.white;
				}
			}
		}
		
		public void SetSliderValueAlt(string name, float value){
			string[] pattern = {" : "};
			string[] words = name.Split(pattern, StringSplitOptions.None);
			Dictionary<string, string> map = new Dictionary<string, string>(){
				{"axisPitch1", "right"},
				{"axisPitch2", "right2"},
				{"axisRoll1", "forward"},
				{"axisRoll2", "forward2"},
				{"axisYaw", "up"},				
			};
			core.settings["HeadControlAngle"][words[0]][map[words[1]]] = "" + value;
			core.headController.UpdateAngle();
		}
		
		public void SetSliderValueAlt2(string name, float value){
			core.settings["HeadControlRatio"]["EventFireRatio"][condMap[name]] = "" + value;
			core.headController.UpdateFireRatio();
		}
		
		public void SetSliderValueAlt3(string name, float value){
			string[] pattern = {")"};
			string[] words = name.Split(pattern, StringSplitOptions.None);
			
			core.settings["HeadControlRatio"][condMap2[words[0]]][words[1]] = "" + value;
			core.headController.UpdateRatioByStage();
		}
		
		public void SetSliderValue(string name, float value){
			if(name == "ExpressionStrengthBase" || name == "Expression Strength")
 				expression2.fmm.baseMultiplier = value;
			else if(name == "Ecstasy Scale")
				core.ecstasyScale = (int)value;
			else if(name == "EyesControlDurationTime" || name == "Eyes Control interval Time")
				eyesControl.eyecontrolClosingTimeInterval = value;
			else if(name == "BodyMorphDurationTime" || name == "BodyMorph Duration Time")
				bodyMorph.bodyMorphClosingTimeOffset = value;
			else if(name == "BlushDurationTime" || name == "Blush Duration Time")
				blushing.BlushClosingTimeOffset = value;
			else if(name == "TearsDurationTime" || name == "Tears Duration Time")
				tears.TearsClosingTimeOffset = value;
			else if(name == "BreathStrength" || name == "Breath Strength")
				belly.targetStrength["chestControl"] = value;
			else if(name == "PeeingRatio" || name == "Peeing Ratio")
				customUnityAssetItem.peeingRatio = value;
			else if(name == "Pitch" || name == "Sound Pitch")
				core.sound.headAudioSource.pitch = value;
			else if(name == "Sound Volume"){
				core.sound.headAudioSource.volume = value;
			}else if(name == "Delayed Synchronous Interval"){
				// Utility.Debug($"value:{value}");
				core.homingDelay = value;
			}
			else if(name == "CustomUnityAsset Scale")
				core.assetScale = value;
			else if(name == "CUA Random Speed Min")
				core.randomSpeedMin = value;
			else if(name == "CUA Random Speed Max")
				core.randomSpeedMax = value;
			else if(name == "Mouth Cover Event Ratio")
				core.MouthCoverRatio = value;
			else if(name == "Test Morph"){
			}
			else if(name == "Playback Rate: Breath")
				core.sound.SetFrequency("breath", value);
			else if(name == "Playback Rate: Moan")
				core.sound.SetFrequency("moan", value);
			else if(name == "Playback Rate: Climax")
				core.sound.SetFrequency("climax", value);
			// addon1
			else if(name == "Undress Power")
				core.addonManager1.undressPower = value;
			else if(name == "Undress Duration")
				core.addonManager1.undressSeconds = value;
			// addon2
			else if(name == "OrgasmStrength" || name == "Orgasm Strength Max")
				core.orgasmStrengthMax = value;
			else if(name == "AfterglowStrength" || name == "Afterglow Strength Max")
				core.afterglowStrengthMax = value;
			else if(name == "WaveBigCycleMax" || name == "Orgasm Wave Big Cycle Count Max")
				core.orgasmWaveCycleBigMax = (int)value;
			else if(name == "WaveBigCycleMin" || name == "Orgasm Wave Big Cycle Count Min")
				core.orgasmWaveCycleBigMin = (int)value;
			else if(name == "WaveSmallCycleMax" || name == "Orgasm Wave Small Cycle Count Max")
				core.orgasmWaveCycleSmallMax = (int)value;
			else if(name == "WaveSmallCycleMin" || name == "Orgasm Wave Small Cycle Count Min")
				core.orgasmWaveCycleSmallMin = (int)value;
			else if(name == "AfterglowBigCycleMax" || name == "Orgasm Afterglow Big Cycle Count Max")
				core.orgasmAfterglowCycleBigMax = (int)value;
			else if(name == "AfterglowBigCycleMin" || name == "Orgasm Afterglow Big Cycle Count Min")
				core.orgasmAfterglowCycleBigMin = (int)value;
			else if(name == "AfterglowSmallCycleMax" || name == "Orgasm Afterglow Small Cycle Count Max")
				core.orgasmAfterglowCycleSmallMax = (int)value;
			else if(name == "AfterglowSmallCycleMin" || name == "Orgasm Afterglow Small Cycle Count Min")
				core.orgasmAfterglowCycleSmallMin = (int)value;
			else if(name == "WaveBigCycleIntervalMax" || name == "Orgasm Wave Big Cycle Interval Max")
				core.orgasmWaveCycleIntervalBigMax = value;
			else if(name == "WaveSmallCycleIntervalMax" || name == "Orgasm Wave Small Cycle Interval Max")
				core.orgasmWaveCycleIntervalSmallMax = value;
			else if(name == "AfterglowBigCycleIntervalMax" || name == "Orgasm Afterglow Big Cycle Interval Max")
				core.orgasmAfterglowCycleIntervalBigMax = value;
			else if(name == "AfterglowSmallCycleIntervalMax" || name == "Orgasm Afterglow Small Cycle Interval Max")
				core.orgasmAfterglowCycleIntervalSmallMax = value;

			else if(name == "Shivering Strength for Finger Low Max"   ){ bodyMorph.strengthFingerLowMax = value; }
			else if(name == "Shivering Strength for Finger High Max"  ){ bodyMorph.strengthFingerHighMax = value; }
			else if(name == "Shivering Strength for Body Low Max"     ){ bodyMorph.strengthShiveringLowMax = value; }
			else if(name == "Shivering Strength for Body High Max"    ){ bodyMorph.strengthShiveringHighMax = value; }
			else if(name == "Shivering Strength for Random Max"       ){ bodyMorph.strengthShiveringIntervalMax = value; }
			else if(name == "Shivering Strength for Finger Low Min"   ){ bodyMorph.strengthFingerLowMin = value; }
			else if(name == "Shivering Strength for Finger High Min"  ){ bodyMorph.strengthFingerHighMin = value; }
			else if(name == "Shivering Strength for Body Low Min"     ){ bodyMorph.strengthShiveringLowMin = value; }
			else if(name == "Shivering Strength for Body High Min"    ){ bodyMorph.strengthShiveringHighMin = value; }
			else if(name == "Shivering Strength for Random Min"       ){ bodyMorph.strengthShiveringIntervalMin = value; }
			
			else if(name == "Ease of Re-Climax"){ /* nop */ }
			else if(name.StartsWith("HC_RatioByStage_")){
			}
			else if(name.StartsWith("HC_RatioByStage_")){
			}
			else
				core.Info("ERROR: unknown name: " + name);
		}		
		
		public void ClickAny(string name){
			if(name == "Load Default"){
				try{
					worldUi.OnCloseMenuClick();
					expression2.StopExpression();
					bodyMorph.StopBodyMorph();
					core.Logger("load default settings.");
					core.LoadSettingsEBATCore("default");
					core.LoadSettingsAfterEBATCore();
					RemoveConfigMenu();
					SaveConfig();
					//core.InitCore();
					//core.Start();
					
					Utility.ReloadPlugins(atom);
				}catch(Exception e){
					core.LoggerE(e);
				}
//				core.Start();				
			}else if(name == "Save Configuration"){
				SaveConfig();
			}else if(name == "Copy Sound File"){
				sound.CopySound();
			}else if(name == "Make her Orgasm"){
				core.DoOrgasmFunction("MakeHerOrgasm");
			}else if(name == "Stop her Orgasm"){
				core.DoOrgasmFunction("StopHerOrgasm");
			}else if(name == "Undress All"){
				tears.UndressAll();
			}else if(name == "Test: Face Forward"){
				core.headController.HeadMotion("Face Forward", true);
			}else if(name == "Test: Turn Head Back 1"){
				core.headController.HeadMotion("Turn Head Back 1", true);
			}else if(name == "Test: Turn Head Back 2"){
				core.headController.HeadMotion("Turn Head Back 2", true);
			}else if(name == "Test: Face Sideways 1"){
				core.headController.HeadMotion("Face Sideways 1", true);
			}else if(name == "Test: Face Sideways 2"){
				core.headController.HeadMotion("Face Sideways 2", true);
			}else if(name == "Test: Face Sideways 3"){
				core.headController.HeadMotion("Face Sideways 3", true);
			}else if(name == "Test: Glance"){
				core.headController.HeadMotion("Glance", true);
			}else if(name == "Sound Test: Breath"){
				sound.PlaySound("breath", Time.time, true);
			}else if(name == "Sound Test: Moan"){
				sound.PlaySound("moan", Time.time, true);
			}else if(name == "Sound Test: Climax"){
				sound.PlaySound("climax", Time.time, true);
			}
			else if (name == "Default Color")
			{
				dUIColor["Blush Color"].colorPicker.SetHSV(Utility.ConvertRGBtoHSV(core.blushing.DefaultColor));
				core.blushing.ForceActivateTemporary(3.0f);
			}
			else if(name.EndsWith("Considering the Event Firing Ratio")){
				core.headController.PickAction(keyMap[name], false, true);
			}else if(name.EndsWith("Ignoring the Event Firing Ratio")){
				core.headController.PickAction(keyMap[name], true, true);
			}else if(name == "Entry Morph"){
				if(dJSPopup["Morph Name"].val != "(nothing)"){
					string key = "DELSPEX:" + dJSPopup["Morph Name"].val;
					if(!dUIButton.ContainsKey(key)){
						try{
							
						core.expression2.AddSpecialExpression(dJSPopup["Morph Name"].val);
						core.expression2.AddEyesDirection(dJSPopup["Morph Name"].val, dJSPopup["Gaze(Eyes) Direction"].val);
						core.expression2.UpdateSPLevelTable();
						core.expression2.MakeEyesDirectionTable();
						RemoveConfigMenu();
						SetupUI();
						}catch(Exception e){
							core.LoggerE(e);
						}
					}else{
						core.Info("Morph \"" + dJSPopup["Morph Name"].val + "\" is already registerd!");
					}
				}else{
					core.Info("Select Valid MorphName!");
				}
			}else if(name.StartsWith("DELSPEX:")){
				string[] words = name.Split(':');
				RemoveConfigMenu();
				core.expression2.RemoveSpecialExpression(words[1]);
				core.expression2.RemoveEyesDirection(words[1]);
				core.expression2.UpdateSPLevelTable();
				core.expression2.MakeEyesDirectionTable();
				if(dUIButton.ContainsKey(name))
				{
					dUIButton.Remove(name);
				}
				SetupUI();
			}else if(name.StartsWith("SPEXTST2:")){
				string[] words = name.Split(':');
				string lvl = words[1];
				core.expression2.ClearContinuityCount();
				core.expression2.TestExpressionByLevel(lvl);
			}else if(name.StartsWith("SPEXTST3:")){
				string[] words = name.Split(':');
				string expression = words[1];
				core.expression2.ClearContinuityCount();
				core.expression2.TestSpecialExpression(expression);
				core.blushing.ForceActivateTemporary(3.0f);
				core.tears.ForceActivateTemporary(3.0f);
			}
			else if(name.StartsWith("Hint")){
				string[] words = name.Split(':');
				string newName = "Hint:" + words[1];
				core.hint.CustomUiHint(newName);
			}
		}

		public void PickColorAny(string name)
		{
			if (name == "WRONG")
			{
			}
			else if(name == "Blush Color")
			{
				blushing.SetBlushColor(Utility.ConvertHSVtoRGB(dJSColor[name].val));
				core.blushing.ForceActivateTemporary(3.0f);
				SetValueToSettings(dJSColor[name].val.H.ToString(), core.gender, "Blush Color", "h", "");
				SetValueToSettings(dJSColor[name].val.S.ToString(), core.gender, "Blush Color", "s", "");
				SetValueToSettings(dJSColor[name].val.V.ToString(), core.gender, "Blush Color", "v", "");
			}
		}

		public void MakeUIPartPopup(string name, bool isRight, bool isFilterable = false){
			if(dJSPopup.ContainsKey(name) == false){
				core.Info("MakeUIPartPopup: unknown name: " + name);
				return;
			}
			UIDynamicPopup ui = (isFilterable) ? 
				core.CreateFilterablePopup(dJSPopup[name], isRight) :
				core.CreateScrollablePopup(dJSPopup[name], isRight) ;

			if(dUIPopup.ContainsKey(name)) dUIPopup[name] = ui;
			else dUIPopup.Add(name, ui);
		}
		
		public void MakeUIPartColor(string name, bool isRight)
		{
			if(!dJSColor.ContainsKey(name)) 
			{
				core.Info("MakeUIPartColor: unknown name: " + name);
				return;
			}
			UIDynamicColorPicker ui = core.CreateColorPicker(dJSColor[name], isRight);
			if (dUIColor.ContainsKey(name)) dUIColor[name] = ui;
			else dUIColor.Add(name, ui);
		}
		
		public void MakeUIPartToggle(string name, bool isRight, string displayName = ""){
			MakeUIPartToggle(name, isRight, Color.white, displayName);
		}
		
		public void MakeUIPartToggle(string name, bool isRight, Color color, string displayName = ""){
			if(dJSToggle.ContainsKey(name) == false){
				core.Info("MakeUIPartToggle: unknown name: " + name);
				return;
			}
			UIDynamicToggle ui = core.CreateToggle(dJSToggle[name], isRight);
			ui.backgroundColor = color;
			if(displayName == ""){
				string[] words = name.Split(':');
				string labelName = (words.Length > 1) ? words[1] : words[0];
				ui.label = labelName;				
			}else{
				ui.label = displayName;
			}
			
			if(dUIToggle.ContainsKey(name)) dUIToggle[name] = ui;
			else dUIToggle.Add(name, ui);
		}
		
		public void MakeUIPartSpacer(string name, string type, bool isRight){
			MakeUIPartSpacer(name, GetHeight(type), isRight);
		}
		
		public float GetHeight(string sHeight){
			float height = 0f;
			if(sHeight == "SectionSeparator") height = 16f;
			else if(sHeight == "NewLineSkip") height = 0f;
			else if(sHeight == "ButtonAndSectionSeparator") height = 50f;
			else if(sHeight == "ButtonSkip") height = 50f;
			else if(sHeight == "SliderSkip") height = 120f;
			else if(sHeight == "PopupSkip") height = 100;
			else if(sHeight == "PopupFilterableSkip") height = 120f;
			else core.Info("ERROR:");
			
			return height;
		}
				
		public void MakeUIPartSpacer(string name, float height, bool isRight){
			UIDynamic ui = core.CreateSpacer(isRight);
//			ui.height = height;
			SetLayoutHeight(ui, height);
//			Image img = ui.gameObject.AddComponent<Image>();
//			img.material = new Material(Shader.Find("UI/Default-Overlay"));
//			RectTransform imageRect = img.rectTransform;
//			imageRect.sizeDelta = new Vector2(300, 300);
			
			if(dUISpacer.ContainsKey(name)) dUISpacer[name] = ui;
			else dUISpacer.Add(name, ui);
		}                   
		
		public void MakeUIPartButtonNoFunc(string name, bool isRight, string displayName = ""){
			MakeUIPartButtonNoFunc(name, isRight, colorDefault, displayName);
		}
		
		public void MakeUIPartButtonNoFunc(string name, bool isRight, Color color, string displayName = ""){
			UIDynamicButton ui = core.CreateButton(name, isRight);
			ui.buttonColor = color;
			if(displayName != ""){
				ui.label = displayName;
			}
			if(dUIButton.ContainsKey(name)) dUIButton[name] = ui;
			else dUIButton.Add(name, ui);
		}
		
		public void MakeUIPartButton(string name, bool isRight, string displayName = ""){
			MakeUIPartButton(name, isRight, colorDefault, displayName);
		}
		
		public void MakeUIPartButton(string name, bool isRight, Color color, string displayName = ""){
			MakeUIPartButtonNoFunc(name, isRight, color, displayName);
			dUIButton[name].button.onClick.AddListener(()=>{ClickAny(name);});
		}                   
		
		public void SetUISliderValueExternal(string name, float value){
			if(dJSSlider.ContainsKey(name)){
				if(dJSSlider[name] != null){
					dJSSlider[name].val = value;
				}
				if(dJSSlider[name] != null && dJSSlider[name].slider){
					dJSSlider[name].slider.value = value;
				}
			}
		}
		
		public void MakeUIPartSlider(string name, bool isRight, string displayName = ""){
			if(dJSSlider.ContainsKey(name) == false){
				core.Info("MakeUIPartSlider: unknown name: " + name);
				return;
			}
			
			UIDynamicSlider ui = core.CreateSlider(dJSSlider[name], isRight);
			if(displayName != ""){
				ui.label = displayName;
			}
			if(dUISlider.ContainsKey(name)) dUISlider[name] = ui;
			else dUISlider.Add(name, ui);
			
			if(name == "ExpressionStrengthBase" || name == "Expression Strength"){
				dJSSlider[name].slider.onValueChanged.AddListener((float value)=>{
					worldUi.uiStrengthSlider.slider.value = value;
				});				
			}else if(name == "Ecstasy Scale"){
				dJSSlider[name].slider.onValueChanged.AddListener((float value)=>{
					core.ResetThreshold();
					worldUi.ReloadMenu();
				});
			}else if(name == "CustomUnityAsset Scale"){
				dJSSlider[name].slider.onValueChanged.AddListener((float value)=>{
					core.DoAddonManager2Function("SetAssetScale");
					worldUi.ReloadMenu();
				});
			}else if(name == "Mouth Cover Event Ratio"){
				dJSSlider[name].slider.onValueChanged.AddListener((float value)=>{
					core.MouthCoverRatio = value;
				});
			}else if(name == "CUA Random Speed Min"){
				dJSSlider[name].slider.onValueChanged.AddListener((float value)=>{
					core.randomSpeedMin = value;
				});
			}else if(name == "CUA Random Speed Max"){
				dJSSlider[name].slider.onValueChanged.AddListener((float value)=>{
					core.randomSpeedMax = value;
				});
			}else if(name == "Test Morph"){
				dUISlider[name].defaultButton.onClick.AddListener(() => {
					morphCurrent.SetValue(0.000001f);
				});
				dJSSlider[name].slider.onValueChanged.AddListener((float value)=>{
					morphCurrent.SetValue(value);
				});
			}else if(name == "WaveBigCycleMax" || name == "Orgasm Wave Big Cycle Count Max"){
				dJSSlider[name].slider.onValueChanged.AddListener((float value)=>{
					worldUi.uiWaveSlider.slider.value = value;
				});			
			}else if(name == "Sound Pitch"){
				dJSSlider[name].slider.onValueChanged.AddListener((float value)=>{
					core.sound.headAudioSource.pitch = value;
					worldUi.uiPitchSlider.slider.value = value;
				});			
			}else if(name == "Sound Volume"){
				dJSSlider[name].slider.onValueChanged.AddListener((float value)=>{
					core.sound.headAudioSource.volume = value;
					worldUi.uiVolumeSlider.slider.value = value;
				});			
			}

		}	

		public void MakeUIPartStringAndVariable(string name, string text, bool isRight, string sHeight, int fontSize = 0){
			MakeUIPartStringAndVariable(name, text, isRight, GetHeight(sHeight), fontSize);
		}
		
		public void MakeUIPartStringAndVariable(string name, string text, bool isRight, float fHeight = 0f, int fontSize = 0){
			Color color = Color.white;
			MakeUIPartStringAndVariable(name, text, isRight, color, fHeight, fontSize);
		}
		
		public void MakeUIPartStringAndVariable(string name, string text, bool isRight, Color color, string sHeight, int fontSize = 0){
			MakeUIPartStringAndVariable(name, text, isRight, color, GetHeight(sHeight), fontSize);
		}
		
		public void MakeUIPartStringAndVariable(string name, string text, bool isRight, Color color, float fHeight = 0f, int fontSize = 0){
			MakeVariableString(name, text);
			MakeUIPartString(name, isRight, color, fHeight, fontSize);
		}
		
		public void MakeUIPartString(string name, bool isRight, Color color, float fHeight = 0f, int fontSize = 0){
			if(dJSString.ContainsKey(name) == false){
				core.Info("MakeUIPartString: unknown name: " + name);
				return;
			}
			UIDynamicTextField ui = core.CreateTextField(dJSString[name], isRight);

			if(fHeight != 0f){
				SetLayoutHeight(ui, fHeight);
//				ui.height = fHeight;
			}
			if(fontSize != 0){
				ui.UItext.fontSize = fontSize;
			}
			ui.backgroundColor = color;
			if(dUIString.ContainsKey(name)) dUIString[name] = ui;
			else dUIString.Add(name, ui);			
		}
		
		public void MakeUIPartString(string name, bool isRight, float fHeight = 0f){
			Color color = Color.white;
			MakeUIPartString(name, isRight, color, fHeight);
		}
		
		public void MakeUIPartInputTextAndVariable(string name, string text, bool isRight, float fHeight = 16f, int fontSize = 36){
			MakeVariableString(name, text);
			MakeUIPartInputText(name, isRight, fHeight, fontSize);
		}
		
		public void MakeUIPartInputText(string name, bool isRight, float fHeight = 16f, int fontSize = 36){
			if(dJSString.ContainsKey(name) == false){
				core.Info("MakeUIPartString: unknown name: " + name);
				return;
			}

			UIDynamicTextField ui = core.CreateTextField(dJSString[name], isRight);
			ui.height = fHeight;
			ui.backgroundColor = Color.white;
			SetLayoutHeight(ui, fHeight);
			if(dUIString.ContainsKey(name)) dUIString[name] = ui;
			else dUIString.Add(name, ui);	
			
			InputField inputField = ui.gameObject.AddComponent<InputField>();
			inputField.textComponent = ui.UItext;
			inputField.textComponent.fontSize = fontSize;
			if(dInput.ContainsKey(name)) dInput[name] = inputField;
			else dInput.Add(name, inputField);
		}
		
		public void SetLayoutIgnoreLayout(Component component, bool bIgnore = false){
			var layoutElement = component.GetComponent<LayoutElement>();
			layoutElement.ignoreLayout = bIgnore;
		}
		
		public void SetLayoutWidth(Component component, float width){
			var layoutElement = component.GetComponent<LayoutElement>();
			layoutElement.minWidth = 0f;
			layoutElement.preferredWidth = width;
		}
		
		public void SetLayoutHeight(Component component, float height){
			var layoutElement = component.GetComponent<LayoutElement>();
			layoutElement.minHeight = 0f;
			layoutElement.preferredHeight = height;
		}
		
		
		public void MakeUIPartButtonToggleMenu(string name, bool bSwitch = false){
			bool flag = (bSwitch);
			string displayName = !(dOpenState[name]) ? "[+]Expand " + name : "[-]Collapse " + name;
			MakeUIPartButtonNoFunc(displayName, flag, Color.white);
			dUIButton[displayName].button.onClick.AddListener(()=>{
				OnSwitchToggleMenu(displayName);
				RemoveConfigMenu();
				dOpenState[name] = !(dOpenState[name]);
				SetupUI();	
			});
		}
		//unko
		public void OnSwitchToggleMenu(string displayName){
			if(displayName == "[-]Collapse [EM]Registering Facial Expressions"){
				foreach(var name in core.expression2.GetSpecialExpressions()){
					DAZMorph morph = Utility.GetMorphByDisplayName(core.atom, name);
					morph.SetValue(0.000001f);
					morph.SetValue(0.0f);
				}
				morphCurrent.SetValue(0.000001f);
				morphCurrent.SetValue(0.0f);
			}
		}
		
		#region etc.
		public void SaveConfig(){
			core.SaveConfig();
		}
		
		public void InitExpandState(bool flag){
			foreach(var name in expandsNames){
				if(!dOpenState.ContainsKey(name)){
					dOpenState.Add(name, flag);
				}
			}
		}
		
		public void ExpandAll(bool flag){
			foreach(var name in expandsNames){
				dOpenState[name] = flag;
			}
		}
		#endregion
		
		public void SetupUI(){
			SetupUIActionButtons();
			SetupUIExpandMenu("Toggles for Main Features");
			if(dOpenState["Toggles for Main Features"]) SetupUIToggleButtons();
			// SetupUIExpandMenu("Toggles for WorldUI Shortcut");
			// if(dOpenState["Toggles for WorldUI Shortcut"]) SetupUIShortcut();
			SetupUIExpandMenu("Toggles for Undress");
			if(dOpenState["Toggles for Undress"]) SetupUIToggleUndress();
			SetupUIExpandMenu("Sliders for Main Features");
			if(dOpenState["Sliders for Main Features"]) SetupUISliders1();
			SetupUIExpandMenu("Head Controller(HC) Menu");
			if(dOpenState["Head Controller(HC) Menu"]) SetupUIHCMenu();

			SetupUIExpandMenu("Expression Manager(EM)");
			if(dOpenState["Expression Manager(EM)"]) SetupUIExpressionManager();

			SetupUIExpandMenu("Sound Menu");
			if(dOpenState["Sound Menu"]) SetupUISound();
			SetupUIExpandMenu("AutoStop(AS) Menu");
			if(dOpenState["AutoStop(AS) Menu"]) SetupUIASMenu();			
			SetupUIExpandMenu("Sliders for Stage Thresholds");
			if(dOpenState["Sliders for Stage Thresholds"]) SetupUISliders2();
			if(core.orgasmModeOn){
				SetupUIExpandMenu("Sliders for Orgasm Features");
				if(dOpenState["Sliders for Orgasm Features"]) SetupUISliders3();
				SetupUIExpandMenu("Toggles for Orgasm Features");
				if(dOpenState["Toggles for Orgasm Features"]) SetupUIToggle2();				
			}
			if(core.addon2ModeOn){
				SetupUIExpandMenu("Toggles for Addon2 Settings");
				if(dOpenState["Toggles for Addon2 Settings"]) SetupUIToggle3();				
			}
			UpdateFontSize();
		}

		public void UpdateFontSize(){
			foreach(var ui in dUIButton.Values.ToList()){ UpdateFontSize(ui); }
			foreach(var ui in dUIToggle.Values.ToList()){ UpdateFontSize(ui); }
			foreach(var ui in dUISlider.Values.ToList()){ UpdateFontSize(ui); }
			foreach(var ui in dUIPopup.Values.ToList()) { UpdateFontSize(ui); }
		}
		
		public void LabelUpdate(UIDynamic ui, string label){
			if(ui == null) { return; }
			
			UIDynamicButton button = ui as UIDynamicButton;
			if(button != null){ button.label = label; UpdateFontSize(button); }
			
			UIDynamicToggle toggle = ui as UIDynamicToggle;
			if(toggle != null){ toggle.label = label; UpdateFontSize(toggle); }
			
			UIDynamicSlider slider = ui as UIDynamicSlider;
			if(slider != null){ slider.label = label; UpdateFontSize(slider); }
			
			UIDynamicPopup  popup  = ui as UIDynamicPopup;
			if(popup != null){ popup.label = label; UpdateFontSize(popup); }
		}
		
		public void UpdateFontSize(UIDynamic ui){
			if(ui == null) { return; }
			
			UIDynamicButton button = ui as UIDynamicButton;
			if(button != null){ button.buttonText.fontSize = (button.label.Length < LENGTH_THRESHOLD) ? FONTSIZE_NORMAL : FONTSIZE_SMALL; }
			
			UIDynamicToggle toggle = ui as UIDynamicToggle;
			if(toggle != null){ toggle.labelText.fontSize = (toggle.label.Length < LENGTH_THRESHOLD) ? FONTSIZE_NORMAL : FONTSIZE_SMALL; }
			
			UIDynamicSlider slider = ui as UIDynamicSlider;
			if(slider != null){ slider.labelText.fontSize = (slider.label.Length < LENGTH_THRESHOLD) ? FONTSIZE_NORMAL : FONTSIZE_SMALL; }
			
			UIDynamicPopup  popup  = ui as UIDynamicPopup;
			if(popup  != null){ popup.popup.labelText.fontSize = (popup.label.Length < LENGTH_THRESHOLD) ? FONTSIZE_NORMAL : FONTSIZE_SMALL; }
		}
		
		public void SetupUIHCMenu(){
			SetupUIExpandMenu("[HC]Angle");
			if(dOpenState["[HC]Angle"]) SetupUISliders4();
			SetupUIExpandMenu("[HC]Event Firing Ratio");
			if(dOpenState["[HC]Event Firing Ratio"]) SetupUISliders5();
			SetupUIExpandMenu("[HC]Ratio By Stage");
			if(dOpenState["[HC]Ratio By Stage"]) SetupUISliders6();
		}
		
		public void SetupUIExpressionManager(){
			SetupCategoryMessage("Expression Manager(EM)");
			SetupUIExpandMenu("[EM]Registering Facial Expressions");
			if(dOpenState["[EM]Registering Facial Expressions"]) SetupUIEM1();
			SetupUIExpandMenu("[EM]Register expressions to the level");
			if(dOpenState["[EM]Register expressions to the level"]) SetupUIEM2();
			SetupUIExpandMenu("[EM]Event firing ratio");
			if(dOpenState["[EM]Event firing ratio"]) SetupUIEM3();
		}
		
		public void SetupUIASMenu(){
			SetupUIExpandMenu("[AS]AutoStop On/Off Settings");
			if(dOpenState["[AS]AutoStop On/Off Settings"]) SetupUIAS1();
			SetupUIExpandMenu("[AS]Plugin Switching");
			if(dOpenState["[AS]Plugin Switching"]) SetupUIAS2();
			SetupUIExpandMenu("[AS]Plugin Registration");
			if(dOpenState["[AS]Plugin Registration"]) SetupUIAS3();
		}
		
		public void SetupUIExpandMenu(string name){
			bool flag = (name.StartsWith("[HC]") || name.StartsWith("[AS]") || name.StartsWith("[EM]"));
			MakeUIPartButtonToggleMenu(name, bSwitch:flag);
			MakeUIPartSpacer("spacer_" + name, "ButtonAndSectionSeparator", !flag);
		}
	
		public void SetupCategoryMessage(string name)
		{
			string msgId = name + "_message";
			string msgBody = "";
			
			if(name == "Expression Manager(EM)")
			{
				msgBody = 
				"<b>In This Menu, You can register your favorite Facial Expressions(hereafter referred to as 'User-Defined-Expression').</b>\n\n" +
				"<b>In STEP1,</b> register the User-Defined-Expression you wish to use:\n" +
				"  Note: User-Defined-Expression should be created using Morph Merger or similar.\n" +
				"<b>In STEP2,</b> register the associations of which User-Defined-Expression you want to use at which stage.\n" +
				"  Note: Only the User-Defined-Expression registered in STEP1 can be associated with a stage.\n" + 
				"<b>In STEP3,</b> set up the User-Defined-Expression to be used at what rate and at what stage.\n" +
				"  Note: The User-Defined-Expression will be used according to the incidence set here. " +
				"You cannot set individual incidence for the User-Defined-Expression to be used. " + 
				"All registered User-Defined-Expression will be used with the same incidence. " +
				"If you set the incidence to 0, only normal Expressions will be used; " + 
				"if you set it to 1, only User-Defined-Expression will be used.";
			}
			else if(name == "")
			{
				
			}
					
			if(msgBody != ""){
				MakeUIPartStringAndVariable(msgId, msgBody, true, colorYellow, 200f, 28);
				MakeUIPartSpacer("space_" + msgId, 200f, false);
			}
		}
	
		public string MakeName(string type, string tag, string key){
			return type + "_" + tag + "_" + key;
		}
		
		public string MakeName(string type, string tag, int i){
			return type + "_" + tag + "_" + i;
		}
		
		public string MakeExplanation(string key){
			string expPrefix = "MorphName:\n";
			string expSuffix = "\nFor this morph, you can\n - toggle enable/disable\n - limit strength\n - test morph";
			return expPrefix + key + expSuffix;
		}
				
		/*
		public void OverwriteWithSaveData(){
			OverwriteVariableToggle("Debug Message Off", ref core.disableLog);
			OverwriteVariableToggle("Display UI Menu", ref core.menuOnGlobal);
			//AfterStartingConstructor
			//setupUIToggleButtons
			OverwriteVariableToggle("Auto Expression Off", ref etc.autoExpressionOffGlobal);
			OverwriteVariableToggle("Auto Blink Off", ref etc.autoBlinkOffGlobal);			
		}
		*/
		
		public void SetupUIVariablesToggles(){
			//Unordered
			//setupUIActionButtons
			MakeVariableToggle("Debug Message Off", core.disableLog);
			MakeVariableToggle("Display UI Menu", core.menuOnGlobal);
			//AfterStartingConstructor
			//setupUIToggleButtons
			MakeVariableToggle("Auto Expression Off", etc.autoExpressionOffGlobal);
			MakeVariableToggle("Auto Blink Off", etc.autoBlinkOffGlobal);
			MakeVariableToggle("Expression On", expression2.expressionOnGlobal);
			MakeVariableToggle("Eyes Control On", eyesControl.eyecontrolOnGlobal);
			MakeVariableToggle("Eyes Rollup On", eyesControl.eyecontrolRollupOnGlobal);
			MakeVariableToggle("Blush On", blushing.BlushOn);
			MakeVariableToggle("Tears On", tears.TearsOn);
			MakeVariableToggle("Drool On", tears.DroolOn);
			MakeVariableToggle("Sound On", sound.soundOnGlobal);
			MakeVariableToggle("Use VAMMoan for Sound", core.vammoanLinkOnGlobal);
			MakeVariableToggle("Nipple Erection On", bodyMorph.nippleErectionOnGlobal);
			MakeVariableToggle("Clitoris Erection On", bodyMorph.clitorisErectionOnGlobal);
			MakeVariableToggle("Head Motion On", headController.headMotionOnGlobal);
			MakeVariableToggle("Peeing On", customUnityAssetItem.peeingOnGlobal);
			MakeVariableToggle("2x Collider Radius", core.collider2xOnGlobal);
//			MakeVariableToggle("AutoStop OtherPlugins", addonTakeControlItem.autoStopOnGlobal);
			// MakeVariableToggle("Sensitive Trigger", core.sensitiveTriggerOnGlobal);
			
			MakeVariableToggle("Penis Support", core.manController.penisSupportOnGlobal);
			MakeVariableToggle("HeadMotionOff During Possession", core.headController.headMotionStopDuringPossessionOnGlobal);
			
			MakeVariableToggle("Forced Undress", core.addonManager1.forcedUndressOnGlobal);
			MakeVariableToggle("Reverse Gravity", core.addonManager1.undressReverseOnGlobal);
			MakeVariableToggle("Undress Detach", core.addonManager1.undressDetachOnGlobal);
			MakeVariableToggle("Undress CUAs Exclude Head", core.addonManager1.addonCUAUndresser.excludeHeadOnGlobal);

			MakeVariableToggle("Alter SkinWrap to ClothSim", core.addonManager1.wrapAlterToSimOnGlobal);
			MakeVariableToggle("Hold Clothes containing NGWords", core.addonManager1.holdNGWordsOnGlobal);
			MakeVariableToggle("Hold Clothes with ClothSim"     , core.addonManager1.holdClothSimOnGlobal);
			MakeVariableToggle("Hold Clothes with AlterSkinWrap", core.addonManager1.holdSkinWrapOnGlobal );
			
			if(core.addon2ModeOn){
				MakeVariableToggle("Armbinder By Hand", core.armBinderByHandOnGlobal);
				MakeVariableToggle("Armbinder By Beam", core.armBinderByBeamOnGlobal);
				MakeVariableToggle("Legbinder By Hand", core.legBinderByHandOnGlobal);
				MakeVariableToggle("Legbinder By Beam", core.legBinderByBeamOnGlobal);
				MakeVariableToggle("Covering Actions All", core.coveringOnGlobal);
				MakeVariableToggle("Cover with Hands", core.coveringWithHandsOnGlobal);
				MakeVariableToggle("Close Legs",       core.coveringWithLegsOnGlobal);
				MakeVariableToggle("Cover Mouth", core.coveringMouthOnGlobal);
				MakeVariableToggle("Select One Arm Each", core.oneArmEachOnGlobal);
				MakeVariableToggle("CUA Collision", core.collisionControlOnGlobal);
				MakeVariableToggle("CUA Speed Randomizer", core.speedRandomizerOnGlobal);
			}
			MakeVariableToggle("Collision Failure Check", core.collisionFailureCheckOnGlobal);
			MakeVariableToggle("Collision Auto Fix", core.collisionAutoFixOnGlobal);
			
			MakeVariablesToggleAS1();
			MakeVariablesToggleAS2();
			MakeVariablesToggleAS3();
			
			if(core.orgasmModeOn){
				MakeVariableToggle("Shivering during climax(morph)", core.bellyMorphOn);
				MakeVariableToggle("Shivering during climax(bone)",  core.bellyBoneOn);
				MakeVariableToggle("BodyMorph:Anus",       core.bodyMorph.otherMorphsStatus["Anus"      ]);
				// MakeVariableToggle("BodyMorph:Fingers",    core.bodyMorph.otherMorphsStatus["Fingers"   ]);
				MakeVariableToggle("BodyMorph:Shivering1", core.bodyMorph.otherMorphsStatus["Shivering1"]);
				MakeVariableToggle("BodyMorph:Shivering2", core.bodyMorph.otherMorphsStatus["Shivering2"]);
				MakeVariableToggle("BodyMorph:ShiveringP", core.bodyMorph.otherMorphsStatus["ShiveringP"]);
			}
		}
		
		public void SetupUIVariables(){
			SetupUIVariablesToggles();
			MakeVariableColor("Blush Color", blushing.CurrentColor);
			MakeVariableForShortcut();
			//Unordered
			//AfterStartingConstructor
			//setupUIToggleButtons
			MakeVariablePopup("Blush Type", blushing.BlushTypes, blushing.BlushTypeDefault);
			MakeVariablePopup("Tears Type", tears.TearsTypes, tears.TearsTypeDefault);
			MakeVariablePopup("Sound Type(Default)", sound.soundTypes, sound.soundTypeDefault);
			MakeVariablePopup("Sound Type(Personal)", sound.soundTypes, sound.soundTypeDefault);
			//setupUISliders1
			MakeVariableSlider("Expression Strength", expression2.fmm.baseMultiplier, 0f, 1.2f, "General", "Expression Strength");
			MakeVariableSlider("Ecstasy Scale", core.ecstasyScale, 1f, 16f, "General", "Ecstasy Scale");
			MakeVariableSlider("Eyes Control interval Time", eyesControl.eyecontrolClosingTimeInterval, 0f, 60f, "General", "EyesControlDurationTime");
			MakeVariableSlider("BodyMorph Duration Time", bodyMorph.bodyMorphClosingTimeOffset, 0f, 60f, "General", "BodyMorphDurationTime");
			MakeVariableSlider("Blush Duration Time", blushing.BlushClosingTimeOffset, 0f, 60f, "General", "BlushDurationTime");
			MakeVariableSlider("Tears Duration Time", tears.TearsClosingTimeOffset, 0f, 60f, "General", "TearsDurationTime");
			MakeVariableSlider("Breath Strength", belly.targetStrength["chestControl"], -60f, 60f, "General", "BreathStrength");
			MakeVariableSlider("Peeing Ratio", customUnityAssetItem.peeingRatio, 0f, 1f, "General", "PeeingRatio");
			MakeVariableSlider("Delayed Synchronous Interval", core.homingDelay, 0f, 1.0f, "General", "Delayed Synchronous Interval");

			MakeVariableSlider("Default Canvas Position Up"     , worldUi.worldUIBase.defaultCanvasOffsetUp      , -2.0f, 2.0f, "Common", "Default Position", "Up"     , "");
			MakeVariableSlider("Default Canvas Position Right"  , worldUi.worldUIBase.defaultCanvasOffsetRight   , -2.0f, 2.0f, "Common", "Default Position", "Right"  , "");
			MakeVariableSlider("Default Canvas Position Forward", worldUi.worldUIBase.defaultCanvasOffsetForward , -2.0f, 2.0f, "Common", "Default Position", "Forward", "");

			//setupUIToggle3
			MakeVariableSlider("CustomUnityAsset Scale", core.assetScale, 0f, 1.5f, "General", "CustomUnityAsset Scale");
			MakeVariableSlider("Mouth Cover Event Ratio", core.MouthCoverRatio, 0f, 1.0f, "General", "Mouth Cover Event Ratio");
			MakeVariableSlider("CUA Random Speed Min", core.randomSpeedMin, 0f, 10.0f, "General", "CUA Random Speed Min");
			MakeVariableSlider("CUA Random Speed Max", core.randomSpeedMax, 0f, 10.0f, "General", "CUA Random Speed Max");

			//setupUISliders4
			MakeVariableSlider("Face Sideways 1 : axisPitch1", core.headController.GetAngle("Face Sideways 1", "right"),    -180f, 180f, "HeadControlAngle", "Face Sideways 1",  "right");
			MakeVariableSlider("Face Sideways 1 : axisPitch2", core.headController.GetAngle("Face Sideways 1", "right2"),   -180f, 180f, "HeadControlAngle", "Face Sideways 1",  "right2");
			MakeVariableSlider("Face Sideways 1 : axisRoll1", core.headController.GetAngle( "Face Sideways 1", "forward"),  -180f, 180f, "HeadControlAngle", "Face Sideways 1",  "forward");
			MakeVariableSlider("Face Sideways 1 : axisRoll2", core.headController.GetAngle( "Face Sideways 1", "forward2"), -180f, 180f, "HeadControlAngle", "Face Sideways 1",  "forward2");
			MakeVariableSlider("Face Sideways 1 : axisYaw", core.headController.GetAngle(   "Face Sideways 1", "up"),       -180f, 180f, "HeadControlAngle", "Face Sideways 1",  "up");
			MakeVariableSlider("Face Sideways 2 : axisPitch1", core.headController.GetAngle("Face Sideways 2", "right"),    -180f, 180f, "HeadControlAngle", "Face Sideways 2",  "right");
			MakeVariableSlider("Face Sideways 2 : axisPitch2", core.headController.GetAngle("Face Sideways 2", "right2"),   -180f, 180f, "HeadControlAngle", "Face Sideways 2",  "right2");
			MakeVariableSlider("Face Sideways 2 : axisRoll1", core.headController.GetAngle( "Face Sideways 2", "forward"),  -180f, 180f, "HeadControlAngle", "Face Sideways 2",  "forward");
			MakeVariableSlider("Face Sideways 2 : axisRoll2", core.headController.GetAngle( "Face Sideways 2", "forward2"), -180f, 180f, "HeadControlAngle", "Face Sideways 2",  "forward2");
			MakeVariableSlider("Face Sideways 2 : axisYaw", core.headController.GetAngle(   "Face Sideways 2", "up"),       -180f, 180f, "HeadControlAngle", "Face Sideways 2",  "up");
			MakeVariableSlider("Face Sideways 3 : axisPitch1", core.headController.GetAngle("Face Sideways 3", "right"),    -180f, 180f, "HeadControlAngle", "Face Sideways 3",  "right");
			MakeVariableSlider("Face Sideways 3 : axisPitch2", core.headController.GetAngle("Face Sideways 3", "right2"),   -180f, 180f, "HeadControlAngle", "Face Sideways 3",  "right2");
			MakeVariableSlider("Face Sideways 3 : axisRoll1", core.headController.GetAngle( "Face Sideways 3", "forward"),  -180f, 180f, "HeadControlAngle", "Face Sideways 3",  "forward");
			MakeVariableSlider("Face Sideways 3 : axisRoll2", core.headController.GetAngle( "Face Sideways 3", "forward2"), -180f, 180f, "HeadControlAngle", "Face Sideways 3",  "forward2");
			MakeVariableSlider("Face Sideways 3 : axisYaw", core.headController.GetAngle(   "Face Sideways 3", "up"),       -180f, 180f, "HeadControlAngle", "Face Sideways 3",  "up");
			MakeVariableSlider("Glance : axisPitch1", core.headController.GetAngle("Glance", "right"),                      -180f, 180f, "HeadControlAngle", "Glance",           "right");
			MakeVariableSlider("Glance : axisPitch2", core.headController.GetAngle("Glance", "right2"),                     -180f, 180f, "HeadControlAngle", "Glance",           "right2");
			MakeVariableSlider("Glance : axisRoll1", core.headController.GetAngle( "Glance", "forward"),                    -180f, 180f, "HeadControlAngle", "Glance",           "forward");
			MakeVariableSlider("Glance : axisRoll2", core.headController.GetAngle( "Glance", "forward2"),                   -180f, 180f, "HeadControlAngle", "Glance",           "forward2");
			MakeVariableSlider("Glance : axisYaw", core.headController.GetAngle(   "Glance", "up"),                         -180f, 180f, "HeadControlAngle", "Glance",           "up");
			MakeVariableSlider("Turn Head Back 1 : axisPitch1", core.headController.GetAngle("Turn Head Back 1", "right"),  -180f, 180f, "HeadControlAngle", "Turn Head Back 1", "right");
			MakeVariableSlider("Turn Head Back 2 : axisPitch1", core.headController.GetAngle("Turn Head Back 2", "right"),  -180f, 180f, "HeadControlAngle", "Turn Head Back 2", "right");
			//setupUISliders5
			
			MakeVariableSlider("Cond1)Stage < 3 & Orgasm Count < 99", core.headController.GetFireRatio("Stage<3:OrgasmCount<99"),    0f, 100f, "HeadControlRatio", "EventFireRatio",  "Stage<3:OrgasmCount<99");
			MakeVariableSlider("Cond2)Stage < 5 & Orgasm Count < 99", core.headController.GetFireRatio("Stage<5:OrgasmCount<99"),    0f, 100f, "HeadControlRatio", "EventFireRatio",  "Stage<5:OrgasmCount<99");
			MakeVariableSlider("Cond3)Stage = 5 & Orgasm Count < 01", core.headController.GetFireRatio("Stage=5:OrgasmCount<01"),    0f, 100f, "HeadControlRatio", "EventFireRatio",  "Stage=5:OrgasmCount<01");
			MakeVariableSlider("Cond4)Stage = 5 & Orgasm Count < 03", core.headController.GetFireRatio("Stage=5:OrgasmCount<03"),    0f, 100f, "HeadControlRatio", "EventFireRatio",  "Stage=5:OrgasmCount<03");
			MakeVariableSlider("Cond5)Stage = 5 & Orgasm Count < 06", core.headController.GetFireRatio("Stage=5:OrgasmCount<06"),    0f, 100f, "HeadControlRatio", "EventFireRatio",  "Stage=5:OrgasmCount<06");
			MakeVariableSlider("Cond6)Stage = 5 & Orgasm Count < 09", core.headController.GetFireRatio("Stage=5:OrgasmCount<09"),    0f, 100f, "HeadControlRatio", "EventFireRatio",  "Stage=5:OrgasmCount<09");
			MakeVariableSlider("Cond7)Stage = 5 & Orgasm Count < 99", core.headController.GetFireRatio("Stage=5:OrgasmCount<99"),    0f, 100f, "HeadControlRatio", "EventFireRatio",  "Stage=5:OrgasmCount<99");

			int n = 0;
			foreach(var stage in core.headController.ListStages()){
				n++;
				bool flag = (n % 2 == 0);
				foreach(var actionName in core.headController.ListActions()){
					string name = "HC_RatioByStage_" + n + ")" + actionName;
					MakeVariableSlider(name, core.headController.GetRatioByStage(stage, actionName), 0f, 100f, "HeadControlRatio", stage, actionName);
				}
			}

			MakeVariableSlider("Sound Pitch", sound.headAudioSource.pitch, 0.8f, 1.5f, "General", "Sound Pitch");
			MakeVariableSlider("Sound Volume", sound.headAudioSource.volume, 0.0f, 1.5f, "General", "Sound Volume");
			MakeVariableSlider("Playback Rate: Breath", sound.GetFrequency("breath"), 0.001f, 1.0f, "General", "Playback Rate: Breath");
			MakeVariableSlider("Playback Rate: Moan"  , sound.GetFrequency("moan"),   0.001f, 1.0f, "General", "Playback Rate: Moan");
			MakeVariableSlider("Playback Rate: Climax", sound.GetFrequency("climax"), 0.001f, 1.0f, "General", "Playback Rate: Climax");

			MakeVariablesSliderThresholds();

			if(core.addon1ModeOn){
				MakeVariableSlider("Undress Power", core.addonManager1.undressPower, 0f, 5f, "General", "UndressPower");
				MakeVariableSlider("Undress Duration", core.addonManager1.undressSeconds, 0f, 15f, "General", "UndressDuration");
			}

			//setupUISliders3
			if(core.orgasmModeOn){
				MakeVariableSlider("Orgasm Strength Max", core.orgasmStrengthMax, 0f, 5f, "Orgasm", "OrgasmStrength");
				MakeVariableSlider("Afterglow Strength Max", core.afterglowStrengthMax, 0f, 5f, "Orgasm", "AfterglowStrength");
				MakeVariableSlider("Orgasm Wave Big Cycle Count Max", core.orgasmWaveCycleBigMax, 0f, 1000f, "Orgasm", "WaveBigCycleMax");
				MakeVariableSlider("Orgasm Wave Big Cycle Count Min", core.orgasmWaveCycleBigMin, 0f, 1000f, "Orgasm", "WaveBigCycleMin");
				MakeVariableSlider("Orgasm Wave Small Cycle Count Max", core.orgasmWaveCycleSmallMax, 0f, 1000f, "Orgasm", "WaveSmallCycleMax");
				MakeVariableSlider("Orgasm Wave Small Cycle Count Min", core.orgasmWaveCycleSmallMin, 0f, 1000f, "Orgasm", "WaveSmallCycleMin");
				MakeVariableSlider("Orgasm Afterglow Big Cycle Count Max", core.orgasmAfterglowCycleBigMax, 0f, 1000f, "Orgasm", "AfterglowBigCycleMax");
				MakeVariableSlider("Orgasm Afterglow Big Cycle Count Min", core.orgasmAfterglowCycleBigMin, 0f, 1000f, "Orgasm", "AfterglowBigCycleMin");
				MakeVariableSlider("Orgasm Afterglow Small Cycle Count Max", core.orgasmAfterglowCycleSmallMax, 0f, 1000f, "Orgasm", "AfterglowSmallCycleMax");
				MakeVariableSlider("Orgasm Afterglow Small Cycle Count Min", core.orgasmAfterglowCycleSmallMin, 0f, 1000f, "Orgasm", "AfterglowSmallCycleMin");
				MakeVariableSlider("Orgasm Wave Big Cycle Interval Max", core.orgasmWaveCycleIntervalBigMax, 0f, 1000f, "Orgasm", "WaveBigCycleIntervalMax");
				MakeVariableSlider("Orgasm Wave Small Cycle Interval Max", core.orgasmWaveCycleIntervalSmallMax, 0f, 1000f, "Orgasm", "WaveSmallCycleIntervalMax");
				MakeVariableSlider("Orgasm Afterglow Big Cycle Interval Max", core.orgasmAfterglowCycleIntervalBigMax, 0f, 1000f, "Orgasm", "AfterglowBigCycleIntervalMax");
				MakeVariableSlider("Orgasm Afterglow Small Cycle Interval Max", core.orgasmAfterglowCycleIntervalSmallMax, 0f, 1000f, "Orgasm", "AfterglowSmallCycleIntervalMax");

				MakeVariableSlider("Shivering Strength for Finger Low Max",  bodyMorph.strengthFingerLowMax,         0f, 1f, "BodyMorphStrength", "Shivering Strength for Finger Low Max" );
				MakeVariableSlider("Shivering Strength for Finger High Max", bodyMorph.strengthFingerHighMax,        0f, 1f, "BodyMorphStrength", "Shivering Strength for Finger High Max");
				MakeVariableSlider("Shivering Strength for Body Low Max",    bodyMorph.strengthShiveringLowMax,      0f, 1f, "BodyMorphStrength", "Shivering Strength for Body Low Max"   );
				MakeVariableSlider("Shivering Strength for Body High Max",   bodyMorph.strengthShiveringHighMax,     0f, 1f, "BodyMorphStrength", "Shivering Strength for Body High Max"  );
				MakeVariableSlider("Shivering Strength for Random Max",      bodyMorph.strengthShiveringIntervalMax, 0f, 1f, "BodyMorphStrength", "Shivering Strength for Random Max"     );
				
				MakeVariableSlider("Shivering Strength for Finger Low Min",  bodyMorph.strengthFingerLowMin,         0f, 1f, "BodyMorphStrength", "Shivering Strength for Finger Low Min" );
				MakeVariableSlider("Shivering Strength for Finger High Min", bodyMorph.strengthFingerHighMin,        0f, 1f, "BodyMorphStrength", "Shivering Strength for Finger High Min");
				MakeVariableSlider("Shivering Strength for Body Low Min",    bodyMorph.strengthShiveringLowMin,      0f, 1f, "BodyMorphStrength", "Shivering Strength for Body Low Min"   );
				MakeVariableSlider("Shivering Strength for Body High Min",   bodyMorph.strengthShiveringHighMin,     0f, 1f, "BodyMorphStrength", "Shivering Strength for Body High Min"  );
				MakeVariableSlider("Shivering Strength for Random Min",      bodyMorph.strengthShiveringIntervalMin, 0f, 1f, "BodyMorphStrength", "Shivering Strength for Random Min"     );

				MakeVariableSlider("Ease of Re-Climax", 0.7f , 0f, 1f, "Orgasm", "Ease of Re-Climax");
			}
			
			SetupUIVariableEM1();
			SetupUIVariableEM2();
			SetupUIVariableEM3();
			
		}
				
				
		public void MakeVariablesSliderThresholds(){
			string tag = "threshold";
			for(int i = 0; i < 6; i++){
				int num = i;
				string key = MakeName("slider", tag, i);
				MakeVariableSliderNoFunc(key, (float)stageThreshold[num], 0f, 100f);
				dJSSlider[key].setCallbackFunction = (float value) => {
					stageThreshold[num] = (int)value;
					stageThresholdInGame[num] = stageThreshold[num] * core.ecstasyScale;
					settings["StageThreshold"][("Threshold" + num)]["Value"] = value.ToString();
//					SaveConfig();
				};
			}
		}
		
		public void SetupUIActionButtons(){
			MakeUIPartButton("Load Default", false, Color.cyan);
			MakeUIPartButton("Save Configuration", true, Color.cyan);
			MakeUIPartToggle("Debug Message Off", true);
			MakeUIPartToggle("Display UI Menu", false);
			if(core.orgasmModeOn){
				MakeUIPartButton("Make her Orgasm", false, Color.cyan);
				MakeUIPartButton("Stop her Orgasm", true, Color.cyan);
			}
			MakeUIPartSpacer("spacer01", "SectionSeparator", false);			
			MakeUIPartSpacer("spacer02", "SectionSeparator", true);			
		}

		public void SetupUIToggleButtons(){
			MakeUIPartToggle("Auto Expression Off", false);
			MakeUIPartToggle("Auto Blink Off", true);
			MakeUIPartToggle("Expression On", false);
			MakeUIPartSpacer("spacer16", "ButtonSkip", true);
			MakeUIPartToggle("Eyes Control On", false);
			MakeUIPartToggle("Eyes Rollup On", true);
			MakeUIPartToggle("Tears On", false);
			MakeUIPartToggle("Drool On", false);
			MakeUIPartPopup("Tears Type", true);
			MakeUIPartSpacer("spacer12", 2f, true);			
			MakeUIPartToggle("Sound On", false);
			MakeUIPartToggle("Use VAMMoan for Sound", true);
			
//			MakeUIPartSpacer("spacer17", 36f, false);			
//			MakeUIPartSpacer("spacer17", "ButtonAndSectionSeparator", true);
			
			MakeUIPartToggle("Nipple Erection On", false);
			MakeUIPartToggle("Clitoris Erection On", true);
			MakeUIPartToggle("Peeing On", false);
			MakeUIPartToggle("Head Motion On", true);
			MakeUIPartToggle("2x Collider Radius", false);
//			MakeUIPartToggle("AutoStop OtherPlugins", true);
			// MakeUIPartToggle("Sensitive Trigger", true);
			MakeUIPartToggle("Penis Support", false);
			MakeUIPartSpacer("spacer17", "ButtonSkip", true);
			MakeUIPartToggle("Collision Failure Check", false );
			MakeUIPartToggle("Collision Auto Fix", true );
			MakeUIPartToggle("HeadMotionOff During Possession", true);
			//			MakeUIPartSpacer("spacer13", "ButtonSkip", true);

			MakeUIPartToggle("Blush On", false);
			MakeUIPartPopup("Blush Type", false);
			MakeUIPartButton("Default Color", false);
//			MakeUIPartSpacer("spacer11", 37f, false);
			MakeUIPartStringAndVariable("Exp:Blush Color",
				"Pick a Blush Color.\n(The Blush will be attached for a few seconds as a reference image, then automatically removed.) "
				, false, colorYellow, 137f);
			MakeUIPartColor("Blush Color", true);
			MakeUIPartSpacer("spacer14", "SectionSeparator", false);
			MakeUIPartSpacer("spacer15", "SectionSeparator", true);
		}

		public void MakeVariableForShortcut(){
			if(worldUi.ButtonStructDic == null) {
				core.worldUi.MakeStructureNormalButton();
			}
			var list = new List<string>(){""};
			list.AddRange(worldUi.ButtonStructDic.Keys.ToList<string>());
			
			for(int i = 0; i < shortcutMax; i++){
				var key = GetShortcutKey(i);
				var value = jsShortcutDic.ContainsKey(key) ? jsShortcutDic[key].val : "";
				MakeVariablePopup(key, list, value);
			}
		}			

		public void SetupUIShortcut(){
			if(worldUi.ButtonStructDic == null) {
				core.worldUi.MakeStructureNormalButton();
			}

			for(int i = 0; i < shortcutMax; i++){
				var OddEven = (i % 2) != 0;
				var key = GetShortcutKey(i);
				MakeUIPartPopup(key, OddEven);
			}
		}

		public void SetupUIToggleUndress(){
			MakeUIPartButton("Hint:RemoveOptions", false, colorYellow, "Help for this setting...");
			MakeUIPartSpacer("spacerU1", "ButtonSkip", true);
			MakeUIPartToggle("Forced Undress", false);
			MakeUIPartToggle("Reverse Gravity", true);
			MakeUIPartToggle("Undress Detach", false);
			MakeUIPartToggle("Undress CUAs Exclude Head",  true);
			// MakeUIPartSpacer("spacerU4", "ButtonSkip", true);
			MakeUIPartSlider("Undress Power", false);
			MakeUIPartSlider("Undress Duration", true);

			MakeUIPartToggle("Alter SkinWrap to ClothSim", false);
			MakeUIPartToggle("Hold Clothes containing NGWords", true);			
			MakeUIPartToggle("Hold Clothes with ClothSim", false);
			MakeUIPartToggle("Hold Clothes with AlterSkinWrap", true);
			
			MakeUIPartSpacer("spacerU2", "SectionSeparator", false);
			MakeUIPartSpacer("spacerU3", "SectionSeparator", true);
		}
		
		public void SetupUIToggle2(){
			MakeUIPartToggle("Shivering during climax(bone)",     false, "Enable Shivering(bone) in climax.");
			MakeUIPartToggle("Shivering during climax(morph)",    true,  "Enable Shivering(morph) in climax.");
			
			// MakeUIPartToggle("BodyMorph:Fingers",    true , "Enable Morph: Fingers");
			MakeUIPartToggle("BodyMorph:Shivering1", false, "Enable Morph: Shivering1");
			MakeUIPartToggle("BodyMorph:Shivering2", true , "Enable Morph: Shivering2");
			MakeUIPartToggle("BodyMorph:ShiveringP", false, "Enable Morph: ShiveringP");
			MakeUIPartToggle("BodyMorph:Anus",       true, "Enable Morph: Anus");
			
			// MakeUIPartSpacer("spacer60","ButtonSkip", true);
			MakeUIPartSpacer("spacer61","SectionSeparator", false);
			MakeUIPartSpacer("spacer62","SectionSeparator", true);
		}
		
		public void SetupUIToggle3(){
			MakeUIPartToggle("Armbinder By Hand", false);
			MakeUIPartToggle("Armbinder By Beam", true );
			MakeUIPartToggle("Legbinder By Hand", false);
			MakeUIPartToggle("Legbinder By Beam", true );
			MakeUIPartToggle("Covering Actions All", false );
			MakeUIPartToggle("Cover with Hands", true );
			MakeUIPartToggle("Close Legs", false );
			MakeUIPartToggle("Cover Mouth", true );
			MakeUIPartToggle("Select One Arm Each", false);
			MakeUIPartToggle("CUA Collision", true);
			MakeUIPartToggle("CUA Speed Randomizer", false);
			MakeUIPartSpacer("spacer73","ButtonSkip", true);

			MakeUIPartSlider("CUA Random Speed Min", false);
			MakeUIPartSlider("CUA Random Speed Max", true);

			MakeUIPartSlider("CustomUnityAsset Scale", false);
			MakeUIPartSlider("Mouth Cover Event Ratio", true);
			// MakeUIPartSpacer("spacer70", "SliderSkip", true);
			
			MakeUIPartSpacer("spacer71","SectionSeparator", false);
			MakeUIPartSpacer("spacer72","SectionSeparator", true);
		}
		
		public void SetupUISliders1(){
			MakeUIPartSlider("Expression Strength", false);
			MakeUIPartSlider("Ecstasy Scale", true);

			MakeUIPartSlider("Eyes Control interval Time", false);
			MakeUIPartSlider("BodyMorph Duration Time", true);
			MakeUIPartSlider("Blush Duration Time", false);
			MakeUIPartSlider("Tears Duration Time", true);
			
			MakeUIPartSlider("Breath Strength", false);
			MakeUIPartSlider("Peeing Ratio", true);
			
			MakeUIPartSlider("Delayed Synchronous Interval", false);
			MakeUIPartSpacer("spacer20", "SliderSkip", true);
			
			MakeUIPartSlider("Default Canvas Position Up"      , false);
			MakeUIPartSlider("Default Canvas Position Right"   , true);
			MakeUIPartSlider("Default Canvas Position Forward" , false);
			MakeUIPartSpacer("spacer23", "SliderSkip", true);
			
			MakeUIPartSpacer("spacer21", "SectionSeparator", false);
			MakeUIPartSpacer("spacer22", "SectionSeparator", true);
		}

		public void SetupUISliders2(){
			MakeUIPartButton("Undress All", false);
			MakeUIPartSpacer("spacer34", "ButtonSkip", true);
			
			string tag = "threshold";
			string expPrefix = "Settings for each Stage Threshold";
			string expSuffix = "For each stage, you can set the threshold(0 ~ 100) and the clothes you want the character to equip with this menu. In this Plug-in, tears and drool are implemented as clothes.";
			
			for(int i = 0; i < 6; i++){
				int num = i;
				string textKey = MakeName("text", tag, i);
				string sliderKey = MakeName("slider", tag, i);
				string explanation = "<b>" + expPrefix + num + ":</b>\n" + expSuffix;
				MakeUIPartStringAndVariable(textKey, explanation, false);
				MakeUIPartSlider(sliderKey, true, "Stage" + num + " Threshold:");
				MakeUIPartButtonNoFunc("Set Stage" + num + " clothes", true);
				dUIButton["Set Stage" + num + " clothes"].button.onClick.AddListener(() =>{
					tears.SetClothes(num);
					List<string> tmpClothUids = tears.GetClothUids(num);
					for(int j = 0; j < tmpClothUids.Count; j++){
						settings["StageThreshold"][("Threshold" + num)]["Clothes"][j] = tmpClothUids[j];
					}
//					SaveConfig();
				});	
				
				MakeUIPartButtonNoFunc("Reset Stage" + num + " clothes", true);
				dUIButton["Reset Stage" + num + " clothes"].button.onClick.AddListener(() =>{
					tears.ClearClothes(num);
					settings["StageThreshold"][("Threshold" + num)]["Clothes"] = new JSONArray();						
//					SaveConfig();
				});	
				
				MakeUIPartButtonNoFunc("Test Stage" + num + " clothes", true);
				dUIButton["Test Stage" + num + " clothes"].button.onClick.AddListener(() =>{
					tears.EquipClothes(num);
				});	
				
				MakeUIPartSpacer(MakeName("spacer", tag, i), 35f, false);
				MakeUIPartButtonNoFunc("Show Clothes for Stage" + num, false);
				dUIButton["Show Clothes for Stage" + num].button.onClick.AddListener(() =>{
					SuperController.LogMessage("Clothes for Stage" + num + ":");
					tears.ShowClothes(num);
				});	
			}
			
//			MakeUIPartSpacer("spacer31", "SliderSkip", true);
			MakeUIPartSpacer("spacer32", "SectionSeparator", false);
			MakeUIPartSpacer("spacer33", "SectionSeparator", true);
		}
		
		//unko
		public void MakeMorphCategories(){
			DAZCharacterSelector character = core.atom.GetStorableByID("geometry") as DAZCharacterSelector;
			GenerateDAZMorphsControlUI morphControl = character.morphsControlUI;
			morphControl.showType = GenerateDAZMorphsControlUI.ShowType.MorphAndPose;				
			
			Dictionary<string, bool> dCategoryPair  = null;
			Dictionary<string, bool> dCategoryBoth  = new Dictionary<string, bool>();
			Dictionary<string, bool> dCategoryPose  = new Dictionary<string, bool>();
			Dictionary<string, bool> dCategoryMorph = new Dictionary<string, bool>();
			Dictionary<string, Dictionary<string, bool>> dMorphPair   = null;
			Dictionary<string, Dictionary<string, bool>> dMorphBoth  = new Dictionary<string, Dictionary<string, bool>>();
			Dictionary<string, Dictionary<string, bool>> dMorphPose  = new Dictionary<string, Dictionary<string, bool>>();
			Dictionary<string, Dictionary<string, bool>> dMorphMorph = new Dictionary<string, Dictionary<string, bool>>();
			List<string> mCategoryPair = null;
			mCategoryBoth  = new List<string>();
			mCategoryPose  = new List<string>();
			mCategoryMorph = new List<string>();
			Dictionary<string, List<string>> mMorphPair = null;
			mMorphBoth  = new Dictionary<string, List<string>>();
			mMorphPose  = new Dictionary<string, List<string>>();
			mMorphMorph = new Dictionary<string, List<string>>();
			
			//Too Heavy
			/*
			string[] defaultKeys = {"All", "Builtin", "Custom"};
			foreach(var group in defaultKeys){
				dMorphBoth.Add (group, new Dictionary<string, bool>());
				dMorphPose.Add (group, new Dictionary<string, bool>());
				dMorphMorph.Add(group, new Dictionary<string, bool>());
			}
			*/
			
			foreach(var morph in morphControl.GetMorphs()){
				string group = morph.region;
				string bcKey = morph.uid.Contains("/") ? "Custom" : "Builtin";
				dMorphPair = morph.isPoseControl ? dMorphPose : dMorphMorph;
				mMorphPair = morph.isPoseControl ? mMorphPose : mMorphMorph;
				dCategoryPair = morph.isPoseControl ? dCategoryPose : dCategoryMorph;
				mCategoryPair = morph.isPoseControl ? mCategoryPose : mCategoryMorph;
				
				if(!dCategoryBoth.ContainsKey(group)) dCategoryBoth.Add(group, true);
				if(!dCategoryPair.ContainsKey(group)) dCategoryPair.Add(group, true);
				//Too Heavy
				/*
				if(!dMorphBoth["All"].ContainsKey(morph.displayName)) dMorphBoth["All"].Add(morph.displayName, true);
				if(!dMorphPair["All"].ContainsKey(morph.displayName)) dMorphPair["All"].Add(morph.displayName, true);
				if(!dMorphPair[bcKey].ContainsKey(morph.displayName)) dMorphPair[bcKey].Add(morph.displayName, true);
				if(!dMorphBoth[bcKey].ContainsKey(morph.displayName)) dMorphBoth[bcKey].Add(morph.displayName, true);
				*/
				if(!dMorphBoth.ContainsKey(group)) dMorphBoth.Add(group, new Dictionary<string, bool>());
				if(!dMorphPair.ContainsKey(group)) dMorphPair.Add(group, new Dictionary<string, bool>());
				if(!dMorphBoth[group].ContainsKey(morph.displayName)) dMorphBoth[group].Add(morph.displayName, true);
				if(!dMorphPair[group].ContainsKey(morph.displayName)) dMorphPair[group].Add(morph.displayName, true);
			}
			
			mCategoryBoth  = MakeCategoryList(new List<string>(dCategoryBoth.Keys));
			mCategoryPose  = MakeCategoryList(new List<string>(dCategoryPose.Keys));
			mCategoryMorph = MakeCategoryList(new List<string>(dCategoryMorph.Keys));

			mMorphBoth  = MakeNameList(mCategoryBoth , dMorphBoth);
			mMorphPose  = MakeNameList(mCategoryPose , dMorphPose);
			mMorphMorph = MakeNameList(mCategoryMorph, dMorphMorph);
		}
		
		public List<string> MakeCategoryList(List<string> mList){
			List<string> result = new List<string>(mList);
			result.Sort();
//Too Heavy			
//			result.Insert(0, "Custom");
//			result.Insert(0, "Builtin");
//			result.Insert(0, "All");
			return result;
		}
		
		public Dictionary<string, List<string>> MakeNameList(List<string> groups, Dictionary<string, Dictionary<string, bool>> dMorph){
			Dictionary<string, List<string>> result = new Dictionary<string, List<string>>();
			foreach(var group in groups){
				result.Add(group, new List<string>(dMorph[group].Keys));
				result[group].Sort();
			}
			return result;
		}
		
		public void SetShowType(string type){
			DAZCharacterSelector character = core.atom.GetStorableByID("geometry") as DAZCharacterSelector;
			GenerateDAZMorphsControlUI morphControl = character.morphsControlUI;
			morphControl.showType = (GenerateDAZMorphsControlUI.ShowType)Enum.Parse(typeof(GenerateDAZMorphsControlUI.ShowType), type);
		}

		public void PopupSelectShwoType(string choice){
			choiceShowtype = choice;
			if(dJSPopup.ContainsKey("Morph Category")){
				JSONStorableStringChooser jssc = dJSPopup["Morph Category"];
				SetMorphCategory(jssc, choice, filterCategory);
			}
		}
		
		public void SetMorphCategory(JSONStorableStringChooser jssc, string choice, string filter){
			string currentSelection = jssc.val;
			jssc.choices = GetCurrentCategoryList(choice, filter);
			if(jssc.choices.Count != 0){
				if(jssc.choices.Contains(currentSelection)){
					jssc.val = currentSelection;
				}else{
					jssc.val = jssc.choices[0];
				}
			}else{
				jssc.val = "(nothing)";
			}
		}
		
		public void PopupSelectCategory(string choice){
			try{				
				choiceCategory = choice;
				if(dJSPopup.ContainsKey("Morph Name")){
					JSONStorableStringChooser jssc = dJSPopup["Morph Name"];
					SetMorphName(jssc, choice, filterName);
				}
			}catch(Exception e){
				core.LoggerE(e);
			}
		}
		
		public void SetMorphName(JSONStorableStringChooser jssc, string choice, string filter){
			try{
				string currentSelection = jssc.val;
				jssc.choices = GetCurrentNameList(choiceCategory, filter);
				if(jssc.choices.Count != 0){
					if(jssc.choices.Contains(currentSelection)){
						jssc.val = currentSelection;
					}else{
						jssc.val = jssc.choices[0];
					}
				}else{
					jssc.val = "(nothing)";
				}
			}catch(Exception e){
				core.LoggerE(e);
			}
		}
		
		public void PopupSelectEyesDirection(string name, string choice){
			string[] words = name.Split(':');
			string level = words[1];
			string expression = words[2];
			
		}
		
		public List<string> GetCurrentCategoryList(string choice, string filter = ""){
			List<string> mCategoryAny = mCategoryBoth;
			if(choice != "MorphAndPose") mCategoryAny = (choice == "Pose") ? mCategoryPose : mCategoryMorph;
			if(filter != "")
				return mCategoryAny.FindAll(x => x.Contains(filter));				
			else
				return mCategoryAny; 
		}
		
		public List<string> GetCurrentNameList(string choice, string filter = ""){
			Dictionary<string, List<string>> mMorphAny = mMorphBoth;
			if(choiceShowtype != "MorphAndPose") mMorphAny = (choiceShowtype == "Pose") ? mMorphPose : mMorphMorph;
			if(!mMorphAny.ContainsKey(choice)){
				return new List<string>();
			}else{
				if(filter != "")
					return mMorphAny[choice].FindAll(x => x.Contains(filter));
				else
					return mMorphAny[choice];
			}
		}
		
		public void MorphNameUpdate(string choice){
			if(dJSPopup.ContainsKey("Morph Name")){
				if(dUISlider.ContainsKey("Test Morph")){
					LabelUpdate(dUISlider["Test Morph"], "Demo Morph: " + dJSPopup["Morph Name"].val);
					dJSSlider["Test Morph"].val = 0f;
				}
				if(dUIButton.ContainsKey("Entry Morph")){
					LabelUpdate(dUIButton["Entry Morph"], "Register Morph: " + dJSPopup["Morph Name"].val);
				}
				
				DAZCharacterSelector character = core.atom.GetStorableByID("geometry") as DAZCharacterSelector;
				GenerateDAZMorphsControlUI morphControl = character.morphsControlUI;
				string morphName = dJSPopup["Morph Name"].val;
				morphCurrent = morphControl.GetMorphByDisplayName(morphName);
				if(morphOld != null){
					morphOld.SetValue(0.000001f);
					morphOld.SetValue(0.0f);
				}
				morphOld = morphCurrent;
			}
		}
		
		public void SetupUIVariableEM1(){
			List<string> eyesDirection = new List<string>(){"Up", "Down", "Left", "Right", "Neutral", "Random"};
			
			MakeMorphCategories();
			List<string> showType = Enum.GetNames(typeof(GenerateDAZMorphsControlUI.ShowType)).ToList();
			MakeVariablePopup("Show Type", showType, "MorphAndPose");
			MakeVariablePopup("Morph Category", mCategoryBoth, "Pose/Head/Expressions/Custom");
			MakeVariablePopup("Morph Name", mMorphBoth["Pose/Head/Expressions/Custom"], "CTY_Orgasm_EO_MO_01");
			MakeVariableSliderNoFunc("Test Morph", 0f, 0f, 1.0f);
			MakeVariablePopup("Gaze(Eyes) Direction", eyesDirection, "Random");
		}
		
		public void SetupUIVariableEM2(){
		}
		
		public void SetupUIVariableEM3(){
		}
		
		//unko
		public void SetupUIEM1(){
			try{
				string message1 = "STEP1-1: Select Morph Type.";
				string message2 = "STEP1-2: Select Morph Category.";
				string message3 = "STEP1-3: Select Morph Name.";
				string message4 = "STEP1-4: Demonstrate Morph (if needed).";
				string message5 = "STEP1-5: Select Gaze(Eyes) Direction.";
				string message6 = "STEP1-6: Register Morph. (if needed)";
				string message7 = "STEP1-7: Test or Deregister Morph.";


				MakeUIPartPopup("Show Type", false);
				MakeUIPartStringAndVariable("Exp:Show Type", message1, true, colorYellow, "PopupSkip", 24);
				
				MakeUIPartPopup("Morph Category", false, true);
				MakeUIPartStringAndVariable("Exp:Morph Category", message2, true, colorYellow, "PopupFilterableSkip", 24);
				
				MakeUIPartPopup("Morph Name", false, true);
				MakeUIPartStringAndVariable("Exp:Morph Name", message3, true, colorYellow, "PopupFilterableSkip", 24);
				
				MakeUIPartSlider("Test Morph", false);
				MakeUIPartStringAndVariable("Exp:Test Morph", message4, true, colorYellow, "SliderSkip", 24);
				
				MakeUIPartPopup("Gaze(Eyes) Direction", false);
				MakeUIPartStringAndVariable("Exp:Gaze(Eyes) Direction", message5, true, colorYellow, "PopupSkip", 24);
				
				MakeUIPartButton("Entry Morph", false, colorGreen);
				MakeUIPartStringAndVariable("Exp:Entry Morph:", message6, true, colorYellow, "ButtonSkip", 24);
				MakeUIPartSpacer("dummy space1", "SectionSeparator", false);
				MakeUIPartSpacer("dummy space2", "SectionSeparator", true);

				MakeUIPartStringAndVariable("Exp:TestOrDeregister:", message7, false, colorYellow, "ButtonSkip", 24);
				MakeUIPartSpacer("dummy space3", "ButtonSkip", true);
				/*
				MakeUIPartStringAndVariable("Category Filter:", "Filter:(type key word and press enter)", 
											true, Color.clear, 35f);
				MakeUIPartInputTextAndVariable("Category Filter", "", 
												true, fHeight:50, fontSize:32);
				dInput["Category Filter"].onEndEdit.AddListener((string value) => {
					filterCategory = value;
					SetMorphCategory(dJSPopup["Morph Category"], dJSPopup["Morph Category"].val, value);
				});
				
				MakeUIPartStringAndVariable("Name Filter:", "Filter:(type key word and press enter)",
											true, Color.clear, 35f);
				MakeUIPartInputTextAndVariable("Name Filter", "",
												true, fHeight:50f, fontSize:32);
				dInput["Name Filter"].onEndEdit.AddListener((string value) => {
					filterName = value;
					SetMorphName(dJSPopup["Morph Name"], dJSPopup["Morph Name"].val, value);
				});
				*/

				//				MakeUIPartSpacer("spacerEM12", 105f, true);

				MorphNameUpdate(choiceName);
				
				foreach(var name in core.expression2.GetSpecialExpressions()){
					string key1 = "SPEXTEST:" + name;
					if(!dJSSlider.ContainsKey(key1)){
						MakeVariableSliderNoFunc(key1, 0f, 0f, 1.0f);
					}
					MakeUIPartSlider(key1, false, ("Demo Morph(" + core.expression2.GetEyesDirection(name) + "): " + name));
					dJSSlider[key1].slider.onValueChanged.AddListener((float value) =>{
						DAZMorph morph = Utility.GetMorphByDisplayName(core.atom, name);
						morph.SetValue(value);
					});
					dUISlider[key1].defaultButton.onClick.AddListener(() => {
						DAZMorph morph = Utility.GetMorphByDisplayName(core.atom, name);
						morph.SetValue(0.000001f);
					});
										
					
					string key3 = "SPEXTST3:" + name;
					MakeUIPartButton(key3, true, colorGreen, "Test:" + name + " + eyes:" + core.expression2.GetEyesDirection(name));
					/*
					string key3 = "SPEXTEXT:" + name;
					MakeUIPartStringAndVariable(key3, "Deregister morph if you don't need it.",
												true, Color.clear, 35f);
					*/
					string displayName = "Deregister: " + name;
					string key4 = "DELSPEX:" + name;
					MakeUIPartButton(key4, true, colorRed, displayName);
					MakeUIPartSpacer("SPEXSPAC:" + name, 5f, true);
					MakeUIPartSpacer("SPEXSPA2:" + name, 0f, false);
				}
				MakeUIPartSpacer("dummy space4", "SectionSeparator", false);
				MakeUIPartSpacer("dummy space5", "SectionSeparator", true);
				
			}catch(Exception e){
				core.LoggerE(e);
			}
		}
		
		public void SetupUIEM2(){
			string message1 = "STEP2: Associate Morph with Level.";
			MakeUIPartStringAndVariable("Exp:STEP2:", message1, false, colorYellow, 100f, 28);
			MakeUIPartSpacer("dummy space6", 100f, true);

			JSONClass jsc = core.settingsRoot["Common"]["SpecialExpression"]["LevelVsExpression"].AsObject;
			foreach(var lv in ExpreLevelValue.Keys.ToList()){
				int i = 0;
				string key2 = "SPEXLVTL:" + lv;
				string key3 = "SPEXLVTR:" + lv;
				MakeUIPartStringAndVariable(key2, ExpreLevelDisp[lv], false, Color.clear, fHeight:35f);
				MakeUIPartSpacer("dummy space2" + lv, 35f, true);
				foreach(var name in core.expression2.GetSpecialExpressions()){
					string key1 = "SPEXTOGL:" + lv + ":" + name;
					MakeVariableToggle(key1, jsc[lv][name].AsBool);
					MakeUIPartToggle(key1, (i%2 == 1), lv + ", " + name + "(" + core.expression2.GetEyesDirection(name) + ")");
					i++;
				}
				if(i%2 == 1){
					string key9 = "SPEXSPC2:" + lv;
					MakeUIPartSpacer(key9, "ButtonSkip", true);
				}
			}
		}
		
		public void SetupUIEM3(){
			string message1 = "STEP3: Set the frequency, and test if needed. If set to 1, Special Expression are always used.";
			MakeUIPartStringAndVariable("Exp:STEP3:", message1, false, colorYellow, 100f, 28);
			MakeUIPartSpacer("dummy space30", 100f, true);
			JSONClass jsc = core.settingsRoot["Common"]["SpecialExpression"]["LevelVsRatio"].AsObject;
			foreach(var lv in ExpreLevelValue.Keys.ToList()){
				string key2 = "SPEXLVTL2:" + lv;
				string key3 = "SPEXLVTR2:" + lv;
				MakeUIPartStringAndVariable(key2, ExpreLevelDisp[lv], false, Color.clear, fHeight:35f);
				
				MakeUIPartSpacer(("SPEXSPC4:" + lv), 35f, true);
				MakeUIPartSpacer(key3, 55f, true);
				//MakeUIPartStringAndVariable(key3, "Set the frequency, and test if needed. If set to 1, Special Expression are always used.",
				//							true,  Color.clear, 55f, 24);
				float value = core.expression2.dLvlVsRatioTable[lv];
				MakeVariableSlider((lv + ":Frequency"), value, 0f, 1f, "Common", "SpecialExpression", "LevelVsRatio", lv);
				MakeUIPartSlider((lv + ":Frequency"), false);
				MakeUIPartButton(("SPEXTST2:" + lv), true, (lv + ": Test Button"));
			}
		}
		
		public void RemoveAll(){
			RemoveUIs(dUISpacer.Keys.ToList());
			RemoveUIs(dUIButton.Keys.ToList());
			RemoveUIs(dUISlider.Keys.ToList());
			RemoveUIs(dUIString.Keys.ToList());
			RemoveUIs(dUIToggle.Keys.ToList());
			RemoveUIs(dUIPopup.Keys.ToList());
			RemoveUIs(dUIColor.Keys.ToList());
		}

		public void RemoveUIEM1(){
			string[] names = {
				"TestEM1", "TestEM1a", "TestEM1b",
				"spacerEM10",  "spacerEM11",  "spacerEM12", "spacerEM19",
				"Category Filter", "Name Filter", "Entry Morph:", 
				"Category Filter:", "Name Filter:", 
				"Test Morph", "Entry Morph",
				"Morph Category", "Show Type", "Morph Name", 
			};
			RemoveUIs(names);
			
			List<string> names2 = new List<string>();
			foreach(var name in core.expression2.GetSpecialExpressions()){
				names2.Add("DELSPEX:" + name);
				names2.Add("SPEXTEST:" + name);
				names2.Add("SPEXTEXT:" + name);
				names2.Add("SPEXSPAC:" + name);
			}
			RemoveUIs(names2);
		}
		
		public void RemoveUIEM2(){
			string[] names = {
				"TestEM2", "spacerEM20",
			};
			RemoveUIs(names);
			
			List<string> names2 = new List<string>();
			foreach(var lv in ExpreLevelValue.Keys.ToList()){
				names2.Add("SPEXLVTL:" + lv);
				names2.Add("SPEXLVTR:" + lv);
				names2.Add("SPEXSPC2:" + lv);
				names2.Add("SPEXSPC3:" + lv);
				
				foreach(var name in core.expression2.GetSpecialExpressions()){
					names2.Add("SPEXTOGL:" + lv + ":" +name);
					names2.Add("SPEXPOPU:" + lv + ":" +name);
				}
			}
			RemoveUIs(names2);
		}
		
		public void RemoveUIEM3(){
			List<string> names = new List<string>();
			foreach(var lv in ExpreLevelValue.Keys.ToList()){
				string key2 = "SPEXLVTL2:" + lv;
				string key3 = "SPEXLVTR2:" + lv;
				string key4 = lv + ":Frequency";
				string key5 = "SPEXTST2:" + lv;
				string key1 = "SPEXSPC4:" + lv;
				names.Add(key1);
				names.Add(key2);
				names.Add(key3);
				names.Add(key4);
				names.Add(key5);
			}
			RemoveUIs(names);
		}
		
		public void SetupUISliders4(){
			MakeUIPartButton("Test: Face Forward", false, new Color(1f, 0.7f, 0.9f, 1f));
			MakeUIPartSpacer("spacerH49", "ButtonSkip", true);
			MakeUIPartButton("Test: Turn Head Back 1", false, new Color(1f, 0.7f, 0.9f, 1f));
			MakeUIPartSlider("Turn Head Back 1 : axisPitch1", false);
			MakeUIPartButton("Test: Turn Head Back 2", true, new Color(1f, 0.7f, 0.9f, 1f));
			MakeUIPartSlider("Turn Head Back 2 : axisPitch1", true);
			
			MakeUIPartButton("Test: Glance",        false, new Color(1f, 0.7f, 0.9f, 1f));
			MakeUIPartSlider("Glance : axisPitch1", false);
			MakeUIPartSlider("Glance : axisPitch2", false);
			MakeUIPartSlider("Glance : axisRoll1",  false);
			MakeUIPartSlider("Glance : axisRoll2",  false);
			MakeUIPartSlider("Glance : axisYaw",    false);
			
			MakeUIPartButton("Test: Face Sideways 1",        true, new Color(1f, 0.7f, 0.9f, 1f));
			MakeUIPartSlider("Face Sideways 1 : axisPitch1", true);
			MakeUIPartSlider("Face Sideways 1 : axisPitch2", true);
			MakeUIPartSlider("Face Sideways 1 : axisRoll1",  true);
			MakeUIPartSlider("Face Sideways 1 : axisRoll2",  true);
			MakeUIPartSlider("Face Sideways 1 : axisYaw",    true);

			MakeUIPartButton("Test: Face Sideways 2",        false, new Color(1f, 0.7f, 0.9f, 1f));
			MakeUIPartSlider("Face Sideways 2 : axisPitch1", false);
			MakeUIPartSlider("Face Sideways 2 : axisPitch2", false);
			MakeUIPartSlider("Face Sideways 2 : axisRoll1",  false);
			MakeUIPartSlider("Face Sideways 2 : axisRoll2",  false);
			MakeUIPartSlider("Face Sideways 2 : axisYaw",    false);
			
			MakeUIPartButton("Test: Face Sideways 3",        true, new Color(1f, 0.7f, 0.9f, 1f));
			MakeUIPartSlider("Face Sideways 3 : axisPitch1", true);
			MakeUIPartSlider("Face Sideways 3 : axisPitch2", true);
			MakeUIPartSlider("Face Sideways 3 : axisRoll1",  true);
			MakeUIPartSlider("Face Sideways 3 : axisRoll2",  true);
			MakeUIPartSlider("Face Sideways 3 : axisYaw",    true);
		}

		public void SetupUISliders5(){
			MakeUIPartSlider("Cond1)Stage < 3 & Orgasm Count < 99", false);
			MakeUIPartSlider("Cond2)Stage < 5 & Orgasm Count < 99", true);
			MakeUIPartSlider("Cond3)Stage = 5 & Orgasm Count < 01", false);
			MakeUIPartSlider("Cond4)Stage = 5 & Orgasm Count < 03", true);
			MakeUIPartSlider("Cond5)Stage = 5 & Orgasm Count < 06", false);
			MakeUIPartSlider("Cond6)Stage = 5 & Orgasm Count < 09", true);
			MakeUIPartSlider("Cond7)Stage = 5 & Orgasm Count < 99", false);
			MakeUIPartSpacer("spacerI01", "SliderSkip", true);
		}
		
		//unko
		public void SetupUISliders6(){
			int n = 0;
			foreach(var stage in core.headController.ListStages()){
				n++;
				bool flag = (n % 2 == 0);
				string buttonName1 = "Test: " + n + ") Considering the Event Firing Ratio";
				MakeUIPartButton(buttonName1, flag, new Color(1f, 0.7f, 0.9f, 1f));
				string buttonName2 = "Test: " + n + ") Ignoring the Event Firing Ratio";
				MakeUIPartButton(buttonName2, flag, new Color(1f, 0.7f, 0.9f, 1f));
				foreach(var actionName in core.headController.ListActions()){
					string displayName = n + ")" + actionName;
					string paramName = "HC_RatioByStage_" + n + ")" + actionName;
					MakeUIPartSlider(paramName, flag, displayName);
				}
			}
//			MakeUIPartSpacer("spacerJ00", "SliderSkip", false);
//			MakeUIPartSpacer("spacerJ01", "SliderSkip", true);
		}
		
		public void MakeVariablesToggleAS2(){
			foreach(var name in core.settingsRoot["Common"]["PTMC On/Off"].AsObject.Keys){
				string key = "OnOrNot:" + name;
				MakeVariableToggle(key, core.settingsRoot["Common"]["PTMC On/Off"][name].AsBool);
			}
		}
		
		public void MakeVariablesToggleAS3(){
			try{
				
			foreach(var name in core.settingsRoot["Common"]["PTMC On/Off"].AsObject.Keys){
				if(name.StartsWith("General ")){
					continue;
				}
				string key = "ListOrNot:" + name;
				MakeVariableToggle(key, true);
			}
			
			foreach(var name in core.addonTakeControl.GetPluginList()){
				string key = "ListOrNot:" + name;
				MakeVariableToggle(key, false);
			}
			
			}catch(Exception e){
				core.LoggerE(e);
			}
		}
		
			
		public void MakeVariablesToggleAutoStopEditingIfNeeded(string name){
			string key = "ListOrNot:" + name;
			if(!dJSToggle.ContainsKey(key)){
				MakeVariableToggle(key, false);
			}
		}

		public void MakeVariablesToggleAS1(){
			MakeVariableToggle("OnOff:AutoStop Other Plugins", addonTakeControlItem.autoStopOnGlobal);
			MakeVariableToggle("OnOff:Stop Morph Control by non-plugins", addonTakeControlItem.autoStopMorphOnGlobal);
			MakeVariableToggle("OnOff:Stop Head Control by non-plugins", addonTakeControlItem.autoStopHeadOnGlobal);
			MakeVariableToggle("OnOff:Stop Body Control by non-plugins", addonTakeControlItem.autoStopBodyOnGlobal);			
		}
		
		public void SetupUIAS1(){
			string[] names = {
				"AutoStop Other Plugins",
				"Stop Morph Control by non-plugins",
				"Stop Head Control by non-plugins",
				"Stop Body Control by non-plugins",
			};
			
			Dictionary<string, string> hintNameMap = new Dictionary<string, string>(){
				{"AutoStop Other Plugins",                 "Hint1:[AS]AutoStop Other Plugins"},
				{"Stop Morph Control by non-plugins", "Hint1:[AS]Stop Morph Control by non-plugins"},
				{"Stop Head Control by non-plugins",   "Hint1:[AS]Stop Head Control by non-plugins"},
				{"Stop Body Control by non-plugins",   "Hint1:[AS]Stop Body Control by non-plugins"},
			};
			
			Dictionary<string, string> displayNameMap = new Dictionary<string, string>(){
				{"AutoStop Other Plugins",             "AutoStop Other Plugins"               },                
				{"Stop Morph Control by non-plugins",  "AutoStop Morph Control by non-plugins"},
				{"Stop Head Control by non-plugins",   "AutoStop Head Control by non-plugins" },
				{"Stop Body Control by non-plugins",   "AutoStop Body Control by non-plugins" },
			};
			
			foreach(var name in names){
				string key = "OnOff:" + name;
				MakeUIPartToggle(key, false, displayNameMap[name]);
				string key3 = hintNameMap[name];
				MakeUIPartButton(key3, true, new Color(255f/255f, 255f/255f, 180f/255f), "Help for this setting...");
			}
		}	
		
		public void SetupUIAS2(){
			Dictionary<string, string> displayNameMap = new Dictionary<string, string>(){
				{"[AS]Stop Morph Control by non-plugins","Stop Morph Control by non-plugins"},
				{"[AS]Stop Head Control by non-plugins" ,"Stop Head Control by non-plugins" },
				{"[AS]Stop Body Control by non-plugins" ,"Stop Body Control by non-plugins" },
			};
			
			Dictionary<string, string> hintNameMap = new Dictionary<string, string>(){
				{"[AS]Stop Morph Control by non-plugins","Help for this setting..."},
				{"[AS]Stop Head Control by non-plugins" ,"Help for this setting..."},
				{"[AS]Stop Body Control by non-plugins" ,"Help for this setting..."},
			};
			
			foreach(var name in core.settingsRoot["Common"]["PTMC On/Off"].AsObject.Keys){
				if(name == "General Timeline"){
					continue;
				}
				if(name.StartsWith("[AS]AutoStop")){
					continue;
				}
				string key = "OnOrNot:" + name;
				string displayName = (displayNameMap.ContainsKey(name)) ? displayNameMap[name] : name;
				MakeUIPartToggle(key, false, Color.white, displayName);
				string key2 = "Timing:" + name;
				string key3 = "Hint2:" + name;
				int timing = core.settingsRoot["Common"]["PTMC Timing"][name].AsInt;
				MakeVariablePopup(key2, stageOptions, stageOptions[timing], "AutoStop Timing");
				MakeUIPartPopup(key2, true);
				if(name.StartsWith("[AS]")){
					MakeUIPartButton(key3, false, colorYellow, hintNameMap[name]);
					MakeUIPartSpacer("spacer3b_" + name, 6f, false);				
					MakeUIPartSpacer("spacer3a_" + name, 21f, true);				
				}else{
					MakeUIPartSpacer("spacer3a_" + name, 35f, false);				
				}
			}
		}
		
		public void SetupUIAS3(){
			try{
				
			string ngWord = "Cotyounoyume.EBATCore";
			string message1 = 
				"<b>Listed Plugins:</b>\n" +
				"  If you uncheck and save, this plugin\n" + 
				"  will disappear from the config.";
				
			string message2 = 
				"<b>Other currently loaded plugins:</b>\n" +
				"  If you check and save, this plugin\n" +
				"  will be listed as AutoStop target.";
				
			MakeUIPartStringAndVariable("ListOrNot:1", message1, false, fHeight:100f);
			MakeUIPartStringAndVariable("ListOrNot:2", message2, true,  fHeight:100f);
			foreach(var name in core.settingsRoot["Common"]["PTMC On/Off"].AsObject.Keys){
				if(name.StartsWith("[AS]")){
					continue;
				}
				if(name == ngWord){
					continue;
				}
				string key = "ListOrNot:" + name;
				
				
				MakeUIPartToggle(key, false, Color.white);
				MakeUIPartSpacer("spacer2_" + name, "ButtonSkip", true);
			}
			
			foreach(var name in core.addonTakeControl.GetPluginList()){
				if(name == ngWord){
					continue;
				}
				MakeVariablesToggleAutoStopEditingIfNeeded(name);
				string key = "ListOrNot:" + name;
				MakeUIPartToggle(key, true, Color.gray);
				MakeUIPartSpacer("spacer2_" + name, "ButtonSkip", false);
			}
			
			}catch(Exception e){
				core.LoggerE(e);
			}
		}
		
		public void SetupUISound(){
			string explanation = 
			"You can change or test the pitch of the voice in this menu.\n" +
			"And, you can add your own Sound types by doing the following.\n" + 
			" 1. Add a new directory such as 'female1' to the following path.\n" +
			"   - YOUR_VAM/Custom/Sounds/ExpressionBlushingAndTears\n" +
			" 2. Add three directories to that path, and place at least one file in it.\n" +
			"   - breath, moan, climax. (Please refer to the 'default' directory.)\n" +
			" 3. Reload the script.";
			
			sound.RefreshSoundDirectory();
			MakeUIPartStringAndVariable("TEXT:Sound", explanation, false);
			MakeUIPartSpacer("spacer51", 102f, false);
			MakeUIPartSpacer("spacer52", 98f, false);
			MakeUIPartSpacer("spacer53", 98f, false);
			MakeUIPartPopup("Sound Type(Default)", true);
			MakeUIPartPopup("Sound Type(Personal)", true);			
			MakeUIPartButton("Sound Test: Breath", true, new Color(1f, 0.7f, 0.9f, 1f));
			MakeUIPartButton("Sound Test: Moan", true, new Color(1f, 0.7f, 0.9f, 1f));
			MakeUIPartButton("Sound Test: Climax", true, new Color(1f, 0.7f, 0.9f, 1f));

			MakeUIPartSlider("Sound Pitch", true);
			MakeUIPartSlider("Playback Rate: Breath", false);
			MakeUIPartSlider("Playback Rate: Moan", true);
			MakeUIPartSlider("Playback Rate: Climax", false);
			MakeUIPartSlider("Sound Volume", true);
			// MakeUIPartSpacer("spacer54", "SliderSkip", true);
		}
		
		public void SetupUISliders3(){
			if(core.orgasmModeOn){
				MakeUIPartSlider("Orgasm Strength Max", false);
				MakeUIPartSlider("Afterglow Strength Max", true);
				MakeUIPartSlider("Orgasm Wave Big Cycle Count Max", false);
				MakeUIPartSlider("Orgasm Wave Big Cycle Count Min", true);
				MakeUIPartSlider("Orgasm Wave Small Cycle Count Max", false);
				MakeUIPartSlider("Orgasm Wave Small Cycle Count Min", true);

				MakeUIPartSlider("Orgasm Afterglow Big Cycle Count Max", false);
				MakeUIPartSlider("Orgasm Afterglow Big Cycle Count Min", true);
				MakeUIPartSlider("Orgasm Afterglow Small Cycle Count Max", false);
				MakeUIPartSlider("Orgasm Afterglow Small Cycle Count Min", true);
				MakeUIPartSlider("Orgasm Wave Big Cycle Interval Max", false);
				MakeUIPartSlider("Orgasm Wave Small Cycle Interval Max", true);
				
				MakeUIPartSlider("Orgasm Afterglow Big Cycle Interval Max", false);
				MakeUIPartSlider("Orgasm Afterglow Small Cycle Interval Max", true);

				MakeUIPartSlider("Ease of Re-Climax", false);
				MakeUIPartSpacer("spacer40", "SliderSkip", true);
				
				MakeUIPartSlider("Shivering Strength for Finger Low Max",  false);
				MakeUIPartSlider("Shivering Strength for Finger High Max", false);
				MakeUIPartSlider("Shivering Strength for Body Low Max",    false);
				MakeUIPartSlider("Shivering Strength for Body High Max",   false);
				MakeUIPartSlider("Shivering Strength for Random Max",      false);

				MakeUIPartSlider("Shivering Strength for Finger Low Min",  true);
				MakeUIPartSlider("Shivering Strength for Finger High Min", true);
				MakeUIPartSlider("Shivering Strength for Body Low Min",    true);
				MakeUIPartSlider("Shivering Strength for Body High Min",   true);
				MakeUIPartSlider("Shivering Strength for Random Min",      true);
				
				MakeUIPartSpacer("spacer41", "SectionSeparator", false);
				MakeUIPartSpacer("spacer42", "SectionSeparator", true);
			}
		}
		
		public void RemoveConfigMenu(){
			RemoveAll();
		}
		
		public void RemoveUIs(List<string> names){
			foreach(var name in names){
				if(dUIToggle.ContainsKey(name)) RemoveAnyUI(dUIToggle[name]);
				else if(dUIPopup.ContainsKey(name)) RemoveAnyUI(dUIPopup[name]);
				else if(dUIButton.ContainsKey(name)) RemoveAnyUI(dUIButton[name]);
				else if(dUISpacer.ContainsKey(name)) RemoveAnyUI(dUISpacer[name]);
				else if(dUISlider.ContainsKey(name)) RemoveAnyUI(dUISlider[name]);
				else if(dUIString.ContainsKey(name)) RemoveAnyUI(dUIString[name]);
				else if (dUIColor.ContainsKey(name)) RemoveAnyUI(dUIColor[name]);
			}
		}
		
		public void RemoveUIs(string[] names){
			foreach(var name in names){
				if(dUIToggle.ContainsKey(name)) RemoveAnyUI(dUIToggle[name]);
				else if(dUIPopup.ContainsKey(name)) RemoveAnyUI(dUIPopup[name]);
				else if(dUIButton.ContainsKey(name)) RemoveAnyUI(dUIButton[name]);
				else if(dUISpacer.ContainsKey(name)) RemoveAnyUI(dUISpacer[name]);
				else if(dUISlider.ContainsKey(name)) RemoveAnyUI(dUISlider[name]);
				else if (dUIString.ContainsKey(name)) RemoveAnyUI(dUIString[name]);
				else if (dUIColor.ContainsKey(name)) RemoveAnyUI(dUIColor[name]);
			}
		}
		
		public void RemoveAnyUI(UIDynamicButton ui){
			if(ui != null) core.RemoveButton(ui);
		}
		
		public void RemoveAnyUI(UIDynamic ui){
			if(ui != null) core.RemoveSpacer(ui);
		}
		
		public void RemoveAnyUI(JSONStorableBool ui){
			if(ui != null) core.RemoveToggle(ui);
		}
		
		public void RemoveAnyUI(UIDynamicToggle ui){
			if(ui != null) core.RemoveToggle(ui);
		}
		
		public void RemoveAnyUI(JSONStorableStringChooser ui){
			if(ui != null) core.RemovePopup(ui);
		}
		
		public void RemoveAnyUI(UIDynamicPopup ui){
			if(ui != null) core.RemovePopup(ui);
		}
		
		public void RemoveAnyUI(JSONStorableString ui){
			if(ui != null) core.RemoveTextField(ui);
		}
		
		public void RemoveAnyUI(UIDynamicTextField ui){
			if(ui != null) core.RemoveTextField(ui);
		}
		
		public void RemoveAnyUI(JSONStorableFloat ui){
			if(ui != null) core.RemoveSlider(ui);
		}

		public void RemoveAnyUI(UIDynamicSlider ui)
		{
			if (ui != null) core.RemoveSlider(ui);
		}

		public void RemoveAnyUI(UIDynamicColorPicker ui)
		{
			if (ui != null) core.RemoveColorPicker(ui);
		}

		public void RemoveAnyUI(JSONStorableColor ui)
		{
			if (ui != null) core.RemoveColorPicker(ui);
		}

		public void OnDestroy(){
			dUISpacer.Clear();
			dUIButton.Clear(); 
			dUIToggle.Clear();
			dJSToggle.Clear();
			dUISlider.Clear(); 
			dJSSlider.Clear(); 
			dUIString.Clear(); 
			dJSString.Clear(); 
			dUIPopup.Clear();  
			dJSPopup.Clear();
			dUIColor.Clear();
			dJSColor.Clear();
			dOpenState.Clear();
			condMap.Clear();
			keyMap.Clear();
			stageMap.Clear();
			stageOptions.Clear();
//			expandsNames.Clear();
		}
	}
}