using System;
using UnityEngine;
using UnityEngine.UI;
using UnityEngine.XR;
using System.Collections;
using System.Collections.Generic;
using SimpleJSON;
using Object = UnityEngine.Object;
using System.Text.RegularExpressions;
using MVR.FileManagementSecure;
using MVR.FileManagement;

namespace Cotyounoyume
{
    public class CustomUnityAssetItem : MonoBehaviour 
    {
		public Atom atom;
		public EBATCore core;
		public bool peeingOnGlobal = true;
		
		public string peeFilename = "vam_pee.assetbundle";
		public string peeUrl = "Custom/Assets/cotyounoyume/vam_pee.assetbundle";
		public string peeLongName = "assets/prefabs/peelong.prefab";
		public string peeShortName = "assets/prefabs/peeshort.prefab";
		public string fullpath;

		public bool isPeeFree = true;
		public float timePeeShort = 3.5f;
		public float timePeeLong = 5.0f;
		public float peeingRatio = 0.2f;
		public float peeingLongRatio = 0.5f;

		public string mofmesBasePath = "Custom/Assets/Mofme/mofme_fluids.assetbundle";
		public string mofmesLongName  = "assets/prefabs_fl/mofme_cumshot_m_hp.prefab";
		public string mofmesShortName = "assets/prefabs_fl/mofme_cumshot_m_hp.prefab";
		public float mofmesTime = 1.5f;

		
		public bool debugOn = false;
		public int suffixCount = 0;

		public CustomUnityAssetItem(EBATCore core){
			atom = core.atom;
			this.core = core;
		}
		
		public void LoadSettings(){
			PeeSettings();
		}		
		
		public void PeeSettings(){
			peeingRatio    = core.settings["Peeing"]["Peeing Ratio"].AsFloat;
			peeingOnGlobal = core.settings["General"]["Peeing On"].AsBool;
			fullpath = peeUrl;
			
			string mofmesPath = GetMofmeAssetsPath();
			if(mofmesPath != "" && core.gender == "Male"){
				fullpath = mofmesPath;
				peeLongName = mofmesLongName;
				peeShortName = mofmesShortName;
				timePeeLong  = mofmesTime;
				timePeeShort = mofmesTime;
			}
		}
		
		public string GetMofmeAssetsPath(){
			string[] files = FileManagerSecure.GetFiles("AddonPackages", "*Fluids*");
			for(int i = files.Length - 1; i >= 0; i--){
				string fullpath = files[i] + ":/" + mofmesBasePath;
				if(FileManagerSecure.IsFileInPackage(fullpath)){
					return fullpath.Replace("\\", "/");
				}
			}
			return "";
		}		
		
		public void MakePeeLong(){
			MakePeeCommon(fullpath, peeLongName, timePeeLong);
		}
		
		public void MakePeeShort(){
			MakePeeCommon(fullpath, peeShortName, timePeeShort);			
		}
		
		public void MakePeeCommon(string url, string assetName, float timer){
			if(!isPeeFree){ return; }
			
			string bodyName = (core.gender == "Male") ? "penisTipControl" : "LabiaTrigger";
			string cuaName = "PeeCUA";
			core.StartCoroutine(MakePeeCoroutine(cuaName, url, assetName, bodyName, timer));
		}
		
		public IEnumerator MakePeeCoroutine(string cuaName, string url, string assetName, string bodyName, float timer){
			isPeeFree = false;
			SummonCUA(cuaName, url, assetName, bodyName, 0f, 0f, 0f, femaleOnly:false, debugOn:false, bSetParent:true);
			yield return new WaitForSeconds(timer);
			core.RemoveCUA(cuaName);
			isPeeFree = true;
		}
		
		public void PeeRandom(float time, bool force = false){
			if(peeingOnGlobal == false){
				return;
			}
			
			float randA = UnityEngine.Random.Range(0.0f, 1.0f);
			float randB = UnityEngine.Random.Range(0.0f, 1.0f);
			if(randA > peeingRatio && force == false){
				return;
			}
			
			if(randB < peeingLongRatio){
				core.DoDoubleAction(MakePeeLong, 0.05f);
			}else{
				core.DoDoubleAction(MakePeeShort, 0.05f);
			}
		}

		
		public string GetAtomId(string cuaName){
			if(core.isNameChanged){
				return core.GenerateAtomName(cuaName, core.myNameOld);	
			}else{
				return core.GenerateAtomName(cuaName, core.myName);			
			}
		}

		public Atom GetCUAAtom(string cuaName){
			string atomId = GetAtomId(cuaName);
			if(core.generatedAtomsDictionary.ContainsKey(atomId)){
				return core.generatedAtomsDictionary[atomId];
			}
			return null;
		}
		
		public void PrintAllAtomId(){
			foreach(KeyValuePair<string, Atom> kvp in core.generatedAtomsDictionary){
//				core.Info("generatedAtomsDictionary: Key: " + kvp.Key + ", Value: " + kvp.Value);
			}
		}
		
		public void MakeShirtSpreaders(string strStrengthType = "normal"){
			try{
				
			core.EmbarrassALittle();
			suffixCount = 0;
			if(strStrengthType == "normal"){
			}else{
				core.addonManager1.addonClothSim.DoInitializeIfNeeded(false, tag:"shirt");
			}
			
			if(strStrengthType == "high"){
				MakeShirtSpreader("rShldr", "",         0.00f, "rightStrong",  0.0f, strengthType:strStrengthType);
				MakeShirtSpreader("lShldr", "",         0.00f, "leftStrong",   0.0f, strengthType:strStrengthType);
			}
			
			MakeShirtSpreader("rNipple", "",       0.00f, "rightInner",  0.10f, strengthType:strStrengthType);
			MakeShirtSpreader("rNipple", "",       0.00f, "rightInner",  0.05f, strengthType:strStrengthType);
			MakeShirtSpreader("rNipple", "",       0.00f, "rightInner",  0.00f, strengthType:strStrengthType);
			MakeShirtSpreader("rNipple", "rThigh", 0.10f, "rightInner",  0.00f, strengthType:strStrengthType);
			MakeShirtSpreader("rNipple", "",       0.00f, "rightCenter", 0.10f, strengthType:strStrengthType);
			MakeShirtSpreader("rNipple", "",       0.00f, "rightCenter", 0.05f, strengthType:strStrengthType);
			MakeShirtSpreader("rNipple", "",       0.00f, "rightCenter", 0.00f, strengthType:strStrengthType);
			MakeShirtSpreader("rNipple", "rThigh", 0.10f, "rightCenter", 0.00f, strengthType:strStrengthType);
			MakeShirtSpreader("rNipple", "",       0.00f, "rightOuter",  0.10f, strengthType:strStrengthType);
			MakeShirtSpreader("rNipple", "",       0.00f, "rightOuter",  0.05f, strengthType:strStrengthType);
			MakeShirtSpreader("rNipple", "",       0.00f, "rightOuter",  0.00f, strengthType:strStrengthType);
			MakeShirtSpreader("rNipple", "rThigh", 0.10f, "rightOuter",  0.00f, strengthType:strStrengthType);
			MakeShirtSpreader("rNipple", "rThigh", 0.10f, "rightOuter",  0.00f, strengthType:strStrengthType, isAnchor:true);
			MakeShirtSpreader("lNipple", "",       0.00f, "leftInner",   0.10f, strengthType:strStrengthType);
			MakeShirtSpreader("lNipple", "",       0.00f, "leftInner",   0.05f, strengthType:strStrengthType);
			MakeShirtSpreader("lNipple", "",       0.00f, "leftInner",   0.00f, strengthType:strStrengthType);
			MakeShirtSpreader("lNipple", "lThigh", 0.10f, "leftInner",   0.00f, strengthType:strStrengthType);
			MakeShirtSpreader("lNipple", "",       0.00f, "leftCenter",  0.10f, strengthType:strStrengthType);
			MakeShirtSpreader("lNipple", "",       0.00f, "leftCenter",  0.05f, strengthType:strStrengthType);
			MakeShirtSpreader("lNipple", "",       0.00f, "leftCenter",  0.00f, strengthType:strStrengthType);
			MakeShirtSpreader("lNipple", "lThigh", 0.10f, "leftCenter",  0.00f, strengthType:strStrengthType);
			MakeShirtSpreader("lNipple", "",       0.00f, "leftOuter",   0.10f, strengthType:strStrengthType);
			MakeShirtSpreader("lNipple", "",       0.00f, "leftOuter",   0.05f, strengthType:strStrengthType);
			MakeShirtSpreader("lNipple", "",       0.00f, "leftOuter",   0.00f, strengthType:strStrengthType);
			MakeShirtSpreader("lNipple", "lThigh", 0.10f, "leftOuter",   0.00f, strengthType:strStrengthType);
			MakeShirtSpreader("lNipple", "lThigh", 0.10f, "leftOuter",   0.00f, strengthType:strStrengthType, isAnchor:true);
			}catch(Exception e){
				core.LoggerE(e);
			}
		}
		
		public void MakeShirtSpreader(string fromBody1, string fromBody2, float clampRatio, string type, float fromUpOffset = 0f, string strengthType = "normal", bool isAnchor = false){
			string settingType = (strengthType == "high") ? "shirtTearing" : "shirtSpreading";
			bool isRight = type.Substring(0,5) == "right";
			string toBody = (isRight) ? "rNipple" : "lNipple";
			float fromFrontOffset = -0.02f;
			float fromRightOffset =  0.05f;
			float toUpOffset = -0.15f;
			float toFrontOffset = 0.1f;
			float toRightOffset = 0.20f;
			float size = 0.1f;
			if(strengthType == "high"){
				toUpOffset = -0.5f;
				toFrontOffset = 0.0f;
				toRightOffset = 0.3f;
			}
			
			if(type == "center"){
				/*
				nop
				*/
			}else if(type == "rightStrong" || type == "leftStrong"){
				size = 0.2f;
				fromFrontOffset = 0f;
				fromRightOffset = 0f;
				toRightOffset *= (isRight ? 1.0f : -1.0f);
			}else if(type == "rightInner" || type == "leftInner"){
				fromFrontOffset = -1 * fromUpOffset / 2;
				fromRightOffset = -0.07f * (isRight ? 1.0f : -1.0f);
				size = 0.05f;
				toRightOffset *= (isRight ? 1.0f : -1.0f);
			}else if(type == "rightCenter" || type == "leftCenter"){
				fromFrontOffset = 0.02f + (-1 * fromUpOffset / 2);
				fromRightOffset = -0.02f * (isRight ? 1.0f : -1.0f);
				size = 0.05f;
				toRightOffset *= (isRight ? 1.0f : -1.0f);
			}else if(type == "rightOuter" || type == "leftOuter"){
				fromFrontOffset = -0.03f + (-1 * fromUpOffset / 2);
				fromRightOffset = 0.03f * (isRight ? 1.0f : -1.0f);
				size = 0.10f;
				toRightOffset *= (isRight ? 1.0f : -1.0f);
			}
				
			Vector3 startPos = GetPositionFromBodyPoints(fromBody1, fromBody2, clampRatio, fromUpOffset, fromFrontOffset, fromRightOffset);
			Vector3 endPos = Utility.GetPositionFromTargetBodynameWithOffsetAndRotationArrangement(core.atom, toBody, "abdomen2", toUpOffset, toFrontOffset, toRightOffset, 0.0f);

			string name = "clothGrabberShirt" + fromBody1 + fromBody2 + toBody + suffixCount;
			suffixCount++;
			core.StartCoroutine(MakePullingUpperCoroutine2(settingType, name, startPos, endPos, size, false, isAnchor));
		}
		
		public void MakePullingSkirtUppers(){
			// core.addonManager1.addonClothSim.DoInitializeIfNeeded(false, tag:"skirt");

			suffixCount = 0;
			core.EmbarrassALittle();
			MakePullingUpperSkirt("LabiaTrigger", "", 0f,    "center", -0.05f);
			MakePullingUpperSkirt("LabiaTrigger", "", 0f,    "center", -0.10f);
			MakePullingUpperSkirt("LabiaTrigger", "", 0f,    "center", -0.15f);
			MakePullingUpperSkirt("LabiaTrigger", "", 0f,    "center", -0.20f);
			MakePullingUpperSkirt("LabiaTrigger", "", 0f,    "center", -0.30f);
			MakePullingUpperSkirt("LabiaTrigger", "", 0f,    "center", -0.40f);
			MakePullingUpperSkirt("LabiaTrigger", "", 0f,    "center", -0.60f);
			MakePullingUpperSkirt("LabiaTrigger", "", 0f,    "center", -0.70f);
			MakePullingUpperSkirt("LabiaTrigger", "", 0f,    "center", -0.80f);
			
			MakePullingUpperSkirt("rThigh", "rShin" , 0.25f, "right",  0f, isAnchor:true);
			MakePullingUpperSkirt("rThigh", "rShin" , 0.25f, "right",  0f);
			MakePullingUpperSkirt("rThigh", "rShin" , 0.50f, "right",  0f);
			MakePullingUpperSkirt("rThigh", "rShin" , 0.75f, "right",  0f);
			MakePullingUpperSkirt("rShin",  ""      , 0f,    "right",  0f);
			MakePullingUpperSkirt("rShin",  "rFoot" , 0.25f, "right",  0f);
			MakePullingUpperSkirt("rShin",  "rFoot" , 0.50f, "right",  0f);
			MakePullingUpperSkirt("rShin",  "rFoot" , 0.75f, "right",  0f);
			MakePullingUpperSkirt("rFoot",  ""      , 0f,    "right",  0f);
			
			MakePullingUpperSkirt("lThigh", "lShin" , 0.25f, "left",   0f, isAnchor:true);
			MakePullingUpperSkirt("lThigh", "lShin" , 0.25f, "left",   0f);
			MakePullingUpperSkirt("lThigh", "lShin" , 0.50f, "left",   0f);
			MakePullingUpperSkirt("lThigh", "lShin" , 0.75f, "left",   0f);
			MakePullingUpperSkirt("lShin",  ""      , 0f,    "left",   0f);
			MakePullingUpperSkirt("lShin",  "lFoot" , 0.25f, "left",   0f);
			MakePullingUpperSkirt("lShin",  "lFoot" , 0.50f, "left",   0f);
			MakePullingUpperSkirt("lShin",  "lFoot" , 0.75f, "left",   0f);
			MakePullingUpperSkirt("lFoot",  ""      , 0f,    "left",   0f);
		}
		
		public void MakePullingUpperSkirt(string fromBody1, string fromBody2, float clampRatio, string type, float fromUpOffset = 0f, bool isAnchor = false){
			string toBody = "abdomen2";
			float fromFrontOffset = 0f;
			float fromRightOffset = 0f;
			float toUpOffset = 0.15f;
			float toFrontOffset = 0.15f;
			float toRightOffset = 0.35f;
			float size = 0.1f;
			if(type == "center"){
				fromFrontOffset = 0.1f + Mathf.Abs(fromUpOffset) / 4;
				size = Mathf.Abs(fromUpOffset) / 4;
				size = (size < 0.05f) ? 0.05f : (size > 0.15f ? 0.15f : size);
				toRightOffset = 0f;
				toFrontOffset = 0.10f;
			}else if(type == "right"){
				fromFrontOffset = (fromBody1 == "lShin" || fromBody1 == "lFoot" || fromBody1 == "rShin" || fromBody1 == "rFoot") ? 0.1f : 0.05f;
				size            = (fromBody1 == "lShin" || fromBody1 == "lFoot" || fromBody1 == "rShin" || fromBody1 == "rFoot") ? 0.15f : 0.1f;
				fromRightOffset = 1 * fromFrontOffset;
			}else if(type == "left"){
				fromFrontOffset = (fromBody1 == "lShin" || fromBody1 == "lFoot" || fromBody1 == "rShin" || fromBody1 == "rFoot") ? 0.1f : 0.05f;
				size            = (fromBody1 == "lShin" || fromBody1 == "lFoot" || fromBody1 == "rShin" || fromBody1 == "rFoot") ? 0.15f : 0.1f;
				fromRightOffset = -1 * fromFrontOffset;
				toRightOffset = -1 * toRightOffset;
			}
				
			Vector3 startPos = GetPositionFromBodyPoints(fromBody1, fromBody2, clampRatio, fromUpOffset, fromFrontOffset, fromRightOffset);
			Vector3 endPos = Utility.GetPositionFromTargetBodynameWithOffsetAndRotationArrangement(core.atom, toBody, "pelvisControl", toUpOffset, toFrontOffset, toRightOffset, 0.05f);
			string name = "clothGrabberSkirt" + fromBody1 + fromBody2 + toBody + suffixCount;
			suffixCount++;
			core.StartCoroutine(MakePullingUpperCoroutine2("skirtPullingUp", name, startPos, endPos, size, false, isAnchor));
		}

		public Vector3 GetPositionFromBodyPoints(string fromBody1, string fromBody2, float clampRatio, float upOffset, float frontOffset, float rightOffset){
			Vector3 pos = new Vector3(0f, 0f, 0f);
			if(fromBody2 == ""){
				if(core.trunk != null){
					return Utility.GetPositionFromTargetBodynameWithOffsetAndRotationArrangement(core.atom, fromBody1, core.trunk.transform, upOffset, frontOffset, rightOffset);
				}else{
					return Utility.GetPositionFromTargetBodynameWithOffset(core.atom, fromBody1, upOffset, frontOffset, rightOffset);
				}
			}else{
				if(core.trunk != null){
					Vector3 startPos1 = Utility.GetPositionFromTargetBodynameWithOffsetAndRotationArrangement(core.atom, fromBody1, core.trunk.transform, upOffset, frontOffset, rightOffset);
					Vector3 startPos2 = Utility.GetPositionFromTargetBodynameWithOffsetAndRotationArrangement(core.atom, fromBody2, core.trunk.transform, upOffset, frontOffset, rightOffset);
					return Vector3.LerpUnclamped(startPos1, startPos2, clampRatio);
				}else{
					Vector3 startPos1 = Utility.GetPositionFromTargetBodynameWithOffset(core.atom, fromBody1, upOffset, frontOffset, rightOffset);
					Vector3 startPos2 = Utility.GetPositionFromTargetBodynameWithOffset(core.atom, fromBody2, upOffset, frontOffset, rightOffset);
					return Vector3.LerpUnclamped(startPos1, startPos2, clampRatio);
				}
			}
		}

		public IEnumerator MakePullingUpperCoroutine2(string settingType, string name, Vector3 startPos, Vector3 endPos, float size, bool debugOn = false, bool isAnchor = false){
			GameObject sphere = core.GetGameObject(name);
			if(sphere != null){
				core.RemoveGameObject(name);
			}
			
			core.StartCoroutine(MakeSphereCoroutine(name, size));
			for(int i = 0; i < 200; i++){
				sphere = core.GetGameObject(name);
				if(sphere == null){ yield return null; }
			}
			if(sphere == null){ yield break; }
			
			sphere.transform.position = startPos;
			yield return null;
			
			if(!isAnchor){
				sphere.gameObject.transform.GetComponent<GpuGrabSphere>().enabled = true;
			}
			if(debugOn){
				sphere.GetComponent<Renderer>().enabled = true;
			}

			float duration = 1.0f;
			float frame = 30f;
			float step = duration/frame;
			float waitTime = 0.0f;
			bool keepFlag = true;
			if(settingType == "skirtPullingUp"){
				duration = 2f;
			}else if(settingType == "shirtSpreading"){
				duration = 1f;
			}else if(settingType == "shirtPullingDown"){
				duration = 2f;
			}else if(settingType == "shirtTearing"){
				duration = 0.5f;
				keepFlag = false;
			}
			
			if(settingType == "shirtSpreading" || settingType == "shirtTearing" ){
				for(float delta = 0f; delta < duration / 2; delta += step){
					sphere.transform.position = Vector3.Lerp(startPos, endPos, Utility.Lerp3(0, duration, delta));
					yield return new WaitForSeconds(step / 2);
				}
				if(!isAnchor){
					sphere.gameObject.transform.GetComponent<GpuGrabSphere>().enabled = false;
				}
				sphere.transform.position = startPos;
				yield return null;
				
				if(!isAnchor){
					sphere.gameObject.transform.GetComponent<GpuGrabSphere>().enabled = true;
				}
				yield return null;
				for(float delta = 0f; delta < duration; delta += step){
					sphere.transform.position = Vector3.Lerp(startPos, endPos, Utility.Lerp3(0, duration, delta));
					yield return new WaitForSeconds(step);
				}
				if(isAnchor){
					Vector3 pos = sphere.gameObject.transform.position;
					FreeControllerV3 fc = Utility.GetFreeControllerV3(core.atom, "abdomen2Control");
					sphere.gameObject.transform.SetParent(fc.transform, false);
					sphere.gameObject.transform.position = pos;
					sphere.gameObject.transform.GetComponent<GpuGrabSphere>().enabled = true;
				}
				yield return new WaitForSeconds(waitTime);
				
				if(keepFlag == false || !isAnchor){
					core.RemoveGameObject(name);
				}
				
				if(settingType == "shirtTearing"){
					core.RemoveGameObjectByName("clothGrabberShirt");
				}
			}else{
				for(float delta = 0f; delta < duration; delta += step){
					sphere.transform.position = Vector3.Lerp(startPos, endPos, Utility.Lerp3(0, duration, delta));
					yield return new WaitForSeconds(step);
				}
				if(isAnchor){
					Vector3 pos = sphere.gameObject.transform.position;
					FreeControllerV3 fc = Utility.GetFreeControllerV3(core.atom, "pelvisControl");
					sphere.gameObject.transform.SetParent(fc.transform, false);
					sphere.gameObject.transform.position = pos;
					sphere.gameObject.transform.GetComponent<GpuGrabSphere>().enabled = true;
				}
				yield return new WaitForSeconds(waitTime);
				
				if(!isAnchor){
					core.RemoveGameObject(name);
				}
			}
		}
				
		public IEnumerator MakeSphereCoroutine(string name, float size){
			core.StartCoroutine(core.CreateGameObject(name, PrimitiveType.Sphere, (tmpObj)=>{
				tmpObj.transform.localScale = new Vector3(size, size, size);
				tmpObj.GetComponent<Renderer>().material.shader = Shader.Find("Transparent/Diffuse");
				tmpObj.GetComponent<Renderer>().material.color  = new Color(1f, 0.5f, 0.5f, 0.5f);
				tmpObj.GetComponent<Renderer>().enabled = false;
				tmpObj.GetComponent<Collider>().enabled = false;
				GpuGrabSphere gs = tmpObj.gameObject.AddComponent<GpuGrabSphere>();
				gs.radius = 1;
				gs.enabled = false;
			}));
			yield return null;
		}
		
		public void MakeSphereForUI(Transform uiT){
			core.StartCoroutine(MakeSphereCoroutineForUI("SphereForUICorner", 0.05f, uiT));
		}
		
		public IEnumerator MakeSphereCoroutineForUI(string name, float size, Transform uiT){
			core.StartCoroutine(core.CreateGameObject(name, PrimitiveType.Sphere, (tmpObj)=>{
				tmpObj.transform.localScale = new Vector3(size, size, size);
				tmpObj.GetComponent<Renderer>().material.shader = Shader.Find("Transparent/Diffuse");
				tmpObj.GetComponent<Renderer>().material.color  = new Color(0.5f, 0.5f, 1.0f, 0.5f);
				tmpObj.GetComponent<Renderer>().enabled = true;
				tmpObj.GetComponent<Collider>().enabled = false;
				
				tmpObj.transform.position = uiT.position;
				tmpObj.gameObject.transform.SetParent(uiT, false);
				tmpObj.transform.position = uiT.position;
			}));
			yield return null;
		}
		
		public void ToggleTriggerModel(string sphereName, string bodyName, float size = 0.035f){
			Rigidbody rb = Utility.FindRigidBody(core.atom, bodyName);
			ToggleTriggerModel(sphereName, rb.transform, size);
		}
		
		public void ToggleTriggerModel(string sphereName, Transform transform, float size = 0.035f){
			GameObject obj = core.GetGameObject(sphereName);
			if(obj == null){
				MakeSphereAndSetParent(sphereName, transform, size, true);
			}else{
				core.RemoveGameObject(sphereName);
			}
		}
		
		public void MakeSphereAndSetParent(string sphereName, Transform transform, float size, bool debugOn = false){
			core.StartCoroutine(MakeSphereAndSetParentCoroutine(sphereName, transform, size, debugOn));
		}
		
		public IEnumerator MakeSphereAndSetParentCoroutine(string sphereName, Transform transform, float size, bool debugOn = false){
			GameObject sphere = core.GetGameObject(sphereName);
			if(sphere != null){
				core.RemoveGameObject(sphereName);
			}
			
			core.StartCoroutine(MakeSphereCoroutine(sphereName, size));
			for(int i = 0; i < 200; i++){
				sphere = core.GetGameObject(sphereName);
				if(sphere == null){ yield return null; }
			}
			if(sphere == null){
				yield break; 
			}
			if(debugOn){
				sphere.GetComponent<Renderer>().enabled = true;
			}
			
			sphere.gameObject.transform.position = transform.position;
			sphere.gameObject.transform.SetParent(transform, false);
			sphere.gameObject.transform.position = transform.position;
		}
		
		public void ResetPositionCUA(string cuaName, string bodyName, float upOffset, float forwardOffset, float rightOffset){
			try{
				Atom tmpatom = GetCUAAtom(cuaName);
				if(tmpatom == null){
					return;
				}
				Vector3 pos = Utility.GetPositionFromTargetBodynameWithOffset(core.atom, bodyName, upOffset, forwardOffset, rightOffset, 0f);
				Quaternion rot = Utility.GetRotationFromTargetBodyname(core.atom, bodyName);
				tmpatom.transform.SetPositionAndRotation(pos, rot);
			}catch(Exception e){
				core.LoggerE(e);
			}
		}
		
		public void SummonAtomMarker(string name, string bodyName, float upOffset, float forwardOffset, float rightOffset, bool debugOn = true, bool bSetParent = true){
			if(core.customUnityAssetItem.GetCUAAtom(name) != null){
				core.RemoveCUA(name);				
			}
			
			bool isNipple = (bodyName.EndsWith("NippleControl"));

			core.StartCoroutine(core.CreateAtom("CustomUnityAsset", name, (tmpatom)=>
			{
				if(isNipple){
					tmpatom.transform.rotation *= Quaternion.AngleAxis(180, Vector3.forward);
				}
				Transform t = Utility.GetTransformFromTargetBodyname(core.atom, bodyName);
				ResetPositionCUA(name, bodyName, 0f, 0f, 0f);
				// tmpatom.transform.position = Utility.GetPositionFromTargetTransformWithOffset(t, upOffset, forwardOffset, rightOffset);
				tmpatom.transform.position = Utility.GetPositionFromTargetBodynameWithOffsetAndRotationArrangement(
					core.atom, bodyName, core.trunk.transform, upOffset, forwardOffset, rightOffset, 0);
				// tmpatom.transform.position = Utility.GetPositionFromTargetTransformWithOffset(core.trunk.transform, upOffset, forwardOffset, rightOffset);
				tmpatom.transform.rotation = t.transform.rotation;

				if(bSetParent){
					tmpatom.transform.SetParent(t);
					// Utility.SetParent(tmpatom, core.atom, bodyName);
				}
				if(debugOn == false){
					tmpatom.hidden = true;
					tmpatom.mainController.canGrabPosition = false;
					tmpatom.mainController.canGrabRotation = false;
				}

			}));			
		}

		public void SummonAtomOnly(string name, string bodyName, bool debugOn = true){
			if(GetCUAAtom(name) != null){
				core.RemoveCUA(name);				
			}
			
			core.StartCoroutine(core.CreateAtom("CustomUnityAsset", name, (tmpatom)=>
			{
				ResetPositionCUA(name, bodyName, 0f, 0f, 0f);
				
				if(debugOn == false){
					tmpatom.hidden = true;
					tmpatom.mainController.canGrabPosition = false;
					tmpatom.mainController.canGrabRotation = false;
				}
			}));			
		}

		public void SummonCUA(string cuaName, string url, string assetName, string bodyName, float upOffset, float forwardOffset, float rightOffset, bool femaleOnly = true, bool debugOn = true, bool bSetParent = true){
			if(core.gender=="Male" && femaleOnly == true){
				return;
			}

			if(GetCUAAtom(cuaName) != null){
				core.RemoveCUA(cuaName);				
			}

			core.StartCoroutine(core.CreateAtom("CustomUnityAsset", cuaName, (tmpatom)=>
			{
				if(bSetParent){
					Utility.SetParent(tmpatom, atom, bodyName);
					Transform parent = Utility.GetTransformFromTargetBodyname(atom, bodyName);
					core.parentAngleChecker.RegisterPair(tmpatom.transform, parent, cuaName);
				}
				
				
				string fullpath;
				if(url.StartsWith("Custom/")){
					fullpath = core.myPath.Replace("Custom/Scripts/cotyounoyume/ExpressionBlushingAndTears", "") + url;
				}else{
					fullpath = url;
				}

				if(url != ""){
					Utility.SetAssetBundleUrl(tmpatom, fullpath);
				}
				if(assetName != ""){
					Utility.ResetAssetBundleName(tmpatom, assetName);
				}
				
				ResetPositionCUA(cuaName, bodyName, upOffset, forwardOffset, rightOffset);
				
				if(debugOn == false){
					tmpatom.hidden = true;
					tmpatom.mainController.canGrabPosition = false;
					tmpatom.mainController.canGrabRotation = false;
				}
			}));			
		}
		
		public void OnDestroy(){
			try{
			}catch(Exception e){
				core.LoggerE(e);
			}
		}
	}
}