#region using
using System;
using UnityEngine;
using System.Collections;
using System.Collections.Generic;
using SimpleJSON;
using System.Linq;
using System.Threading;
using System.Text.RegularExpressions;
#endregion

namespace Cotyounoyume{
	public class Etc
	{
		public Atom atom;
		public bool autoExpressionOffGlobal = true;
		public bool autoBlinkOffGlobal = true;
		public bool autoJawMouthMorphOnGlobal = true;
		
		public EBATCore core;
		public bool disableLog;
		
		public Etc(EBATCore core){
			atom = core.atom;
			this.core = core;
		}
		
		public void LoadSettings(){
			try{
				autoExpressionOffGlobal = core.settings["General"]["Auto Expression Off"].AsBool;
				autoBlinkOffGlobal = core.settings["General"]["Auto Blink Off"].AsBool;
				autoJawMouthMorphOnGlobal = core.settings["General"]["Auto Jaw Mouth Morph On"].AsBool;
			}catch (Exception e){
				core.LoggerE(e);
			}
		}
		
		public void ApplySettings(){
			try{
				atom.GetStorableByID("AutoExpressions").SetBoolParamValue("enabled", !(core.settings["General"]["Auto Expression Off"].AsBool));
				atom.GetStorableByID("EyelidControl").SetBoolParamValue("blinkEnabled", !(core.settings["General"]["Auto Blink Off"].AsBool));
				atom.GetStorableByID("AutoJawMouthMorph").SetBoolParamValue("enabled", !(core.settings["General"]["Auto Jaw Mouth Morph On"].AsBool));
			}catch (Exception e){
				core.LoggerE(e);
			}
		}
		
		public void Maintenance(){

		}
	}
}