using System.Collections;
using System.Collections.Generic;

namespace Extensions
{
    public static class StringExtension
    {
        public static string ToUpperLineHead(this string self)
        {
            var _array = self.ToCharArray();
            var up = char.ToUpper(_array[0]);
            _array[0] = up;
            return new string(_array);
        }    
    }

    public static class DictionaryExtensions {    
        public static TValue TryGetValueEx<TKey, TValue>(this IDictionary<TKey, TValue> source, TKey key, TValue defaultValue) {

            //Dictionary自体がnullの場合はインスタンス作成
            if(source == null){
            source = new Dictionary<TKey, TValue>();
            }

            //keyが存在しない場合はデフォルト値を設定
            if(!source.ContainsKey(key)){
            source[key] = defaultValue;
            }

            return source[key];
        }        
    }
}
