using System;
using UnityEngine;
using UnityEngine.UI;
using UnityEngine.XR;
using System.Collections;
using System.Collections.Generic;
using SimpleJSON;
using Object = UnityEngine.Object;
using System.Text.RegularExpressions;

namespace Cotyounoyume
{
    public class Hint : MonoBehaviour 
    {
		public Atom atom;
		public EBATCore core;
		
		public Hint(EBATCore core){
			atom = core.atom;
			this.core = core;
		}
		
		public void LoadSettings(){
			try{
			}catch (Exception e){
				core.LoggerE(e);
			}
		}
		
		public void ApplySettings(){
		}
		
		public void ReplaceTimeline(){
			string message = 
				"<b><size=48>About Timeline Ver.</size></b>\n" + 
				"Timeline Ver. 5 is used in this scene. Also, Timeline Ver. 6 or higher exists for this VaM. \n" +
				"Do you want to change the timeline in this scene to Ver. 6 or higher? \n\n" + 
				"With Timeline Ver. 6 or higher, ExpressionBlushingAndTears will work with the timeline to create a more immersive effect during climax. \n\n" + 
				"(This change is temporary and will not change the existing Var file. If you wish to apply this change permanently, please save this scene as an alias.)";
			core.worldUi.AskToUser(message, ReplaceTimelineYesAction, ReplaceTimelineNoAction, 36);
		}
		
		public void ReplaceTimelineYesAction(){
			string message = "<b><size=48>Plugin is reloaded. Please wait a moment.</size></b>";
			core.worldUi.NotifyToUser(message, 24);
			core.DoDelayedAction(ReplaceTimelineYesActionSub, 0.5f);
		}
		
		public void ReplaceTimelineYesActionSub(){
			Utility.ReplaceNewOneAndReloadPlugins(core.atom, "Timeline");			
		}

		public void ReplaceTimelineNoAction(){
		}
		
		public void LoadVamMoan(){
			string message = 
				"<b><size=48>Load VaMMoan</size></b>\n" + 
				"Load VaMMoan into this Person. After loading, manually check the VaMMoan checkbox [ON].\n";
			core.worldUi.AskToUser(message, LoadVamMoanYesAction, LoadVamMoanNoAction, 36);
		}
		
		public void LoadVamMoanYesAction(){
			string message = "<b><size=48>Plugin is reloaded. Please wait a moment.</size></b>";
			core.worldUi.NotifyToUser(message, 24);
			core.DoDelayedAction(LoadVamMoanYesActionSub, 0.5f);
		}
		
		public void LoadVamMoanYesActionSub(){
			core.soundExternalLinkage.LoadVAMMoan();
		}
		
		public void LoadVamMoanNoAction(){
		}
		
		public void NotifyToUserForDL(string message){
			core.worldUi.NotifyToUserForDL(message);
		}

		public void VersionCheckHint(){
			string message = 
				"<b><size=48>The version-up adds new parameters to this plugin.</size></b>\n" + 
				"The existing parameters will not be changed, only the new parameters will be added.\n" +
				"Give permission to the save confirmation that appears on the VaM screen. (Click \"Confirm\")\n\n" + 
				"(Do you want to restore all the parameters including the existing ones to their default values? " + 
				"If you want to do so, run \"Load Default\" in the custom UI.)";
			core.worldUi.NotifyToUser(message, 36);
		}

		public void StopOtherPluginsHint(){
			string message = 
			"<b><size=48>Stop other plugins that might conflit:</size></b>\n" +
			"This allows you to temporarily stop other potentially conflicting plug-ins. " +
			"When you click Restart, the other plug-ins will resume their activities again." +
			"(See Help for AutoStop)\n\n" +
			"<b>Details:</b>\n" +
			"For example, plug-ins that give movement to the head or chest, such as Gaze or Breath, will conflict with this plug-in (EBAT).\n" + 
			"Plugins that may conflict will be listed in Config. You can adjust this by editing the following elements of Config.\n\n" +
			"  <b>File:</b> Custom/Scripts/ExpressionBlushingAndTears_currentSettings.json\n" +
			"  <b>Tag:</b>  Plugins that might Confilict";
			core.worldUi.NotifyToUser(message, 36, width:1200f, height:400f);
		}
		
		public void DoublingColliderHint(){
			string message = 
			"<b><size=48>Doubles the radius of the Collider</size></b>\n" +
			"This setting doubles the radius of the Collider for Labia, Vagina, DeepVagina, and DeeperVagina.\n" +
			"I don't know why, but my Plugin has a bug where the Collider does not work properly in certain pose.\n" + 
			"In order to make Collider work in such situations, this setting extends the radius of Collider to twice the normal radius.\n" + 
			"(The larger the radius, the more responsive the trigger will be. " +
			"However, this side effect may cause her to climax just by rubbing her belly.)";
			
			core.worldUi.NotifyToUser(message, 36, width:1200f, height:400f);
		}
		
		public void AutoStopHint(){
			string message = 
			"<b><size=48>AutoStop OtherPlugins</size></b>\n" +
			"When AutoStop is enabled, other potentially conflicting plug-ins will be stopped " + 
			"when the Ecstasy gauge reaches the second level. " +
			"(See Help for Stop Other...)\n\n" +
			"This prevents other plug-ins from interfering with head movement and audio, " + 
			"which are the functions of this plugin.\n" +
			"When the Ecstasy gauge goes down, the other plug-ins will resume their activities again.";
			
			core.worldUi.NotifyToUser(message, 36, width:1200f, height:400f);
		}
		
		public void FaceSidewaysHint(){
			string message = 
			"<b><size=48>Head Motion - Face Sideways, Turn Head Back, etc.</size></b>\n" +
			"\"Face Sideways\", \"Turn Head Back\", etc. are functions that allow you to see " +
			"how the PERSON's head and neck move. With this plug-in, when you stimulate a PERSON, " +
			"she will turn her head back or turn her face away from you due to sexual pleasure.\n" + 
			"The probability of head movement occurring can be set from the CustomUI.\n\n" +
			"<b>Custom UI>Expand Head Controller Menu></b>\n" +
			"  - <b>HC Angle:</b> For adjusting the angle of the head movement.\n" +
			"  - <b>HC Event Firing Ratio:</b> For adjusting the ratio of firing event.\n" +
			"  - <b>HC Ratio By Stage:</b> For adjusting the rate at which actions occur.\n";
			
			core.worldUi.NotifyToUser(message, 36, width:1200f, height:400f);
		}
		
		public void BackupPoseHint(){
			string message = 
			"<b><size=48>Backup Pose</size></b>\n" +
			"This is a simple pose backup function. A backup (snap) of the PERSON's pose will be taken " + 
			"after the Plugin is loaded and after the BackupPose button is clicked.\n" +
			"Clicking the Reset button to the left of this button will return to the backed up pose. " + 
			"If you can't get back to the original pose after pressing the button once, " + 
			"you may have to click it several times to get it back.";

			core.worldUi.NotifyToUser(message, 36, width:1200f, height:400f);
		}
		
		public void CoveringHint(){
			string message = 
			"<b><size=48>Hand Covering Action</size></b>\n" +
			"When this option is enabled, PERSON reacts to sexual stimulation of the breasts and pubic area by trying to cover them with her hands.";

			core.worldUi.NotifyToUser(message, 36, width:1200f, height:400f);
		}
		
		public void ResetPhysics(){
			string message = 
			"<b><size=48>Reset Physics</size></b>\n" +
			"This function is used when physics or collision triggers do not work properly for some reason. " +
			"This function is similar to the VaM standard method of correcting the problem at the time of Explosion.";

			core.worldUi.NotifyToUser(message, 36, width:1200f, height:400f);
		}
		
		public void CollisionFailureCheckHint(){
			string message = 
			"<b><size=48>Collision Failure Check</size></b>\n" +
			"When PERSON's Collision Trigger becomes unresponsive (always on or always off), it will automatically attempt to correct the Collision Trigger. " + 
			"However, this correction resets the state of the garment, so this is an experimental feature at this time.";

			core.worldUi.NotifyToUser(message, 36, width:1200f, height:400f);
		}
		
		// public void SensitiveTriggerHint(){
		// 	string message = 
		// 	"<b><size=48>Sensitive Trigger</size></b>\n" +
		// 	"This function will return the state of the FEMALE PERSON's collision trigger " + 
		// 	"to Inactive in a few seconds if it is still in the Active state.\n" +
		// 	"If Dildo or Penis is too deeply inserted into the Vagina, " +
		// 	"the collision trigger will always be active and the PERSON may become unresponsive. "+
		// 	"This function prevents such unresponsive state.";
			
		// 	core.worldUi.NotifyToUser(message, 36, width:1200f, height:400f);
		// }
		
		public void ShiveringHint(){
			string message = 
			"<b><size=48>Shivering of the belly in climax</size></b>\n" +
			"Enables the belly shivering(contraction) caused by the climax wave.\n" + 
			"Pose change (Bone) and surface change (Morph) can be set respectively.\n";
			
			core.worldUi.NotifyToUser(message, 36, width:1200f, height:400f);
		}
		
		public void SkinWrapHint(){
			string message = 
			"<b><size=48>Alter SkinWrap</size></b>\n" +
			"Of the VaM clothes, only the early clothes implemented by MeshedVR have the ability to " +
			"change SkinWrap. This is a feature that may have been mostly forgotten, " + 
			"but it has some interesting effects, such as giving special effects to the clothes, " +
			"such as the bra almost coming off, when using SkinWrap.\n\n" +
			"It is enabled in \"Alphakini Panty\" and other programs (note, it is not \"Alphakini Panty Sim\"," +
			" but \"Alphakini Panty\").";
			
			core.worldUi.NotifyToUser(message, 36, width:1200f, height:400f);
		}
		
		public void UndressCUAsHint(){
			string message = 
			"<b><size=48>Undress CUAs</size></b>\n" +
			"This feature can be used to remove a CustomUnityAsset associated with a person, such as a CUAManager. " +
			"By default, this function does not remove CUAs that are parented to the Head. " + 
			"(For cartoon-like characters, removing the CUAs parented to the head will often result in a significant visual loss).\n" +
			"However, if Exclude Head is turned off, CUAs parented to the Head can be removed.";

			core.worldUi.NotifyToUser(message, 36, width:1200f, height:400f);
		}

		public void UndressPartialHint(){
			string message = 
			"<b><size=48>Partial Undressing</size></b>\n" +
			"The words \"Skirt\" and \"Shirt\" displayed in this World UI are buttons for partial undressing. If you have set tags in \"User Prefs\" for your clothes, you can only undress clothes that match those tags.";

			core.worldUi.NotifyToUser(message, 36, width:1200f, height:400f);
		}

		public void RemoveOptionsHint(){
			string message = 
			"<b><size=48>Undress and Remove</size></b>\n" +
			"Added Undress/Remove Clothes features and settings. There are 4 types of functions or settings.\n\n" +

			"<b>1. Undress clothes functions:</b>\n" +
			"\"Undress\" command allows ClothSim-compatible clothes to be undressed based on a physics simulation." +
			"And, if the \"Undress Force\" option is enabled, it may be possible to undress clothes that would not normally be completely undressable.\n" +
			"In addition, \"Power\" which can be set from the custom UI, allows you to set the strength of the clothing pull, " + 
			" and \"Duration\" allows you to set the time for which the strength is valid.\n\n" +

			"<b>2. Alter SkinWrap:</b>\n" +
			"Alter SkinWrap is a function that changes the shape of the built-in clothing " +
			"created by MeshedVR. The shape changes from the normal state of the clothing " +
			"to a state where the clothing is about to come off, etc. \n" +
			"For example, if you use this function while wearing " +
			"\"<b>Alphakini Bra</b>\", you will immediately see the effect. " +
			"Also, if \"<b>SkinWrapToClothSim</b>\" is enabled, the function will also apply to " + 
			"Builtin clothing which ClothSim is enabled (e.g. \"<b>Alphakini Bra Sim</b>\".)\n\n" +

			"<b>3. (Temporary) Remove function of clothes:</b>\n" +
			"Clothing is temporarily removed in three different settings " +
			"(The difference between undressing and removing is whether or not it instantly becomes invisible.) \n" +
			"  <b>Option 1</b>: If the name of the clothing contains the following words, \n" + 
			"                  it will be excluded from removal.\n" +
			"                      \"eye\", \"nose\", \"face\", \"mouth\", \"hair\", \"brow\",\n" +
			"                      \"drip\", \"makeup\", \"mtk2\", \"glasses\"\n" +
			"  <b>Option 2</b>: Exclude ClothSim enabled clothing from removal.\n" +
			"  <b>Option 3</b>: Clothes with Alter SkinWrap enabled will be excluded from removal.\n\n" +

			"<b>4. Reset:</b>\n" +
			"Pressing the reset button will return to the state before the clothes were " +
			"removed or undressed. This feature is not perfect, but it works most of the time. " +
			"Even if the state of the clothing is not restored, this state is not saved in the game " +
			"and will be restored the next time the game is started.\n";
			
			core.worldUi.NotifyToUser(message, 36, width:1200f, height:400f);
		}
		
		public void VAMMoanHint(){
			string message = 
			"<b><size=48>Use VAMMoan for Sound</size></b>\n" +
			"If this setting is enabled while VAMMoan is added to the PERSON, " + 
			"VAMMoan will be used for Sound.\n" +
			"For the stage of this Plugin(EBAT), the Intensity of the VAMMoan(VAMM) " +
			"corresponds to the following:\n" +
			"    EBAT Stage 0 => VAMM breathing\n" +
			"    EBAT Stage 1 => VAMM intensity 1\n" +
			"    EBAT Stage 2 => VAMM intensity 2\n" +
			"    EBAT Stage 3 => VAMM intensity 3\n" +
			"    EBAT Stage 4 => VAMM intensity 4\n" +
			"    EBAT Stage 5 => VAMM orgasm\n";
			
			core.worldUi.NotifyToUser(message, 36, width:1200f, height:400f);			
		}
		
		public void CustomUiHint(string name){
			string message = "";
			if(false){
			}else if(name == "Hint:AlterSkinWrap"){
				SkinWrapHint();
				return;
			}else if(name == "Hint:RemoveOptions"){
				RemoveOptionsHint();
				return;
			}else if(name == "Hint:UndressForce"){
				UndressPartialHint();
				return;
			}else if(name == "Hint:[AS]AutoStop Other Plugins"){
				message = 
				"<b><size=48>AutoStop Other Plugins</size></b>\n" +
				"When AutoStop is enabled, other potentially conflicting plug-ins will be stopped " + 
				"when the Ecstasy gauge reaches the second level. " +
				"(See Help for Stop Other...)\n\n" +
				"This prevents other plug-ins from interfering with head movement and audio, " + 
				"which are the functions of this plugin.\n" +
				"When the Ecstasy gauge goes down, the other plug-ins will resume their activities again.";
			}else if(name == "Hint:[AS]Stop Morph Control by non-plugins"){
				message = 
				"<b><size=48>Stop Morph Control by non-plugins</size></b>\n" +
				"Enabling this setting will automatically stop Morph " + 
				"via VariableTrigger/AnimationPattern to PERSON when it reaches the specified Stage.\n" +
				"(For example, if Stage is set to 5, the expression at the climax " +
				"will be taken from this plugin. If you are not sure, enable this setting.)" +
				"";
			}else if(name == "Hint:[AS]Stop Head Control by non-plugins"){
				message = 
				"<b><size=48>Stop Head Control by non-plugin</size></b>\n" +
				"Enabling this setting will automatically stop Animation(related to the head) " + 
				"via AnimationPattern/MotionAnimationControl to PERSON when it reaches the specified Stage.\n" +
				"(For example, if Stage is set to 5, the head motion at the climax " +
				"will be taken from this plugin. If you are not sure, enable this setting.)" +
				"\n\nNote that timeline motion will not be stopped by this setting. " + 
				"If you wish to limit timeline motion, include timelines in the Plugin's auto-stop list.";
			}else if(name == "Hint:[AS]Stop Body Control by non-plugins"){
				message = 
				"<b><size=48>Stop WholeBody Control by non-plugins</size></b>\n" +
				"Enabling this setting will automatically stop Animation(of the whole body) " + 
				"via AnimationPattern/MotionAnimationControl to PERSON when it reaches the specified Stage.\n" +
				"(For example, if you set Stage to 5, the animation of the whole body will stop. " +
				"If you are not sure, <b>disable</b> this setting.)" +
				"\n\nNote that timeline motion will not be stopped by this setting. " + 
				"If you wish to limit timeline motion, include timelines in the Plugin's auto-stop list.";
			}else if(name == "Hint:General Timeline"){
				message = 
				"<b><size=48>Stop Animation by Timeline(HeadOnly)</size></b>\n" +
				"Enabling this setting will automatically stop Animation(related to the head) " + 
				"via Timeline to PERSON when it reaches the specified Stage.\n" +
				"(For example, if Stage is set to 5, the head motion at the climax " +
				"will be taken from this plugin. If you are not sure, enable this setting.)" +
				"\n\nNote that timeline motion will not be stopped by this setting. " + 
				"If you wish to limit timeline motion, include timelines in the Plugin's auto-stop list.";
			}
			
			core.worldUi.NotifyToUser(message, 36, width:1200f, height:400f);			
		}
		
	}
}