#region using
using System;
using UnityEngine;
using System.Collections;
using System.Collections.Generic;
using SimpleJSON;
using System.Linq;
using System.Threading;
using System.Text.RegularExpressions;
using MVR.FileManagementSecure;
#endregion

//namespace MVR.FileManagementSecure{
namespace Cotyounoyume{
	public class SoundExternalLinkage{
		#region common or UI Properties
		public Atom atom;
		public EBATCore core;
		public bool disableLog;
		
		public JSONStorable jsVamm = null;
		#endregion
		
		public SoundExternalLinkage(EBATCore core){
			this.core = core; 
			this.atom = core.atom;
		}
		
		public void PlayByIntensity(){
			if(!core.vammoanLinkOnGlobal){ 
				StopVamm();
				return;
			}
			if(!CheckLink()){
				return;
			}
			
			int stage = core.GetStage();
			if(stage == 0){
				jsVamm.CallAction("Voice breathing");				
			}else if(stage < 5){
				jsVamm.CallAction("Voice intensity " + stage);
			}else{
				jsVamm.CallAction("Voice orgasm");
				core.StartCoroutine(TrackTheEndOfOrgasm());
			}
		}
		
		
		public IEnumerator TrackTheEndOfOrgasm(){
			for(int i = 0; i < 200; i++){
				int intensity = (int)jsVamm.GetFloatParamValue("VAMM CurrentArousal");
				if(intensity != 0){
					yield return new WaitForSeconds(0.1f);
				}else{
					PlayByIntensity();
					break;
				}
			}
		}
		
		public void CheckLinkForCustomUI(){
			try{
			bool targetStatus = core.customUi.GetToggleValue("Use VAMMoan for Sound");
			bool realStatus = CheckLink();
			if(realStatus == true){
				if(targetStatus == false){
					StopVamm();
				}
			}else{
				if(targetStatus == true){
					if(Utility.GetLongestFilename("*vammoan*") == ""){
						core.customUi.ToggleExternal("Use VAMMoan for Sound");
						core.Info("Can't find VAMMoan Plugin. This setting has been disabled.");
					}else{
						core.hint.LoadVamMoan();
					}
				}
			}
			
			}catch(Exception e){
				core.LoggerE(e);
			}
		}
		
		public void LoadVAMMoan(){
			core.StartCoroutine(LoadVAMMoanCoroutine());
		}
		
		public IEnumerator LoadVAMMoanCoroutine(){
			Utility.LoadVAMMoanIfNeeded(core.atom);
			yield return new WaitForSeconds(3.0f);
//			core.customUi.ToggleExternal("Use VAMMoan for Sound");
		}
		
		public void StopVamm(){
			if(jsVamm != null){
				jsVamm.CallAction("Voice disabled");			
			}
		}
		
		public bool CheckLink(){
			if(jsVamm != null){ return true; }
			
			jsVamm = Utility.GetReceiver(core.atom, "vammoan");
			if(jsVamm == null){
				return false;
			}else{
				return true;
			}
		}
	}
}
