using System;
using UnityEngine;
using UnityEngine.UI;
using UnityEngine.XR;
using System.Collections;
using System.Collections.Generic;
using SimpleJSON;
using System.Linq;

namespace Cotyounoyume
{
	public struct ButtonStruct{
		public string normal;
		public string alt;
		public Action action;
		public bool hasVar;
		public Func<bool> func;
		public ButtonStruct(
			string normal, string alt, 
			Action action, bool hasVar, Func<bool> func
		)
		{
			this.normal = normal;
			this.alt = alt;
			this.action = action;
			this.hasVar = hasVar;
			this.func = func;
		}
	};

    public class WorldUI
    {
		public EBATCore core;
		public CustomUI customUi;
		
		public WorldUIBase worldUIBase;
		
		// public bool isMinimize = false;
		public Action tempAct1 = null;
		public Action tempAct2 = null;
		public Vector3 canvasPos;
		public Quaternion canvasRot;
				
		public UIDynamic uiCorner;
		
		public UIDynamicTextField uiStatusField;
		public UIDynamicTextField uiTemporaryText;
		public UIDynamicButton uiTemporaryButton;
		public UIDynamicButton uiTemporaryButtonY;
		public UIDynamicButton uiTemporaryButtonN;
		public string strStatusField = "The status of the Person is displayed here.";
		
		public UIDynamicSlider uiStrengthSlider;
		public UIDynamicSlider uiWaveSlider;
		public UIDynamicSlider uiGaugeSlider;
		public UIDynamicSlider uiPitchSlider;
		public UIDynamicSlider uiVolumeSlider;
		public UIDynamicSlider uiScaleSlider;
		public string strStrengthSlider = "Expression Strength";
		public string strWaveSlider = "Cycles of Orgasm(Max)";
		public string strGaugeSlider = "Ecstasy Level";
		public string strPitchSlider = "Sound Pitch";
		public string strVolumeSlider = "Sound Volume";
		public string strScaleSlider = "CUA Scale";
		
		public string strGenderSVar  = "She";
		public string strGenderPVar = "her";
		public string strGenderOVar = "her";
		public string strExpandAlt = "[-]";

		public float quick1 = 0.00f;
		public float quick2 = 0.55f;
		public float quick3 = 1.10f;
		public float quick4 = 1.65f;
		public float quick5 = 2.20f;
		public float quick6 = 2.75f;
		public float quick7 = 3.30f;
		
		public float spacerSizeX = 1000f;
		public float spacerSizeY = 600f;
		public float buttonSizeX = 200f;
		public float buttonSizeX3 = 800f;
		public float buttonSizeY  = 40f;
		public float buttonSizeY2 = 90f;
		public float buttonSizeY3 = 140f;
		public float buttonSizeY4 = 190f;
		public float buttonSizeY5 = 240f;
		public float buttonSizeY6 = 290f;
		public float buttonSizeY7 = 340f;
		public float buttonSizeY8 = 390f;
		public float buttonSizeY9 = 440f;
		public float buttonSizeY10 = 490f;
		public float buttonSizeY11 = 540f;
		public float buttonSizeY12 = 590f;
		public float buttonSizeY13 = 640f;
		public float toggleSizeX = 200f;
		public float toggleSizeY = 40f;
		public float sliderSizeX = 400f;
		public float sliderSizeY  =  80f;
		public float sliderSizeY2 = 180f;
		public float sliderSizeY3 = 280f;
		public float sliderSizeY4 = 380f;
		public float sliderSizeY5 = 480f;
		public float headerX  = 50f;
		public float headerX2 =  0f;
		public float buttonSizeMinimizeX = 10f;
		public float buttonSizeXQuick  = 55f;

		public string strInstantSoundLow    = "Low(0.9)";
		public string strInstantSoundMiddle = "Middle(1.0)";
		public string strInstantSoundHigh   = "High(1.2)";
		public UIDynamicButton uiInstantSoundLow;
		public UIDynamicButton uiInstantSoundMiddle;
		public UIDynamicButton uiInstantSoundHigh;

		public string strInstantVolumeLow    = "Low(0.5)";
		public string strInstantVolumeMiddle = "Middle(0.7)";
		public string strInstantVolumeHigh   = "High(1.0)";
		public UIDynamicButton uiInstantVolumeLow;
		public UIDynamicButton uiInstantVolumeMiddle;
		public UIDynamicButton uiInstantVolumeHigh;

		public string strInstantStrengthLow    = "Low(0.8)";
		public string strInstantStrengthMiddle = "Middle(1.0)";
		public string strInstantStrengthHigh   = "High(1.1)";
		public UIDynamicButton uiInstantStrengthLow;
		public UIDynamicButton uiInstantStrengthMiddle;
		public UIDynamicButton uiInstantStrengthHigh;

		public string strInstantWaveLow    = "Low(5)";
		public string strInstantWaveMiddle = "Middle(10)";
		public string strInstantWaveHigh   = "High(20)";
		public string strInstantWave999    = "999";
		public UIDynamicButton uiInstantWaveLow;
		public UIDynamicButton uiInstantWaveMiddle;
		public UIDynamicButton uiInstantWaveHigh;
		public UIDynamicButton uiInstantWave999;

		public string strInstantScaleLow    = "Low(0.9)";
		public string strInstantScaleMiddle = "Middle(1.0)";
		public string strInstantScaleHigh   = "High(1.1)";
		public UIDynamicButton uiInstantScaleLow;
		public UIDynamicButton uiInstantScaleMiddle;
		public UIDynamicButton uiInstantScaleHigh;
		// public bool categoryOn = true;

		public List<string> expandKeys = new List<string>(){
			"UI1", "Link1", "Action1", "Action2", "Action3", "Config1", "Config2", "Config3", "Config4", "Slider1", "Slider2", 
			"Addon1", "Addon2", "Test", "Main", 
		};
		
		public List<string> categoryKeys = new List<string>(){
			"Bar", "UI", "Action", "Config", "Slider", "Addon1", "Addon2", "Test", "Main",
		};
		
		public int line = -4;
		public int lineMainLast = 0;
		
        public WorldUI(EBATCore core, float scale = 0.002f)
        {
			this.core = core;
			this.canvasPos = new Vector3(0f, 0f, 0f);
			this.canvasRot = new Quaternion(0f, 0f, 0f, 0f);
			this.lineMainLast = 0;
			worldUIBase = new WorldUIBase(core, this, scale);
        }

		public void LoadSettings(){
			this.customUi = core.customUi;
			worldUIBase.LoadSettings();
		}
				
		public void ApplySettings(){
			try{
				strGenderSVar = (core.gender=="Male") ? "He"  : "She";
				strGenderPVar = (core.gender=="Male") ? "his" : "her";
				strGenderOVar = (core.gender=="Male") ? "him" : "her";
			}catch(Exception e){
				core.LoggerE(e);
			}
		}
		
		public void OnDestroy()
		{
			RemoveMenuBody();
			RemoveMenuBodyTemporary();
			core.addonManager1.DoWorldUIAddon1Function("RemoveMenuBodyAddon");
			core.DoAddonManager2Function("RemoveMenuBodyAddon");
			worldUIBase.RemoveMenuBase();
			core.RemoveGameObjectByName("SphereForUICorner");
		}

		public void MakeWorldUI(){
			try{

			if(!core.menuOnGlobal){
				return;
			}
			core.StartCoroutine(MakeWorldUICoroutine());
			}catch(Exception e){
				core.LoggerE(e);
			}
		}
		
		public void ReadMemories(){
			ReadMemory();
			core.addonManager1.worldUIAddon1.ReadMemory();
			core.DoAddonManager2Function("ReadMemory");
		}

		public IEnumerator MakeWorldUICoroutine(){
			for(int i = 0; i < 2000; i++){
				if(core.commonMemory == null){
					yield return new WaitForSeconds(0.1f);
				}else{
					break;
				}
			}

			if(core.hasCommonMemory == false){
				InitMemory();
			}else{
				ReadMemories();
				ChangeDefaultValue();
			}
			MakeDummyEntry();
			
			worldUIBase.MakeMenuBase();
			worldUIBase.MakeMenuBase("temporary");
			core.VersionCheck();

			if(IsPaused()){
			// if(core.GetMemoryBool("isPaused")){
				MakeMenuBodyPartMinAltPaused();
			}else{
				if(IsMinimized()) {
					OnMinimizeStartClick();
				}else{
					ExpandMenu();
				} 
			}
			
			yield return null;
		}
		
		public void MakeDummyEntry(){
			core.SetMemoryBool("DummyEntry", true);
			core.ChangeDefaultValueBool("DummyEntry", false);
		}
		
		public List<string> MemoryKeys = new List<string>(){"isSmall", "isCompact", "isCollapse", "isBarOnly", "isPaused", "isMinimized", "categoryOn"};
		public List<string> ExternalLinkageKeys = new List<string>(){"Reload:PostMagic", "Reload:VAMMoan", "Reload:BrowserAssist"};

		public List<string> UIPositionKeys = new List<string>(){"UI Position.x", "UI Position.y", "UI Position.z"};
		public List<string> UIRotationKeys = new List<string>(){"UI Rotation.x", "UI Rotation.y", "UI Rotation.z", "UI Rotation.w"};

		public void MakeButtonStructures(){
				MakeStructureNormalButton();
				core.addonManager1.worldUIAddon1.MakeButtonStructures();
				core.DoAddonManager2Function("MakeButtonStructures");
		}

		public void InitMemory(){
			try{
				categoryKeys.ForEach((key) => { core.SetMemoryBool(key, true); core.SetMemoryBool("CAT_" + key, true); });
				expandKeys.ForEach((key) => { core.SetMemoryBool(key, true); core.SetMemoryBool("BBOS_" + key, true); });
				MemoryKeys.ForEach(key => core.SetMemoryBool(key, false));
				ExternalLinkageKeys.ForEach(key => core.SetMemoryBool(key, false));
				MakeButtonStructures();

				foreach(var name in ButtonStructDic.Keys.ToList()){
					if(!name.StartsWith("C:")) continue;
					var bs = ButtonStructDic[name];
					core.SetMemoryBool(name, bs.func());
				}

				core.SetMemoryBool("Main", true);
				core.hasCommonMemory = true;
				core.InitDone = true;
			}catch(Exception e){
				core.LoggerE(e);
			}
		}

		public void ChangeDefaultValue(){
			try{
				categoryKeys.ForEach((key) => { core.ChangeDefaultValueBool(key, true); core.ChangeDefaultValueBool("CAT_" + key, true); });
				expandKeys.ForEach((key) => { core.ChangeDefaultValueBool(key, true); core.ChangeDefaultValueBool("BBOS_" + key, true); });
				MemoryKeys.ForEach(key => core.ChangeDefaultValueBool(key, false));

				// core.SetMemoryBool("Main", true);
				UIPositionKeys.ForEach(key => core.ChangeDefaultValueFloat(key, 0f));
				UIRotationKeys.ForEach(key => core.ChangeDefaultValueFloat(key, 0f));
			}catch(Exception e){
				core.LoggerE(e);
			}
		}

		public void ReadMemorySub(string key)
		{
			if(!core.HasMemoryFloat(key)) return;
			if(core.GetMemoryFloat(key) == 0f) core.DeleteMemoryFloat(key);
			else core.SetMemoryFloatIfNull(key, 0f); 				
		}

		public void ReadMemory(){
			try{
				// DebugMemory();
				categoryKeys.ForEach((key) => {core.SetMemoryBoolIfNull(key, true); core.SetMemoryBoolIfNull("CAT_" + key, true);});
				expandKeys.ForEach((key) => {core.SetMemoryBoolIfNull(key, true); core.SetMemoryBoolIfNull("BBOS_" + key, true);});
				MemoryKeys.ForEach(key => core.SetMemoryBoolIfNull(key, false));
				ExternalLinkageKeys.ForEach(key => core.SetMemoryBoolIfNull(key, false));

				MakeButtonStructures();

				foreach(var name in ButtonStructDic.Keys.ToList()){
					if(!name.StartsWith("C:")) continue;
					var bs = ButtonStructDic[name];
					if(!core.HasMemoryBool(name)){
						core.SetMemoryBool(name, bs.func());
					}else{
						var current = bs.func();
						var mem = core.GetMemoryBool(name);
						if(current != mem){
							bs.action();
						}
					}
				}

				core.SetMemoryBoolIfNull("Main", true);

				UIPositionKeys.ForEach(key => ReadMemorySub(key));
				UIRotationKeys.ForEach(key => ReadMemorySub(key));
				core.InitDone = true;
			}catch(Exception e){
				core.LoggerE(e);
			}
		}
		
		public void DebugMemorySub(string key, string type)
		{
			if(type == "bool") core.Info("key:" + key + ", value:"+ core.GetMemoryBool(key));
			else if(type == "float") core.Info("key:" + key + ", value:"+ core.GetMemoryFloat(key));
			else core.Info($"Error: key:{key} is UnknownType:{type}");
		}

		public void DebugMemory(){
			core.Info("in DebugMemory");
			try{
				categoryKeys.ForEach((key) => { DebugMemorySub(key, "bool"); DebugMemorySub("CAT_" + key, "bool");});
				expandKeys.ForEach((key) => { DebugMemorySub(key, "bool"); DebugMemorySub("BBOS_" + key, "bool");});
				MemoryKeys.ForEach(key => DebugMemorySub(key, "bool"));
				// DebugMemorySub("Main", "bool");
				UIPositionKeys.ForEach(key => DebugMemorySub(key, "float"));
				UIRotationKeys.ForEach(key => DebugMemorySub(key, "float"));
			}catch(Exception e){
				core.LoggerE(e);
			}
		}

		public bool IsPaused()
		{
			return core.GetMemoryBool("isPaused");
		}

		public bool IsMinimized()
		{
			return core.GetMemoryBool("isMinimized");
		}

		public bool IsCompact()
		{
			return core.GetMemoryBool("isCompact");
		}

		public bool IsCategoryOn()
		{
			return core.GetMemoryBool("categoryOn");
		}

		public void RemoveMenuAll(){
			RemoveMenuBody();
		}


		public void SetExpandValue(string type){
			var keys = IsCategoryOn() ? categoryKeys : expandKeys;
			var prefix = IsCategoryOn() ? "CAT_" : "BBOS_";
			if(type == "Expand"){
				foreach(var key in keys){
					if(key == "Addon1"){
						core.addonManager1.DoWorldUIAddon1Function("ExpandAddon1All");
					}else if(key == "Addon2"){
						core.DoAddonManager2Function("ExpandAddon2All");
					}else{
						core.SetMemoryBool(key, true);
					}
				}
				core.SetMemoryBool("isCollapse", false);
				core.SetMemoryBool("isMinimized", false);
			}else if(type == "Collapse"){
				foreach(var key in keys){
					if(key == "Addon1"){
						core.addonManager1.DoWorldUIAddon1Function("CollapseAddon1All");
					}else if(key == "Addon2"){
						core.DoAddonManager2Function("CollapseAddon2All");
					}else{
						core.SetMemoryBool(key, false);
					}
				}
				core.SetMemoryBool("isCollapse", true);
			}else if(type == "Recovery"){
				foreach(var key in keys){
					core.SetMemoryBool(key, core.GetMemoryBool(prefix + key));
					
					if(key == "Addon1"){
						if(core.GetMemoryBool(key)){							
							core.addonManager1.DoWorldUIAddon1Function("ExpandAddon1All");
						}else{
							core.addonManager1.DoWorldUIAddon1Function("CollapseAddon1All");
						}
					}else if(key == "Addon2"){
						if(core.GetMemoryBool(key)){							
							core.DoAddonManager2Function("ExpandAddon2All");
						}else{
							core.DoAddonManager2Function("CollapseAddon2All");
						}
					}
				}
				core.SetMemoryBool("isCollapse", false);
				core.SetMemoryBool("isCompact", IsCompact());
				core.SetMemoryBool("isMinimized", IsMinimized());
			}else if(type == "BarOnly"){
				foreach(var key in keys){
					core.SetMemoryBool(prefix + key, core.GetMemoryBool(key));
					if(key == "Addon1"){
						core.addonManager1.DoWorldUIAddon1Function("CollapseAddon1All");
					}else if(key == "Addon2"){
						core.DoAddonManager2Function("CollapseAddon2All");
					}else if(key == "Slider1" || key == "Bar"){
						core.SetMemoryBool(key, true);
					}else{
						core.SetMemoryBool(key, false);
					}
				}
				core.SetMemoryBool("isCompact", IsCompact());
				core.SetMemoryBool("isCollapse", true);
				core.SetMemoryBool("isCompact", true);
				core.SetMemoryBool("isMinimized", false);
			}
		}

		public void MakeMenuBody(){
			line = 0;
			MakeMenuBodyMain();
			lineMainLast = line;
			lineMainLast -= 2;
			core.addonManager1.DoWorldUIAddon1Function("MakeMenuBodyAddon");
			core.DoAddonManager2Function("MakeMenuBodyAddon");
			LabelSwitch();
			Coloring();
		}

		public List<string> MakeMenuBodyMainOrder = new List<string>(){"Slider1", "UI1", "Link1", "Action1", "Action2", "Action3", "Config1", "Config2", "Config3", "Config4", "Slider2",};
		public List<string> MakeMenuBodyMainOrder2 = new List<string>(){"Bar", "UI", "Action", "Config", "Slider",};

		public int GetLineNumber(){
			var list = IsCategoryOn() ? MakeMenuBodyMainOrder2 : MakeMenuBodyMainOrder;
			var sum = 0;
			foreach(var name in list){
				if(!core.addon2ModeOn && name == "Action3") continue;
				if(!ExpandStructDic.ContainsKey(name)) continue;
				var offsetYnormal = IsCompact() ?  0 : 1;
				var offsetYslider = IsCompact() ? -1 : 0;
				if(name == "Slider1" || name == "Slider2" || name == "Bar" || name == "Slider"){
					var y = !core.GetMemoryBool(name) ? offsetYslider : 1 + ExpandStructDic[name].additionalHeight();
					sum += y;
				}else{
					var y = !core.GetMemoryBool(name) ? offsetYnormal : 1 + ExpandStructDic[name].additionalHeight();
					sum += y;
				}
			}
			return sum;
		}

		public void MakeMenuBodyMain(){

			MakeMenuBodyPartMin();
			worldUIBase.MakeMenuBodyPartExpandCollapseButton("Main", core.GetMemoryBool("Main"), uiExpandButtons);

			var list = IsCategoryOn() ? MakeMenuBodyMainOrder2 : MakeMenuBodyMainOrder;
			if(!core.GetMemoryBool("Main")) return;
			foreach(var key in list)
			{
				if(!core.addon2ModeOn && key == "Action3") continue;
				if(core.GetMemoryBool(key)){
					MakeMenuBodyPartExpandButtonCommon(key, false);
				}else{
					if(!IsCompact()){
						MakeMenuBodyPartExpandButtonCommon(key, true);
					}
				}
			}
		}
		
		public struct ExpandStruct{
			public string category;
			public string normal;
			public string alt;
			public Func<int> additionalHeight;
			public Func<float> menuHeight;
			public Action actionMakeBodyPart;

			public ExpandStruct(string category, string normal, string alt, Action actionMakeBodyPart, Func<int> func, Func<float> func2){
				this.category = category;
				this.normal = normal;
				this.alt = alt;
				this.actionMakeBodyPart = actionMakeBodyPart;
				this.additionalHeight = func;
				this.menuHeight = func2;
			}
		};

		public Dictionary<string, ExpandStruct> ExpandStructDic;
		public Dictionary<string, UIDynamicButton> uiExpandButtons;

		public void MakeStructureExpandButton()
		{
			uiExpandButtons = new Dictionary<string, UIDynamicButton>();

			ExpandStructDic = new Dictionary<string, ExpandStruct>(){
				{"Slider1",		new ExpandStruct("Bar", "❤bar[▶]"  	,"❤bar[◀]"	  ,MakeMenuBodyPartBar	,() => 0	,() => sliderSizeY)},
				{"UI1",			new ExpandStruct("UI", "UI[▶]"		,"UI[◀]"		,MakeMenuBodyPartUI1	,() => 2	,() => buttonSizeY3)},
				{"Link1",		new ExpandStruct("Link", "Link[▶]"		,"Link[◀]"		,MakeMenuBodyPartLink1	,() => 1	,() => buttonSizeY2)},
				{"Action1",		new ExpandStruct("Action", "Action1[▶]"	,"Action1[◀]"	,MakeMenuBodyPartAction1	,() => 1	,() => buttonSizeY2)},
				{"Action2",		new ExpandStruct("Action", "Action2[▶]"	,"Action2[◀]"	,MakeMenuBodyPartAction2	,() => 1	,() => buttonSizeY2)},
				{"Action3",		new ExpandStruct("Action", "Action3[▶]"	,"Action3[◀]"	,MakeMenuBodyPartAction3	,() => 1	,() => buttonSizeY2)},
				{"Config1",		new ExpandStruct("Config", "Config1[▶]"	,"Config1[◀]"	,MakeMenuBodyPartConfig1	,() => 1	,() => buttonSizeY2)},
				{"Config2",		new ExpandStruct("Config", "Config2[▶]"	,"Config2[◀]"	,MakeMenuBodyPartConfig2	,() => 2	,() => buttonSizeY3)},
				{"Config3",		new ExpandStruct("Config", "Config3[▶]"	,"Config3[◀]"	,MakeMenuBodyPartConfig3	,() => IsCompact() ? 0 : 1	,() => IsCompact() ? buttonSizeY : buttonSizeY2)},
				{"Config4",		new ExpandStruct("Config", "Config4[▶]"	,"Config4[◀]"	,MakeMenuBodyPartConfig4	,() => core.orgasmModeOn ? 1 : 0	,() => core.orgasmModeOn ? buttonSizeY2 : buttonSizeY)},
				{"Slider2",		new ExpandStruct("Slider", "Slider[▶]"	,"Slider[◀]"	,MakeMenuBodyPartSlider2	,() => (core.orgasmModeOn ? 6 : 4) + (core.addon2ModeOn ? 2 : 0)	,() => !core.orgasmModeOn ? sliderSizeY2 : (core.addon2ModeOn ? sliderSizeY5 : sliderSizeY4))},
			};
   		}

		public void MakeStructureCategoryButton()
		{
			ExpandStructDic.Add("Bar",			new ExpandStruct("Bar", "❤bar[▶]"  	,"❤bar[◀]"	  ,MakeMenuBodyPartBar	,() => 0	,() => sliderSizeY));
			ExpandStructDic.Add("UI",			new ExpandStruct("UI", "UI[▶]"		,"UI[◀]"		,MakeMenuBodyPartUI	,() => 4	,() => buttonSizeY5));
			ExpandStructDic.Add("Action",		new ExpandStruct("Action", "Action[▶]"	,"Action[◀]"	,MakeMenuBodyPartAction	,() => core.addon2ModeOn ? 5 : 3	,() => core.addon2ModeOn ? buttonSizeY6 : buttonSizeY4));
			ExpandStructDic.Add("Config",		new ExpandStruct("Config", "Config[▶]"	,"Config[◀]"	,MakeMenuBodyPartConfig	,() => IsCompact() ? 7 : 8	,() => IsCompact() ? buttonSizeY8 : buttonSizeY9));
			ExpandStructDic.Add("Slider",		new ExpandStruct("Slider", "Slider[▶]"	,"Slider[◀]"	,MakeMenuBodyPartSlider	,() => (core.orgasmModeOn ? 6 : 4) + (core.addon2ModeOn ? 2 : 0)	,() => !core.orgasmModeOn ? sliderSizeY2 : (core.addon2ModeOn ? sliderSizeY5 : sliderSizeY4)));
   		}

		public void MakeMenuBodyPartExpandButtonCommon(string type, bool forExpand)
		{
			if(ExpandStructDic == null) return;
			if(uiExpandButtons == null) return;
			if(forExpand)
			{
				UIDynamicButton ui = MakeButton(ExpandStructDic[type].normal, -1, line);
				ui.button.onClick.AddListener(() => OnExpandCommon(type));
				if(uiExpandButtons.ContainsKey(type)) uiExpandButtons[type] = ui;
				else uiExpandButtons.Add(type, ui);
				line++;
			}
			else
			{
				if(type == "Slider1" || type == "Slider2" || type == "Slider" || type == "Bar") line++;
				UIDynamicButton ui = MakeButton(ExpandStructDic[type].alt, -1, 
						line + ExpandStructDic[type].additionalHeight(),
						height:ExpandStructDic[type].menuHeight());
				ui.button.onClick.AddListener(() => OnExpandCommon(type));
				if(uiExpandButtons.ContainsKey(type)) uiExpandButtons[type] = ui;
				else uiExpandButtons.Add(type, ui);
				ExpandStructDic[type].actionMakeBodyPart();
			}
		}


		public Dictionary<string, string> LabelVarDic;
		public Dictionary<string, ButtonStruct> ButtonStructDic;
		public Dictionary<string, UIDynamicButton> uiHeaderButtons;
		public Dictionary<string, UIDynamicButton> uiBodyButtons;
		public List<string> PartMinOrder1 = new List<string>(){"M:Minimize",};
		public List<string> PartMinOrder = new List<string>(){"M:Minimize", "M:PauseMenu", "M:BrowserAssist", "M:ChangeSize", "M:CompactMenu", "M:BarUI", "M:CollapseExpand", "M:LookFront", "M:CategoryOn"};
		// public List<string> PartMinPausedOrder = new List<string>(){"Minimize", "PauseMenu",};
		public List<string> PartMinPausedOrder = new List<string>(){"M:Minimize", "M:PauseMenu",};
		public List<string> PartUiOrder1 = new List<string>(){"Open Atom UI", "Open Custom UI", "Close UI", "Reset UI",};
		public List<string> PartUiOrder2 = new List<string>(){"Open Clothing UI", "Open Hair UI", "Open FemaleMorphs", "Open MaleMorphs",};
		public List<string> PartUiOrder3 = new List<string>(){"Reload This Plugin", "Reload All Plugins", "Close This Menu",};
		public List<string> PartUiOrder4 = new List<string>(){"C:Colortone", "C:PostMagic", "C:PostMagicWDoF", "C:VAMMoan",};
		public List<string> PartUiOrder5 = new List<string>(){"BrowserAssist", "C:BrowserAssist", };
		// public List<string> PartUiOrder5 = new List<string>(){"C:BrowserAssist",};

		public List<string> PartAction1Order1 = new List<string>(){"Make Her Orgasm", "Make Her Squirt", "Calm Her Down", "Reset Expression",};
		public List<string> PartAction1Order2 = new List<string>(){"Stage Up", "Stage Down",};
		public List<string> PartAction2Order1 = new List<string>(){"Face Forward", "Turn Head Back(T)", "Turn Head Back(L)", "H:Hint4",};
		public List<string> PartAction2Order2 = new List<string>(){"Face Sideways(T)", "Face Sideways(S)", "Face Sideways(M)", "Face Sideways(L)",};
		public List<string> PartAction3Order1 = new List<string>(){"Cover with Hands", "Cover with HandsUU", "Cover with HandsUL", "Cover with HandsLL", };
		public List<string> PartAction3Order2 = new List<string>(){"Close Legs", "Cover Mouth", "Single Wave"};

		public List<string> partConfig1Order1 = new List<string>(){"C:Expression", "C:Blushing", "C:Tears", "C:Drool", };
		public List<string> partConfig1Order2 = new List<string>(){"C:AutoExprOFF", "C:AutoBlinkOFF", "C:EyesControl", "C:EyesRollup", };
		public List<string> partConfig2Order1 = new List<string>(){"C:Peeing", "C:Sound", "C:Use VAMMoan", "H:Hint10", };
		// public List<string> partConfig2Order2 = new List<string>(){"C:HeadMotion", "C:2x Collider Radius", "C:Sensitive Trigger",};
		public List<string> partConfig2Order2 = new List<string>(){"C:HeadMotion", "C:2x Collider Radius", "C:Collision Failure Check", "C:Collision Auto Fix", };
		// public List<string> partConfig2Order3 = new List<string>(){"C:Penis Support", "H:Hint2", "H:Hint5", "H:Hint11",};
		public List<string> partConfig2Order3 = new List<string>(){"C:Penis Support", "H:Hint2", "H:Hint15", "H:Hint11",};

		public List<string> partConfig3Order1 = new List<string>(){"C:AutoStop Plugins", "C:AutoStop Morph", "C:AutoStop Head", "C:AutoStop Body", };
		public List<string> partConfig3Order2 = new List<string>(){"H:Hint3", "H:Hint6", "H:Hint7", "H:Hint8", };
		public List<string> partConfig4Order1 = new List<string>(){"C:NippleErection", "C:ClitorisErection",};
		public List<string> partConfig4Order2 = new List<string>(){"C:Shivering(Bone)", "C:Shivering(Morph)", "H:Hint9",};

		public void MakeStructureNormalButton()
		{
			uiHeaderButtons = new Dictionary<string, UIDynamicButton>();
			uiBodyButtons = new Dictionary<string, UIDynamicButton>();
			LabelVarDic = new Dictionary<string, string>();
			ButtonStructDic = new Dictionary<string, ButtonStruct>(){
				{"M:Minimize",		new ButtonStruct("❏"  	,"❏"			,OnMinimizeClick, false, null)},
				{"M:PauseMenu",		new ButtonStruct("Suspend"  ,"Resume"		,OnPauseClick, true, () => IsPaused())},
				{"M:BrowserAssist",   new ButtonStruct("run BA"	    ,"BrowserAssist"	,OnBrowserAssistOnClick		,false, null)},
				{"M:ChangeSize",		new ButtonStruct("UI Small"  ,"UI Large"	,OnChangeSizeClick, true, () => core.GetMemoryBool("isSmall"))},
				{"M:CompactMenu",		new ButtonStruct("Compact"  ,"Normal"		,OnCompactClick, true, () => IsCompact())},
				{"M:BarUI",			new ButtonStruct("❤Only"  ,"❤Recovery"		,OnCollapseWOBarUIClick, true, () => core.GetMemoryBool("isBarOnly"))},
				{"M:CollapseExpand",	new ButtonStruct("Collapse"  ,"Expand"		,OnCollapseExpandClick, true, () => core.GetMemoryBool("isCollapse"))},
				{"M:LookFront",		new ButtonStruct("LookFront"  ,"LookFront"	,OnLookFrontClick, false, null)},
				{"M:CategoryOn",		new ButtonStruct("Category1"  ,"Category2"	,OnCategoryOnClick, false, () => IsCategoryOn())},

				{"Open Atom UI",		new ButtonStruct("Open Atom UI"  		,"Open Atom UI"		,OnOpenAtomMenuClick		,false, null)},
				{"Open Custom UI",		new ButtonStruct("Open Custom UI"  		,"Open Custom UI"	,OnOpenCustomUIClick		,false, null)},
				{"Close UI",			new ButtonStruct("Close UI"  			,"Close UI"			,OnCloseUIClick, false, null)},
				{"Reset UI",			new ButtonStruct("Reset UI"  			,"Reset UI"			,OnResetUIClick, false, null)},

				{"Open Clothing UI",	new ButtonStruct("Open Clothing UI"  	,"Open Clothing UI"		,OnOpenClothingUIClick		,false, null)},
				{"Open Hair UI",		new ButtonStruct("Open Hair UI"  		,"Open Hair UI"			,OnOpenHairUIClick			,false, null)},
				{"Open FemaleMorphs",	new ButtonStruct("Open FemaleMorphs"	,"Open FemaleMorphs"	,OnOpenFemaleMorphsUIClick	,false, null)},
				{"Open MaleMorphs",		new ButtonStruct("Open MaleMorphs"		,"Open MaleMorphs"		,OnOpenMaleMorphsUIClick		,false, null)},

				{"C:Colortone",         new ButtonStruct("Colortone"	     	,"Colortone"		,OnToggleColortoneClick		,false, () => core.externalLinkage.IsColortoneOn())},
				{"C:PostMagic",         new ButtonStruct("PostMagic"	     	,"PostMagic"		,() => OnTogglePostMagicClick(false)		,false, () => core.externalLinkage.IsPostMagicOn(false))},
				{"C:PostMagicWDoF",     new ButtonStruct("PostMagic+DoF"	    ,"PostMagic+DoF"	,() => OnTogglePostMagicClick(true)		,false, () => core.externalLinkage.IsPostMagicOn(true))},
				{"C:VAMMoan",           new ButtonStruct("VAMMoan"	     	    ,"VAMMoan"		    ,OnToggleVAMMoanClick		,false, () => core.externalLinkage.IsVAMMoanOn())},

				{"C:BrowserAssist",     new ButtonStruct("BrowserAssist"	    ,"BrowserAssist"    ,OnToggleBrowserAssistClick		,false, () => core.externalLinkage.IsBrowserAssistOn())},
				{"BrowserAssist",       new ButtonStruct("run BA"	    ,"BrowserAssist"	,OnBrowserAssistOnClick		,false, null)},

				{"Reload This Plugin",	new ButtonStruct("Reload This Plugin"	,"Reload This Plugin"	,OnReloadThisPluginOnlyClick	,false, null)},
				{"Reload All Plugins",	new ButtonStruct("Reload All Plugins"	,"Reload All Plugins"	,OnReloadPluginsClick		,false, null)},
				{"Close This Menu",		new ButtonStruct("Close This Menu"		,"Close This Menu"		,OnCloseMenuClick			,false, null)},

				{"Make Her Orgasm",		new ButtonStruct("Make Her Orgasm"	,"Stop Her Orgasm"	,OnOrgasmButtonClick		,true,	 () => core.GetGauge() >= core.stageThresholdInGame[5])},
				{"Make Her Squirt",		new ButtonStruct("Make Her Squirt"	,"Make Her Squirt"	,OnPeeButtonClick		,false, null)},
				{"Calm Her Down",		new ButtonStruct("Calm Her Down"	,"Calm Her Down"	,OnCalmDownButtonClick	,false, null)},
				{"Reset Expression",	new ButtonStruct("Reset Expression"	,"Reset Expression"	,OnResetExpressionButton	,false, null)},

				{"Stage Up",		new ButtonStruct("Stage Up"  	,"Stage Up"		,OnStageUp	,false, null)},
				{"Stage Down",		new ButtonStruct("Stage Down"	,"Stage Down"	,OnStageDown	,false, null)},

				{"Face Forward",		new ButtonStruct("Face Forward"  	,"Face Forward"				,OnFaceForwardClick, false, null)},
				{"Turn Head Back(T)",	new ButtonStruct("Turn Head Back(T)"  ,"Turn Head Back(T)"		,OnBackBendingWeakClick, false, null)},
				{"Turn Head Back(L)",	new ButtonStruct("Turn Head Back(L)"  ,"Turn Head Back(L)"		,OnBackBendingStrongClick, false, null)},
				{"H:Hint4",	new ButtonStruct("Help for Face Sideways..."  ,"Help for Face Sideways..."	,OnHint4Click, false, null)},
				{"Face Sideways(T)",	new ButtonStruct("Face Sideways(T)"	,"Face Sideways(T)"			,OnLookGlancingClick, false, null)},
				{"Face Sideways(S)",	new ButtonStruct("Face Sideways(S)"	,"Face Sideways(S)"			,OnFaceSidewaysClick, false, null)},
				{"Face Sideways(M)",	new ButtonStruct("Face Sideways(M)"	,"Face Sideways(M)"			,OnFaceSidewaysAltClick, false, null)},
				{"Face Sideways(L)",	new ButtonStruct("Face Sideways(L)"	,"Face Sideways(L)"			,OnFaceSidewaysMaxClick, false, null)},

				{"Cover with Hands",	new ButtonStruct("Cover with Hands RND"	,"Cover with Hands RND"			,() => OnCoverActionClick("Hands"), false, null)},
				{"Cover with HandsUU",	new ButtonStruct("Cover with Hands U&U"	,"Cover with Hands U&U"			,() => OnCoverActionClick("HandsUU"), false, null)},
				{"Cover with HandsUL",	new ButtonStruct("Cover with Hands U&L"	,"Cover with Hands U&L"			,() => OnCoverActionClick("HandsUL"), false, null)},
				{"Cover with HandsLL",	new ButtonStruct("Cover with Hands L&L"	,"Cover with Hands L&L"			,() => OnCoverActionClick("HandsLL"), false, null)},
				{"Close Legs",			new ButtonStruct("Close Legs"	,"Close Legs"					,() => OnCoverActionClick("Legs"), false, null)},
				{"Cover Mouth",			new ButtonStruct("Cover Mouth"	,"Cover Mouth"					,() => OnCoverActionClick("Mouth"), false, null)},

				{"Single Wave",			new ButtonStruct("Single Wave"	,"Single Wave"					,() => OnSingleWaveClick(), false, null)},

				{"C:Expression",	new ButtonStruct("Expression"	,"Expression"	,() => OnConfigXClickCommon("C:Expression")	,true, () => core.expression2.expressionOnGlobal)},
				{"C:Blushing",		new ButtonStruct("Blushing" 	,"Blushing"		,() => OnConfigXClickCommon("C:Blushing")	,true, () => core.blushing.BlushOn)},
				{"C:Tears",			new ButtonStruct("Tears"  		,"Tears"		,() => OnConfigXClickCommon("C:Tears")	,true, () => core.tears.TearsOn)},
				{"C:Drool",			new ButtonStruct("Drool"  		,"Drool"		,() => OnConfigXClickCommon("C:Drool")	,true, () => core.tears.DroolOn)},

				{"C:AutoExprOFF",	new ButtonStruct("AutoExprOFF"	,"AutoExprOFF"	,() => OnConfigXClickCommon("C:AutoExprOFF")	,true, () => core.etc.autoExpressionOffGlobal)},
				{"C:AutoBlinkOFF",	new ButtonStruct("AutoBlinkOFF"	,"AutoBlinkOFF"	,() => OnConfigXClickCommon("C:AutoBlinkOFF")	,true, () => core.etc.autoBlinkOffGlobal)},
				{"C:EyesControl",	new ButtonStruct("EyesControl" 	,"EyesControl"	,() => OnConfigXClickCommon("C:EyesControl")	,true, () => core.eyesControl.eyecontrolOnGlobal)},
				{"C:EyesRollup",	new ButtonStruct("EyesRollup"  	,"EyesRollup"	,() => OnConfigXClickCommon("C:EyesRollup")	,true, () => core.eyesControl.eyecontrolRollupOnGlobal)},

				{"C:Peeing",		new ButtonStruct("Peeing"  		,"Peeing"		,() => OnConfigXClickCommon("C:Peeing")	,true, () => core.customUnityAssetItem.peeingOnGlobal)},
				{"C:Sound",			new ButtonStruct("Sound"  		,"Sound"		,() => OnConfigXClickCommon("C:Sound")	,true, () => core.sound.soundOnGlobal)},
				{"C:Use VAMMoan",	new ButtonStruct("Use VAMMoan"  ,"Use VAMMoan"	,() => OnConfigXClickCommon("C:Use VAMMoan") 	,true, () => core.vammoanLinkOnGlobal)},
				{"H:Hint10",	new ButtonStruct("Help for Use VAMMoan..."  ,"..."	,OnHint10Click			,false, null)},

				{"C:HeadMotion",			new ButtonStruct("HeadMotion"  ,"HeadMotion"					,() => OnConfigXClickCommon("C:HeadMotion")	,true, () => core.headController.headMotionOnGlobal)},
				{"C:2x Collider Radius",	new ButtonStruct("2x Collider Radius"  ,"2x Collider Radius"	,() => OnConfigXClickCommon("C:2x Collider Radius")	,true, () => core.collider2xOnGlobal)},
				{"C:Collision Failure Check",		new ButtonStruct("SensitiveTrigger"  ,"SensitiveTrigger"		,() => OnConfigXClickCommon("C:Collision Failure Check")	,true, () => core.collisionFailureCheckOnGlobal)},
				{"C:Collision Auto Fix",		new ButtonStruct("CollisionAutoFix"  ,"CollisionAutoFix"		,() => OnConfigXClickCommon("C:Collision Auto Fix")	,true, () => core.collisionAutoFixOnGlobal)},

				{"C:Penis Support",		new ButtonStruct("Penis Support"	,"Penis Support"	,() => OnConfigXClickCommon("C:Penis Support"), true, () => core.manController.penisSupportOnGlobal)},
				{"H:Hint2",		new ButtonStruct("Help for 2x Collider..."	,"..."				,OnHint2Click, false, null)},
				{"H:Hint15",	new ButtonStruct("Help for Collision..."	,"..."				,OnHint15Click, false, null)},
				{"H:Hint11",	new ButtonStruct("Help for SkinWrap..."		,"..."				,OnHint11Click, false, null)},

				{"C:AutoStop Plugins",	new ButtonStruct("AutoStop Plugins"	,"AutoStop Plugins"	,() => OnConfigXClickCommon("C:AutoStop Plugins"), true, () => core.addonTakeControl.autoStopOnGlobal)},
				{"C:AutoStop Morph",	new ButtonStruct("AutoStop Morph"	,"AutoStop Morph"	,() => OnConfigXClickCommon("C:AutoStop Morph"), true, () => core.addonTakeControl.autoStopMorphOnGlobal)},
				{"C:AutoStop Head",		new ButtonStruct("AutoStop Head"  	,"AutoStop Head"	,() => OnConfigXClickCommon("C:AutoStop Head"), true, () => core.addonTakeControl.autoStopHeadOnGlobal)},
				{"C:AutoStop Body",		new ButtonStruct("AutoStop Body"  	,"AutoStop Body"	,() => OnConfigXClickCommon("C:AutoStop Body"), true, () => core.addonTakeControl.autoStopBodyOnGlobal)},

				{"H:Hint3",		new ButtonStruct("Help for Stop Plugins..."	,"..."	,OnHint3Click, false, null)},
				{"H:Hint6",		new ButtonStruct("Help for Stop Morph..."	,"..."	,OnHint6Click, false, null)},
				{"H:Hint7",		new ButtonStruct("Help for Stop Head..."	,"..."	,OnHint7Click, false, null)},
				{"H:Hint8",		new ButtonStruct("Help for Stop Body..."	,"..."	,OnHint8Click, false, null)},

				{"C:NippleErection",	new ButtonStruct("NippleErection"	,"NippleErection"	,() => OnConfigXClickCommon("C:NippleErection"), true, () => core.bodyMorph.nippleErectionOnGlobal)},
				{"C:ClitorisErection",	new ButtonStruct("ClitorisErection"	,"ClitorisErection"	,() => OnConfigXClickCommon("C:ClitorisErection"), true, () => core.bodyMorph.clitorisErectionOnGlobal)},

				{"C:Shivering(Bone)",	new ButtonStruct("Shivering(Bone)"	,"Shivering(Bone)"	,() => OnConfigXClickCommon("C:Shivering(Bone)"), true, () => core.bellyBoneOn)},
				{"C:Shivering(Morph)",	new ButtonStruct("Shivering(Morph)"	,"Shivering(Morph)"	,() => OnConfigXClickCommon("C:Shivering(Morph)"), true, () => core.bellyMorphOn)},
				{"H:Hint9",		new ButtonStruct("Help for Shivering..."	,"..."	,OnHint9Click, false, null)},
			};
		}

		public void LabelInitialize(string name)
		{
			if(ButtonStructDic == null) return;
			if(!ButtonStructDic.ContainsKey(name)) return;
			if(!ButtonStructDic[name].hasVar) return;
			ButtonStruct bs = ButtonStructDic[name];
			string label = bs.func() ? bs.alt : bs.normal;
			if(LabelVarDic.ContainsKey(name)) LabelVarDic[name] = label;
			else LabelVarDic.Add(name, label);
		}
		public void LabelInitialize(List<string> names)
		{
			foreach(var name in names){
				LabelInitialize(name);
			}
		}

		public void LabelUpdateNew(List<string> names)
		{
			foreach(var name in names){
				if(!ButtonStructDic.ContainsKey(name)) continue;
				if(!ButtonStructDic[name].hasVar) continue;
				if(!LabelVarDic.ContainsKey(name)) continue;
				ButtonStruct bs = ButtonStructDic[name];
				LabelVarDic[name] = bs.func() ? bs.alt : bs.normal;
			}
		}

		public string GetNewLabel(string name)
		{
			if(!ButtonStructDic.ContainsKey(name)) return "UnknownError";
			ButtonStruct bs = ButtonStructDic[name];

			if(name.StartsWith("C:")){
				string suffix = bs.func() ? "[ON]" : "[  ]";
				string label = bs.normal + suffix;			
				return label;
			}
			if(bs.hasVar){
				if(!LabelVarDic.ContainsKey(name)) return "UnknownError";
				return LabelVarDic[name];
			}

			return bs.normal;
		}

		public void MakeMenuBodyPartNormalButtonCommon(string name, int posx, bool isHeader = false)
		{
			try{
				var uiButtons = (isHeader) ? uiHeaderButtons : uiBodyButtons;
				if(ButtonStructDic == null) return;
				if(!ButtonStructDic.ContainsKey(name)) {
					Utility.Debug($"UnknownNormalButtonName:{name}");
					return;
				}

				ButtonStruct bs = ButtonStructDic[name];
				var tmpwidth = name.StartsWith("M:") ? 20f : 0f;
				bool compactOn = name.StartsWith("H:") ? true : false;
				bool isMinimize = name == "M:Minimize";
				bool isMinisize = name.StartsWith("M:");
				if(compactOn && IsCompact()) return;

				string label = GetNewLabel(name);
				UIDynamicButton ui = MakeButton(
					label, posx, line, width:tmpwidth, height:0f,
					isMinimizeButton:isMinimize, isMinisizeButton:isMinisize);
				ui.button.onClick.AddListener(() => bs.action());
				if(uiButtons.ContainsKey(name)) uiButtons[name] = ui;
				else uiButtons.Add(name, ui);
			}catch(Exception e){
				core.LoggerE(e);
			}
		}

		public void MakeMenuBodyPartHeaderCommon(List<string> order, bool forNormal = true, bool minimizeStatus = false)
		{
			try{
				line = 0;
				if(ButtonStructDic == null) return;
				uiCorner = MakeSpacer(-1, line);
				int posx = 0;
				LabelInitialize(order);
				foreach(var name in order){
					MakeMenuBodyPartNormalButtonCommon(name, posx, true);
					if(name != "M:Minimize") posx++;
				}
				LabelSwitch();
				Coloring();
				line++;
				core.SetMemoryBool("isMinimized", minimizeStatus);
				// isMinimize = minimizeStatus;
			}catch(Exception e){
				core.LoggerE(e);
			}
		}

		public void MakeMenuBodyPartMin(){
			MakeMenuBodyPartHeaderCommon(PartMinOrder, true, false);
		}

		public void MakeMenuBodyPartMinAlt(){
			MakeMenuBodyPartHeaderCommon(PartMinOrder, false, true);
		}
		
		public void MakeMenuBodyPartMinAltPaused(){
			MakeMenuBodyPartHeaderCommon(PartMinPausedOrder, false, true);
		}
		
		public void MakeMenuBodyPartBodyCommon(List<string> order, bool forNormal = true)
		{
			try{
				LabelInitialize(order);
				int posx = 0;
				foreach(var name in order){
					MakeMenuBodyPartNormalButtonCommon(name, posx);
					posx++;
				}
				LabelSwitch();
				Coloring();
				line++;
			}catch(Exception e){
				core.LoggerE(e);
			}
		}

		public void MakeMenuBodyPartUI(){
			MakeMenuBodyPartUI1();
			MakeMenuBodyPartLink1();
		}

		public void MakeMenuBodyPartUI1(){
			MakeMenuBodyPartBodyCommon(PartUiOrder1);
			MakeMenuBodyPartBodyCommon(PartUiOrder2);
			MakeMenuBodyPartBodyCommon(PartUiOrder3);
		}

		public void MakeMenuBodyPartLink1(){
			MakeMenuBodyPartBodyCommon(PartUiOrder4);
			MakeMenuBodyPartBodyCommon(PartUiOrder5);
		}

		public void MakeMenuBodyPartAction(){
			MakeMenuBodyPartAction1();
			MakeMenuBodyPartAction2();
			if(core.addon2ModeOn){
				MakeMenuBodyPartAction3();
			}
		}

		public void MakeMenuBodyPartAction1(){
			MakeMenuBodyPartBodyCommon(PartAction1Order1);
			MakeMenuBodyPartBodyCommon(PartAction1Order2);
		}

		public void MakeMenuBodyPartAction2(){
			MakeMenuBodyPartBodyCommon(PartAction2Order1);
			MakeMenuBodyPartBodyCommon(PartAction2Order2);
		}

		public void MakeMenuBodyPartAction3(){
			MakeMenuBodyPartBodyCommon(PartAction3Order1);
			MakeMenuBodyPartBodyCommon(PartAction3Order2);
		}

		public void MakeMenuBodyPartConfig(){
			MakeMenuBodyPartConfig1();
			MakeMenuBodyPartConfig2();
			MakeMenuBodyPartConfig3();
			MakeMenuBodyPartConfig4();
		}

		public void MakeMenuBodyPartConfig1(){
			MakeMenuBodyPartBodyCommon(partConfig1Order1);
			MakeMenuBodyPartBodyCommon(partConfig1Order2);
		}
		
		public void MakeMenuBodyPartConfig2(){
			MakeMenuBodyPartBodyCommon(partConfig2Order1);
			MakeMenuBodyPartBodyCommon(partConfig2Order2);
			MakeMenuBodyPartBodyCommon(partConfig2Order3);
		}
		
		public void MakeMenuBodyPartConfig3(){
			MakeMenuBodyPartBodyCommon(partConfig3Order1);
			if(!IsCompact()) MakeMenuBodyPartBodyCommon(partConfig3Order2);
		}
		
		public void MakeMenuBodyPartConfig4(){
			MakeMenuBodyPartBodyCommon(partConfig4Order1);
			MakeMenuBodyPartBodyCommon(partConfig4Order2);
		}
		
		public void MakeMenuBodyPartBar(){
			float gaugeMax = (float)core.stageThresholdInGame[5] * 1.2f;
			uiGaugeSlider = MakeSlider(strGaugeSlider, 0, line, 0f, gaugeMax, (float)core.GetGauge());				
			Image bgImage = uiGaugeSlider.GetComponentInChildren<Image>();
			bgImage.color = new Color(1f, 0.25f, 0.75f);
			uiGaugeSlider.labelText.color = new Color(1, 0, 0);

			if(!IsCompact()){
				uiStatusField = MakeTextField(strStatusField, quick4, line, width:buttonSizeX3, height:sliderSizeY);
			}
			line+= 1;
		}
		
		public void MakeMenuBodyPartSlider(){
			MakeMenuBodyPartSlider2();
		}

		public void MakeMenuBodyPartSlider2(){
			if(core.orgasmModeOn){
				uiWaveSlider = MakeSlider(strWaveSlider, 0, line, 0f, 1000f, core.orgasmWaveCycleBigMax);
				uiWaveSlider.slider.onValueChanged.AddListener(OnWaveSliderChange);
				uiInstantWaveLow    = MakeButton(strInstantWaveLow,    quick4, line, width:buttonSizeXQuick, height:sliderSizeY);
				uiInstantWaveMiddle = MakeButton(strInstantWaveMiddle, quick5, line, width:buttonSizeXQuick, height:sliderSizeY);
				uiInstantWaveHigh   = MakeButton(strInstantWaveHigh,   quick6, line, width:buttonSizeXQuick, height:sliderSizeY);
				uiInstantWave999    = MakeButton(strInstantWave999,    quick7, line, width:buttonSizeXQuick, height:sliderSizeY);
				uiInstantWaveLow.button.onClick.AddListener(   OnInstantWaveLowClick);
				uiInstantWaveMiddle.button.onClick.AddListener(OnInstantWaveMiddleClick);
				uiInstantWaveHigh.button.onClick.AddListener(  OnInstantWaveHighClick);
				uiInstantWave999.button.onClick.AddListener(   OnInstantWave999Click);
				line += 2;
			}
			
			if(core.addon2ModeOn){
				uiScaleSlider = MakeSlider(strScaleSlider, 0, line, 0.5f, 1.5f, core.assetScale);
				uiScaleSlider.slider.onValueChanged.AddListener(OnScaleSliderChange);
				uiInstantScaleLow    = MakeButton(strInstantScaleLow,    quick4, line, width:buttonSizeXQuick, height:sliderSizeY);
				uiInstantScaleMiddle = MakeButton(strInstantScaleMiddle, quick5, line, width:buttonSizeXQuick, height:sliderSizeY);
				uiInstantScaleHigh   = MakeButton(strInstantScaleHigh,   quick6, line, width:buttonSizeXQuick, height:sliderSizeY);
				uiInstantScaleLow.button.onClick.AddListener(   OnInstantScaleLowClick);
				uiInstantScaleMiddle.button.onClick.AddListener(OnInstantScaleMiddleClick);
				uiInstantScaleHigh.button.onClick.AddListener(  OnInstantScaleHighClick);
				line += 2;
			}
			
			uiPitchSlider = MakeSlider(strPitchSlider, 0, line, 0.8f, 1.5f, core.sound.headAudioSource.pitch);
			uiPitchSlider.slider.onValueChanged.AddListener(OnPitchSliderChange);
			uiInstantSoundLow    = MakeButton(strInstantSoundLow,   quick4, line, width:buttonSizeXQuick, height:sliderSizeY);
			uiInstantSoundMiddle = MakeButton(strInstantSoundMiddle,quick5, line, width:buttonSizeXQuick, height:sliderSizeY);
			uiInstantSoundHigh   = MakeButton(strInstantSoundHigh,  quick6, line, width:buttonSizeXQuick, height:sliderSizeY);
			uiInstantSoundLow.button.onClick.AddListener(   OnInstantSoundLowClick);
			uiInstantSoundMiddle.button.onClick.AddListener(OnInstantSoundMiddleClick);
			uiInstantSoundHigh.button.onClick.AddListener(  OnInstantSoundHighClick);
			line += 2;
			
			uiVolumeSlider = MakeSlider(strVolumeSlider, 0, line, 0.0f, 1.5f, core.sound.headAudioSource.volume);
			uiVolumeSlider.slider.onValueChanged.AddListener(OnVolumeSliderChange);
			uiInstantVolumeLow    = MakeButton(strInstantVolumeLow,   quick4, line, width:buttonSizeXQuick, height:sliderSizeY);
			uiInstantVolumeMiddle = MakeButton(strInstantVolumeMiddle,quick5, line, width:buttonSizeXQuick, height:sliderSizeY);
			uiInstantVolumeHigh   = MakeButton(strInstantVolumeHigh,  quick6, line, width:buttonSizeXQuick, height:sliderSizeY);
			uiInstantVolumeLow.button.onClick.AddListener(   OnInstantVolumeLowClick);
			uiInstantVolumeMiddle.button.onClick.AddListener(OnInstantVolumeMiddleClick);
			uiInstantVolumeHigh.button.onClick.AddListener(  OnInstantVolumeHighClick);
			line += 2;
			
			uiStrengthSlider = MakeSlider(strStrengthSlider, 0, line, 0f, 1.5f, core.expression2.fmm.baseMultiplier);
			uiStrengthSlider.slider.onValueChanged.AddListener(OnStrengthSliderChange);
			uiInstantStrengthLow    = MakeButton(strInstantStrengthLow,    quick4, line, width:buttonSizeXQuick, height:sliderSizeY);
			uiInstantStrengthMiddle = MakeButton(strInstantStrengthMiddle, quick5, line, width:buttonSizeXQuick, height:sliderSizeY);
			uiInstantStrengthHigh   = MakeButton(strInstantStrengthHigh,   quick6, line, width:buttonSizeXQuick, height:sliderSizeY);
			uiInstantStrengthLow.button.onClick.AddListener(   OnInstantStrengthLowClick);
			uiInstantStrengthMiddle.button.onClick.AddListener(OnInstantStrengthMiddleClick);
			uiInstantStrengthHigh.button.onClick.AddListener(  OnInstantStrengthHighClick);
			line += 1;
			
		}
		
		public void RemoveMenuBody(){
			RemoveMenuBodyMain();
			core.addonManager1.DoWorldUIAddon1Function("RemoveMenuBodyAddon");
			core.DoAddonManager2Function("RemoveMenuBodyAddon");
		}

		public void RemoveTemporaryMenu(){
			RemoveMenuBodyTemporary();			
		}
		
		public void ColoringButton(UIDynamicButton[] buttons, float fR, float fG, float fB){
			foreach(UIDynamicButton button in buttons){
				ColoringButton(button, fR, fG, fB);
			}
		}
		
		public void ColoringButtonNew(Dictionary<string, UIDynamicButton> buttons, float fR, float fG, float fB){
			List<string> keys = buttons.Keys.ToList<string>();
			foreach(var key in buttons.Keys.ToList<string>()){
				if(!ButtonStructDic.ContainsKey(key)) continue;
				if(key.StartsWith("C:") || key.StartsWith("H:")) ColoringButton(buttons[key], fR, fG, fB);
			}
		}
		
		public void ColoringButton(UIDynamicButton button, float fR, float fG, float fB){
			if(button != null){
				if(button.label.StartsWith("Hint") || button.label.StartsWith("Help")){
					button.buttonColor = new Color(255f/255f, 255f/255f, 180f/255f);
				}else{
					button.buttonColor = new Color(fR, fG, fB);	
				}
			}
		}
		
		public void ColoringTextField(UIDynamicTextField[] texts, float fR, float fG, float fB){
			foreach(UIDynamicTextField text in texts){
				if(text != null){
					text.backgroundColor = new Color(fR, fG, fB);	
				}
			}
		}
		
		public void Coloring(){
			try{
				if(uiHeaderButtons == null) return;
				UIDynamicButton[] baseButtons = {
					uiHeaderButtons["M:Minimize"],
				};
				
				foreach(UIDynamicButton button in baseButtons){
					if(button != null){
						if(core.GetMemoryBool("isPaused")){
							button.buttonColor = new Color(128f/255f, 128f/255f, 128f/255f);				
						}else{
							button.buttonColor = new Color(52f/255f, 164f/255f, 235f/255f);				
						}
					}
				}

				UIDynamicButton[] buttons = {
					uiInstantVolumeLow   ,uiInstantSoundLow,   uiInstantStrengthLow,   uiInstantWaveLow, uiInstantScaleLow,
					uiInstantVolumeMiddle,uiInstantSoundMiddle,uiInstantStrengthMiddle,uiInstantWaveMiddle, uiInstantScaleMiddle,
					uiInstantVolumeHigh  ,uiInstantSoundHigh,  uiInstantStrengthHigh,  uiInstantWaveHigh,  uiInstantWave999, uiInstantScaleHigh, 
				};
				ColoringButton(buttons, 198f/255f, 250f/255f, 192f/255f);

				ColoringButtonNew(uiBodyButtons, 198f/255f, 250f/255f, 192f/255f);
				UIDynamicSlider[] otherSliders = {
					uiStrengthSlider, uiPitchSlider, uiVolumeSlider,
					uiWaveSlider, uiScaleSlider,
				};
				
				foreach(UIDynamicSlider slider in otherSliders){
					if(slider != null){
						Image bgImage = slider.GetComponentInChildren<Image>();
						bgImage.color = new Color(198f/255f, 250f/255f, 192f/255f);
					}
				}
				
				if(uiExpandButtons != null)
				{
					UIDynamicButton[] expandButtons = uiExpandButtons.Values.ToList<UIDynamicButton>().ToArray();
					ColoringButton(expandButtons, 235f/255f, 161f/255f, 52f/255f);
				}

				UIDynamicTextField[] texts = {
					uiStatusField,
				};
				ColoringTextField(texts, 224f/255f, 192f/255f, 255f/255f);
				
			}catch(Exception e){
				core.LoggerE(e);
			}
		}
		
		public void RemoveMenuBodyTemporary(){
			UIDynamicButton[] buttons = {
				uiTemporaryButton, uiTemporaryButtonY, uiTemporaryButtonN,
			};
			
			UIDynamicTextField[] texts = {
				uiTemporaryText,
			};
			
			try{
				worldUIBase.RemoveMenuBodyImpl(buttons, texts);
			}catch(Exception e){
				core.LoggerE(e);
			}
		}
		
		public void RemoveMenuBodyMain(){
			try{
			UIDynamicButton[] buttons = {
				uiInstantVolumeLow   ,uiInstantSoundLow,   uiInstantStrengthLow,   uiInstantWaveLow, uiInstantScaleLow,
				uiInstantVolumeMiddle,uiInstantSoundMiddle,uiInstantStrengthMiddle,uiInstantWaveMiddle, uiInstantScaleMiddle,
				uiInstantVolumeHigh  ,uiInstantSoundHigh,  uiInstantStrengthHigh,  uiInstantWaveHigh,  uiInstantWave999, uiInstantScaleHigh,
			};
			if(uiExpandButtons != null)
				buttons = buttons.Concat(uiExpandButtons.Values).ToArray();
			if(uiHeaderButtons != null)
				buttons = buttons.Concat(uiHeaderButtons.Values).ToArray();
			if(uiBodyButtons != null)
				buttons = buttons.Concat(uiBodyButtons.Values).ToArray();

			UIDynamicSlider[] sliders = {
				uiStrengthSlider, uiWaveSlider, uiGaugeSlider, uiPitchSlider, uiVolumeSlider ,uiScaleSlider, 
			};

			UIDynamicTextField[] texts = {
				uiStatusField,
			};
			
			worldUIBase.RemoveMenuBodyImpl(buttons, sliders, texts);
			}catch(Exception e){
				core.LoggerE(e);
			}
		}

		public void OnExpandCommon(string type){
			core.SetMemoryBool(type, !core.GetMemoryBool(type));
			RemoveMenuBody();
			MakeMenuBody();
		}
				
		public void WorldUIControlIfNeeded(){
			if(SuperController.singleton.worldUIActivated){
				core.wasInWorldUi = true;
				if(IsMinimized() == false){
				// if(isMinimize == false){
					OnMinimizeStartClick();
					core.wasMinimized = true;
				}
			}else{
				core.wasInWorldUi = false;
				if(core.wasMinimized && IsMinimized()){
				// if(core.wasMinimized && isMinimize){
					ExpandMenu();
					core.wasMinimized = false;
					OnRecoverMenu();
				}
			}
		}		

		public void OnRecoverMenu()
		{
			if(core.externalLinkage.InDLing_Colortone){
				core.externalLinkage.InDLing_Colortone = false;
				if(core.externalLinkage.ExistsColortoneInTheGame()){
					core.externalLinkage.SetColorCorrect(true);
					core.DoDelayedAction(() => LabelSwitchNew("C:Colortone"), 0.5f);
				}
			}
			
			core.externalLinkage.postMagicSub.OnMenuRecoveringDone();
			core.DoDelayedAction(() => LabelSwitchNew("C:PostMagic"), 0.5f);
			// if(core.externalLinkage.InDLing_PostMagic){
			// 	core.externalLinkage.InDLing_PostMagic = false;
			// 	if(core.externalLinkage.ExistPostMagicInTheGame()){
			// 		Utility.Debug($"routeX1");
			// 		core.externalLinkage.SetPostMagic(true);
			// 		core.DoDelayedAction(() => LabelSwitchNew("C:PostMagic"), 0.5f);
			// 	}
			// }

			core.externalLinkage.vamMoanSub.OnMenuRecoveringDone();
			core.DoDelayedAction(() => LabelSwitchNew("C:VAMMoan"), 0.5f);
			// if(core.externalLinkage.InDLing_VAMMoan){
			// 	core.externalLinkage.InDLing_VAMMoan = false;
			// 	if(core.externalLinkage.ExistVAMMoanInTheGame()){
			// 		core.externalLinkage.SetVAMMoan(true);
			// 		core.DoDelayedAction(() => LabelSwitchNew("C:VAMMoan"), 0.5f);
			// 	}
			// }

			core.externalLinkage.browserAssistSub.OnMenuRecoveringDone();
			core.DoDelayedAction(() => LabelSwitchNew("C:BrowserAssist"), 0.5f);

		}
		
		public void OnMinimizeClick(){
			try{
			if(IsPaused()) return;
			if(IsMinimized()){
			// if(isMinimize){
				ExpandMenu();
				core.SetMemoryBool("isMinimized", false);
				// isMinimize = false;
			}else{
				OnMinimizeStartClick();
				// isMinimize = true;
				core.SetMemoryBool("isMinimized", true);
			}

			}catch(Exception e){
				core.LoggerE(e);
			}
		}

		public void OnMinimizeStartClick(){
			try{
				if(core.UIAtom != null && core.UIAtom.mainController != null && core.UIAtom.mainController.transform != null)
					canvasPos = Utility.GetPosition(core.UIAtom.mainController.transform.position);
				RemoveMenuBody();
				core.SetMemoryBool("isMinimized", true);
				MakeMenuBodyPartMinAlt();
			}catch(Exception e){
				core.LoggerE(e);
			}
		}

		public void OnPauseClick(){
			if(core.GetMemoryBool("isPaused")){
				OnPauseEndClick();
			}else{
				OnPauseStartClick();
			}
		}

		public void OnPauseStartClick(){
			try{
				core.SetMemoryBool("isPaused", true);
				canvasPos = Utility.GetPosition(core.UIAtom.mainController.transform.position);
				RemoveMenuBody();
				MakeMenuBodyPartMinAltPaused();
			}catch(Exception e){
				core.LoggerE(e);
			}
		}
		
		public void OnPauseEndClick(){
			core.SetMemoryBool("isPaused", false);
			RemoveMenuBody();
			MakeMenuBodyPartMinAlt();
		}
		
		public void OnToggleXClick(string type, string collapseString, string expandString){
			if(!core.GetMemoryBool(type)){
				if(collapseString != ""){
					SetExpandValue(collapseString);
				}
				core.SetMemoryBool(type, true);
			}else{
				if(expandString != ""){
					SetExpandValue(expandString);
				}
				core.SetMemoryBool(type, false);
			}
		}

		public void OnCompactClick(){
			OnToggleXClick("isCompact", "", "");
			ReloadMenu();
		}

		public void OnCategoryOnClick(){
			OnToggleXClick("categoryOn", "", "");
			ReloadMenu();
		}
		
		
		public void OnCollapseExpandClick(){
			OnToggleXClick("isCollapse", "Collapse", "Expand");
			ReloadMenu();
		}
		
		public void OnCollapseWOBarUIClick(){
			OnToggleXClick("isBarOnly", "BarOnly", "Recovery");
			ReloadMenu();
		}

		public void OnCloseMenuClick(){
			core.customUi.dJSToggle["Display UI Menu"].SetVal(false);
			RemoveMenuBody();
			core.customUi.ChangeButtonColoring();
			core.RemoveGameObjectByName("SphereForUICorner");
		}

		public void OnResetUIClick(){
			try{
				core.ResetMemoryAtom();
			}catch(Exception e){
				core.LoggerE(e);
			}
		}

		public void ExpandMenu(){
			core.SetMemoryBool("isMinimized", false);
			ReloadMenu();
		}
		
		public void ReloadMenu(){
			LabelSwitch();
			RemoveMenuBody();
			MakeMenuBody();
		}

		public void OnOpenAtomMenuClick(){
			Utility.OpenAtomUI(core.atom);
		}
		
		public void OnOpenCustomUIClick(){
			Utility.OpenCustomUI(core.atom, "EBATCore");
		}
		
		public void OnOpenClothingUIClick(){
			Utility.OpenUIByName(core.atom, "Clothing");
		}
		
		public void OnOpenHairUIClick(){
			Utility.OpenUIByName(core.atom, "Hair");
		}
		
		public void OnOpenFemaleMorphsUIClick(){
			Utility.OpenUIByName(core.atom, "Female Morphs");
		}
		
		public void OnOpenMaleMorphsUIClick(){
			Utility.OpenUIByName(core.atom, "Male Morphs");
		}		
		
		public void OnCloseUIClick(){
			Utility.CloseUI();
		}
		
		public void OnLookFrontClick(){
			Utility.LookFront(core.UIAtom.mainController.transform);
		}

		public void OnReloadPluginsClick(){
			try{
				Utility.ReloadPlugins(core.atom);
			}catch(Exception e){
				core.LoggerE(e);
			}
		}

		public void OnReloadThisPluginOnlyClick(){
			try{
				bool result = Utility.ReloadButtonClick(core.atom, "EBATCore");
				if(!result){
					core.StartCoroutine(FirstReloadClickCoroutine());
				}
			}catch(Exception e){
				core.LoggerE(e);
			}
		}
		
		public IEnumerator FirstReloadClickCoroutine(){
			OnOpenAtomMenuClick();
			yield return new WaitForSeconds(1.0f);
			OnReloadThisPluginOnlyClick();
			yield return null;
		}

		public void ClearReloadStatus(){
			ExternalLinkageKeys.ForEach(name => {
				core.SetMemoryBool(name, false);
			});
		}

		public bool InReloadSequence(string type){
			var key = "Reload:" + type;
			var result = core.GetMemoryBool(key);
			var reload = core.externalLinkage.IsReloadNeeded(type);

			if(core.externalLinkage.IsReloadNeeded(type)){
				core.SetMemoryBool(key, true);
				return false;
			}else{
				if(core.GetMemoryBool(key)){
					core.SetMemoryBool(key, false);
					return true;
				}
			}
			return false;
		}

		public void OnTogglePostMagicClick(bool isDoFOn = false){
			if(InReloadSequence("PostMagic")) return;
	
			var isOn = core.externalLinkage.IsPostMagicOn(isDoFOn);
			core.externalLinkage.DoFOnOff(isDoFOn);

			var label = isDoFOn ? "C:PostMagicWDoF" : "C:PostMagic";
			core.SetMemoryBool(label, !isOn);

			core.externalLinkage.SetPostMagic(!isOn);
			core.DoDelayedAction(() => LabelSwitchNew("C:PostMagic"), 0.5f);
			core.DoDelayedAction(() => LabelSwitchNew("C:PostMagicWDoF"), 0.5f);

		}

		public void OnToggleVAMMoanClick(){
			if(InReloadSequence("VAMMoan")) return;

			var isOn = core.externalLinkage.IsVAMMoanOn();
			core.SetMemoryBool("C:VAMMoan", !isOn);

			core.externalLinkage.SetVAMMoan(!isOn);
			core.DoDelayedAction(() => LabelSwitchNew("C:VAMMoan"), 0.5f);
		}

		public void OnToggleBrowserAssistClick(){
			if(InReloadSequence("BrowserAssist")) return;

			var isOn = core.externalLinkage.IsBrowserAssistOn();
			core.externalLinkage.SetBrowserAssist(!isOn);
			core.DoDelayedAction(() => LabelSwitchNew("C:BrowserAssist"), 0.5f);
			core.SetMemoryBool("C:BrowserAssist", !isOn);
		}

		public void OnBrowserAssistOnClick(){
			core.externalLinkage.LaunchBrowserAssist();
		}

		public void OnToggleColortoneClick(){
			var isOn = core.externalLinkage.IsColortoneOn();
			core.externalLinkage.SetColorCorrect(!isOn);
			core.DoDelayedAction(() => LabelSwitchNew("C:Colortone"), 0.5f);
			core.SetMemoryBool("C:Colortone", !isOn);
		}

		public void OnChangeSizeClick(){
			if(!core.GetMemoryBool("isSmall")){
				core.SetMemoryBool("isSmall", true);
			}else{
				core.SetMemoryBool("isSmall", false);
			}
			RemoveMenuBody();
			MakeMenuBody();
		}
		
		public void OnOrgasmButtonClick(){
			if(core.orgasmModeOn == false){
				if(core.GetGauge() < core.stageThresholdInGame[5]){
					core.SetGauge(core.stageThresholdInGame[5]);
					core.OnErogenousZoneTouch("ByScript");
					core.UpdateAll();
				}
			}else{
				if(core.orgasmModeOn){
					if(core.GetGauge() < core.stageThresholdInGame[5]){
						StartOrgasm();
					}else{
						FinishOrgasm();
					}
				}
			}
		}
		
		public void StartOrgasm(){
			core.DoOrgasmFunction("MakeHerOrgasm");
		}
		
		public void FinishOrgasm(){
			core.DoOrgasmFunction("StopHerOrgasm");						
		}

		public void OnOrgasmStart()
		{
			if(uiBodyButtons == null || !uiBodyButtons.ContainsKey("Make Her Orgasm")) return;
			if(ButtonStructDic == null || !ButtonStructDic.ContainsKey("Make Her Orgasm")) return;
			if(core.orgasmModeOn){
				LabelUpdateImpl(uiBodyButtons["Make Her Orgasm"], ButtonStructDic["Make Her Orgasm"].alt);
			}
		}
		
		public void OnOrgasmStop()
		{
			if(uiBodyButtons == null || !uiBodyButtons.ContainsKey("Make Her Orgasm")) return;
			if(ButtonStructDic == null || !ButtonStructDic.ContainsKey("Make Her Orgasm")) return;
			if(core.orgasmModeOn){
				LabelUpdateImpl(uiBodyButtons["Make Her Orgasm"], ButtonStructDic["Make Her Orgasm"].normal);
			}
		}
		
		public void OnScaleSliderChange(float value){
			try{
				core.assetScale = value;
				core.DoAddonManager2Function("SetAssetScale");
				if(core.customUi.dJSColor == null || core.customUi.dJSSlider["CustomUnityAsset Scale"].slider == null) return;
				core.customUi.dJSSlider["CustomUnityAsset Scale"].slider.value = value;
			}catch(Exception e){
				core.LoggerE(e);
			}
		}
		
		public void OnInstantScaleLowClick(){
			OnInstantScaleClickCommon(0.9f);
		}

		public void OnInstantScaleMiddleClick(){
			OnInstantScaleClickCommon(1.0f);
		}

		public void OnInstantScaleHighClick(){
			OnInstantScaleClickCommon(1.1f);
		}

		public void OnInstantScaleClickCommon(float value){
			try{
				core.assetScale = value;
				core.DoAddonManager2Function("SetAssetScale");
				if(uiScaleSlider != null) uiScaleSlider.slider.value = value;
				core.customUi.SetUISliderValueExternal("CustomUnityAsset Scale", value);
			}catch(Exception e){
				core.LoggerE(e);
			}
		}		

		public void OnWaveSliderChange(float value){
			try{
				core.orgasmWaveCycleBigMax = (int)value;
				if(core.customUi.dJSSlider["Orgasm Wave Big Cycle Count Max"].slider != null){
					core.customUi.dJSSlider["Orgasm Wave Big Cycle Count Max"].slider.value = value;
				}
			}catch(Exception e){
				core.LoggerE(e);
			}
		}
		
		public void OnInstantWaveLowClick(){
			OnInstantWaveClickCommon(5f);
		}

		public void OnInstantWaveMiddleClick(){
			OnInstantWaveClickCommon(10f);
		}

		public void OnInstantWaveHighClick(){
			OnInstantWaveClickCommon(20f);
		}

		public void OnInstantWave999Click(){
			OnInstantWaveClickCommon(999f);
		}

		public void OnInstantWaveClickCommon(float value){
			core.orgasmWaveCycleBigMax = (int)value;
			if(uiWaveSlider != null) uiWaveSlider.slider.value = (int)value;
			core.customUi.SetUISliderValueExternal("Orgasm Wave Big Cycle Count Max", value);
		}		

		public void OnInstantSoundLowClick(){
			OnInstantSoundClickCommon(0.95f);
		}

		public void OnInstantSoundMiddleClick(){
			OnInstantSoundClickCommon(1.0f);
		}

		public void OnInstantSoundHighClick(){
			OnInstantSoundClickCommon(1.2f);
		}

		public void OnInstantSoundClickCommon(float value){
			core.sound.headAudioSource.pitch = value;
			if(uiPitchSlider != null) uiPitchSlider.sliderControl.setSliderToValue(value);
			core.customUi.SetUISliderValueExternal("Sound Pitch", value);
		}
		
		public void OnInstantVolumeLowClick(){
			OnInstantVolumeClickCommon(0.5f);
		}

		public void OnInstantVolumeMiddleClick(){
			OnInstantVolumeClickCommon(0.7f);
		}

		public void OnInstantVolumeHighClick(){
			OnInstantVolumeClickCommon(1.0f);
		}

		public void OnInstantVolumeClickCommon(float value){
			core.sound.headAudioSource.volume = value;
			if(uiVolumeSlider != null) uiVolumeSlider.sliderControl.setSliderToValue(value);
			core.customUi.SetUISliderValueExternal("Sound Volume", value);
		}
		
		public void OnInstantStrengthLowClick(){
			OnInstantStrengthClickCommon(0.8f);
		}

		public void OnInstantStrengthMiddleClick(){
			OnInstantStrengthClickCommon(1.0f);
		}

		public void OnInstantStrengthHighClick(){
			OnInstantStrengthClickCommon(1.1f);
		}

		public void OnInstantStrengthClickCommon(float value){
			core.expression2.fmm.baseMultiplier = value;
			uiStrengthSlider.slider.value = value;
			core.customUi.SetUISliderValueExternal("Expression Strength", value);
		}
				
		public void OnPeeButtonClick(){
			if(core.customUnityAssetItem.peeingOnGlobal){
				if(core.GetGauge() < core.stageThresholdInGame[2]){
					core.SetGauge(core.stageThresholdInGame[2]);
					core.OnErogenousZoneTouch("VaginaDeeper");						
				}
				core.customUnityAssetItem.PeeRandom(core.GetTime(), true);
			}
			
			DAZCharacterSelector character = core.atom.GetStorableByID("geometry") as DAZCharacterSelector;
			var ui = character.selectedCharacter.transform;			
		}

		public void OnResetExpressionButton(){
			core.expression2.ResetExpression();
		}

		public void OnCalmDownButtonClick(){
			core.DoOrgasmFunction("StopHerOrgasm");
			core.SetGauge(0);
			core.customUi.jsOrgasmCount.val = 0f;
			core.customUi.jsHasMultipleOrgasms.val = false;
			core.tears.ChangeTearsEquipment();
			core.expression2.ResetExpression();
			core.soundExternalLinkage.StopVamm();
			core.OnStageChange(false);
		}
		
		public void OnStageUp(){
			int stage = core.GetStage();
			stage += (stage == 5) ? 0 : 1;
			core.SetStage(stage);
			core.OnErogenousZoneTouch("ByScript");
			if(stage == 5){
				core.DoOrgasmFunction("MakeHerOrgasm");
			}
		}

		public void OnStageDown(){
			int stage = core.GetStage();
			stage -= (stage == 0) ? 0 : 1;
			core.SetStage(stage);
			if(stage == 4){
				core.DoOrgasmFunction("StopHerOrgasm");
			}
		}

		public void OnFaceForwardClick(){
			core.headController.HeadMotion("Face Forward", true);
		}

		public void OnFaceSidewaysClick(){
			core.headController.HeadMotion("Face Sideways 1", true);
		}

		public void OnFaceSidewaysAltClick(){
			core.headController.HeadMotion("Face Sideways 2", true);
		}

		public void OnFaceSidewaysMaxClick(){
			core.headController.HeadMotion("Face Sideways 3", true);
		}

		public void OnLookGlancingClick(){
			core.headController.HeadMotion("Glance", true);
		}

		public void OnBackBendingWeakClick(){
			core.headController.HeadMotion("Turn Head Back 1", true);
		}

		public void OnBackBendingStrongClick(){
			core.headController.HeadMotion("Turn Head Back 2", true);
		}

		public void OnHint2Click(){
			core.hint.DoublingColliderHint();
		}

		public void OnHint3Click(){
			core.hint.AutoStopHint();
		}

		public void OnHint4Click(){
			core.hint.FaceSidewaysHint();
		}

		// public void OnHint5Click(){
		// 	core.hint.SensitiveTriggerHint();
		// }

		public void OnHint6Click(){
			core.hint.CustomUiHint("Hint:[AS]Stop Morph Control by non-plugins");
		}

		public void OnHint7Click(){
			core.hint.CustomUiHint("Hint:[AS]Stop Head Control by non-plugins");
		}

		public void OnHint8Click(){
			core.hint.CustomUiHint("Hint:[AS]Stop Body Control by non-plugins");
		}

		public void OnHint9Click(){
			core.hint.ShiveringHint();
		}

		public void OnHint10Click(){
			core.hint.VAMMoanHint();
		}

		public void OnHint11Click(){
			core.hint.SkinWrapHint();
		}

		public void OnHint15Click(){
			core.hint.CollisionFailureCheckHint();
		}

		public void UpdateStatus(){
			if(uiStatusField == null){ return; };
			if(IsCompact()){ return; };
			
			string status = strGenderSVar + " is not sexually aroused at all.";
			string th = "th";
			if(core.curStage == 1){
				th = "st";
			}else if(core.curStage == 2){
				th = "nd";
			}else if(core.curStage == 3){
				th = "rd";
			}
			if(core.curStage >= 1){
				status = strGenderSVar + " is on the " + core.curStage + th + " level of arousal. ";
			}
			if(!core.isHot){
				status += strGenderSVar + " is calm.";
			}else{
				if(core.isDuringAfterglow){
					status += strGenderSVar + " is having a lingering orgasm. ";
				}else if(core.isDuringOrgasm){
					if(core.customUi.jsHasMultipleOrgasms.val){
						status += strGenderSVar + " is having multiple orgasms. ";
					}else{
						status += strGenderSVar + " is having an orgasm. ";
					}
				}else{
					status += strGenderSVar + " is sexually aroused. ";
				}
				if(core.customUi.jsOrgasmCount.val == 0f){
				}else if(core.customUi.jsOrgasmCount.val == 1f){
					status += strGenderSVar + " has already reached " + strGenderPVar + " climax. ";
				}else{
					status += strGenderSVar + " had already climaxed " + (int)core.customUi.jsOrgasmCount.val + " times. ";
				}
			}
			if(core.customUnityAssetItem.isPeeFree == false){
				status += strGenderSVar + " has squirted. ";
			}
			
			uiStatusField.text = status;
		}

		public void LabelSwitch(){
			core.addonManager1.DoWorldUIAddon1Function("LabelSwitch");
			core.DoAddonManager2Function("LabelSwitch");
		}

		public void LabelSwitchNew(string key)
		{
			string newLabel = GetNewLabel(key);
			if(!uiBodyButtons.ContainsKey(key)) return;
			LabelUpdateImpl(uiBodyButtons[key], newLabel); 
		}
				
		public void LabelUpdateImpl(UIDynamicButton ui, string label){
			try{
				if(ui != null){
					ui.label = label;
				}
			}catch(Exception e){
				core.LoggerE(e);
				core.Info("ui:" + ui + ", label:" + label);
			}
		}
		
		string DLMessagePrefix = "<b>Click \"Download All\"(or \"Download\".)</b>\n" +
		"<size=36>And if you like it, please add a Reaction (Like! etc.) to this great Plugin, ";
		string DLMessageSuffix = ".\nNote: Reactions cannot be added from within the game, so please log in to VaM Hub from a browser such as Chrome.</size>";

		public void DLGuideCommon(string displayName, string varName, string resourceNumber){
			var DLMessage = DLMessagePrefix + displayName + DLMessageSuffix;
			core.worldUi.worldUIBase.OpenHubDetail(varName, resourceNumber);
			core.DoDelayedAction(() => {core.hint.NotifyToUserForDL(DLMessage);}, 1.0f);
		}

		public void NotifyToUserForDL(string text, int fontSize = 96, float width = 800f, float height = 400f){
			if(uiTemporaryText){
				RemoveMenuBodyTemporary();
			}
			uiTemporaryText = MakeTextFieldTemporary(text, width, height, 64, forDL:true);
			uiTemporaryButton = MakeButtonTemporary(100f, 60f, 0.35f, -0.05f, 48, forDL:true);
			uiTemporaryButton.button.onClick.AddListener(OnTemporaryButtonClick);
			UIDynamicTextField[] texts = {
				uiTemporaryText,
			};
				// Color ColorActive = new Color(235f/255f, 161f/255f, 52f/255f);
				// Color ColorStrong = new Color(200f/255f, 100f/255f, 100f/255f);
				// Color ColorSafe   = new Color(198f/255f, 250f/255f, 192f/255f);			
			ColoringTextField(texts, 200f/255f, 100f/255f, 100f/255f);
		}
		
		public void NotifyToUser(string text, int fontSize = 48, float width = 800f, float height = 400f){
			if(uiTemporaryText){
				RemoveMenuBodyTemporary();
			}
			uiTemporaryText = MakeTextFieldTemporary(text, width, height, fontSize);
			uiTemporaryButton = MakeButtonTemporary(100f, 60f, 0.35f, -0.05f, fontSize);
			uiTemporaryButton.button.onClick.AddListener(OnTemporaryButtonClick);
			UIDynamicTextField[] texts = {
				uiTemporaryText,
			};
			ColoringTextField(texts, 160f/255f, 240f/255f, 224f/255f);
		}
		
		public void AskToUser(string text, Action yesF, Action noF, int fontSize = 48, float width = 800f, float height = 400f){
			core.StartCoroutine(AskToUserCoroutine(text, yesF, noF, fontSize, width, height));
		}
		
		public IEnumerator AskToUserCoroutine(string text, Action yesF, Action noF, int fontSize = 48, float width = 800f, float height = 400f){
			for(int i = 0; i < 2000; i++){
				if(worldUIBase.canvasTemporary != null){ break; }
				yield return new WaitForSeconds(0.1f);
			}
			
			if(uiTemporaryText){
				RemoveMenuBodyTemporary();
			}
			uiTemporaryText = MakeTextFieldTemporary(text, width, height, fontSize);
			uiTemporaryButtonY = MakeButtonTemporary(100f, 60f, 0.15f, -0.05f, fontSize, "Yes");
			uiTemporaryButtonY.button.onClick.AddListener(OnTemporaryButtonYClick);
			tempAct1 = yesF;
			tempAct2 = noF;
			uiTemporaryButtonN = MakeButtonTemporary(100f, 60f, 0.55f, -0.05f, fontSize, "No");
			uiTemporaryButtonN.button.onClick.AddListener(OnTemporaryButtonNClick);
			UIDynamicTextField[] texts = {
				uiTemporaryText,
			};
			ColoringTextField(texts, 160f/255f, 240f/255f, 224f/255f);
			yield return null;
		}
		
		public void OnTemporaryButtonClick(){
			RemoveTemporaryMenu();
		}
		
		public void OnTemporaryButtonYClick(){
			RemoveTemporaryMenu();
			tempAct1();
			tempAct1 = null;
		}
		
		public void OnTemporaryButtonNClick(){
			RemoveTemporaryMenu();
			tempAct2();
			tempAct2 = null;
		}
		

		public void OnCoverActionClick(string type){
			core.DisableTriggerTemporary();
			if(type == "Hands"){
				core.DoAddonManager2Function("CoverWithHands");
			}else if(type == "HandsUU"){
				core.DoAddonManager2Function("CoverWithHandsUU");
			}else if(type == "HandsUL"){
				core.DoAddonManager2Function("CoverWithHandsUL");
			}else if(type == "HandsLL"){
				core.DoAddonManager2Function("CoverWithHandsLL");
			}else if(type == "Legs"){
				core.DoAddonManager2Function("CloseLegs");
			}else if(type == "Mouth"){
				core.DoAddonManager2Function("CoverMouth");
			}
		}

		public void OnSingleWaveClick(){
			core.DisableTriggerTemporary();
			core.DoOrgasmFunction("SingleWave");
		}
		
		public Dictionary<string, string> ExternalNameMap = new Dictionary<string, string>(){
			{"C:Expression", "Expression On"},
			{"C:Blushing", "Blush On"},
			{"C:Tears", "Tears On"},
			{"C:Drool", "Drool On"},
			{"C:AutoExprOFF", "Auto Expression Off"},
			{"C:AutoBlinkOFF", "Auto Blink Off"},
			{"C:EyesControl", "Eyes Control On"},
			{"C:EyesRollup", "Eyes Rollup On"},
			{"C:Sound", "Sound On"},
			{"C:Use VAMMoan", "Use VAMMoan for Sound"},
			{"C:Peeing", "Peeing On"},
			{"C:HeadMotion", "Head Motion On"},
			{"C:2x Collider Radius", "2x Collider Radius"},
			{"C:Collision Failure Check", "Collision Failure Check"},
			{"C:Collision Auto Fix", "Collision Auto Fix"},
			{"C:Penis Support", "Penis Support"},
			{"C:AutoStop Plugins", "OnOff:AutoStop Other Plugins"},
			{"C:AutoStop Morph", "OnOff:Stop Morph Control by non-plugins"},
			{"C:AutoStop Head", "OnOff:Stop Head Control by non-plugins"},
			{"C:AutoStop Body", "OnOff:Stop Body Control by non-plugins"},
			{"C:NippleErection", "Nipple Erection On"},
			{"C:ClitorisErection", "Clitoris Erection On"},
			{"C:Shivering(Bone)", "Shivering during climax(bone)"},
			{"C:Shivering(Morph)", "Shivering during climax(morph)"},
		};

		public void OnConfigXClickCommon(string keyName){
			if(!ExternalNameMap.ContainsKey(keyName)) return;
			OnConfigXClickCommon(keyName, ExternalNameMap[keyName]);
		}

		public void OnConfigXClickCommon(string keyName, string displayName){
			core.customUi.ToggleExternal(displayName);
			LabelSwitchNew(keyName);
			if(!ButtonStructDic.ContainsKey(keyName)) return;
			ButtonStruct bs = ButtonStructDic[keyName];
			var mem = bs.func();
			core.SetMemoryBool(keyName, mem);
		}
		
		public void OnStrengthSliderChange(float value){
			try{
				core.expression2.fmm.baseMultiplier = value;
				if(core.customUi.dJSSlider["Expression Strength"].slider != null){
					core.customUi.dJSSlider["Expression Strength"].slider.value = value;
				}
			}catch(Exception e){
				core.LoggerE(e);
			}
		}

		public void OnPitchSliderChange(float value){
			try{
				core.sound.headAudioSource.pitch = value;
				if(core.customUi.dJSSlider["Sound Pitch"].slider != null){
					core.customUi.dJSSlider["Sound Pitch"].slider.value = value;
				}
			}catch(Exception e){
				core.LoggerE(e);
			}
		}
		
		public void OnVolumeSliderChange(float value){
			try{
				core.sound.headAudioSource.volume = value;
				if(core.customUi.dJSSlider["Sound Volume"].slider != null){
					core.customUi.dJSSlider["Sound Volume"].slider.value = value;
				}
			}catch(Exception e){
				core.LoggerE(e);
			}
		}
		
		public UIDynamic MakeSpacer(int x, int y, float width = 0f, float height = 0f){
			return worldUIBase.MakeSpacer(x, y, width, height);
		}
		
		public UIDynamicButton MakeButtonTemporary(float width = 100f, float height = 60f, float xpos = 0.25f, float ypos = -0.05f, int fontSize = 50, string label = "OK", bool forDL = false){
			return worldUIBase.MakeButtonTemporary(width, height, xpos, ypos, fontSize, label, forDL);
		}
		
		public UIDynamicButton MakeButton(string name, int x, int y, float width = 0f, float height = 0f, bool isMinimizeButton = false, bool isMinisizeButton = false){
			return MakeButton(name, (float)x, y, width, height, isMinimizeButton, isMinisizeButton);
		}

		public UIDynamicButton MakeButton(string name, float x, int y, float width = 0f, float height = 0f, bool isMinimizeButton = false, bool isMinisizeButton = false){
			return worldUIBase.MakeButton(name, x, y, width, height, isMinimizeButton, isMinisizeButton);
		}

		public UIDynamicTextField MakeTextField(string text, float x, int y, float width = 0f, float height = 0f, bool isMinimizeButton = false){
			return worldUIBase.MakeTextField(text, x, y, width, height, isMinimizeButton);
		}
		
		public UIDynamicTextField MakeTextFieldTemporary(string text, float width = 0f, float height = 0f, int fontSize = 50, bool forDL = false){
			return worldUIBase.MakeTextFieldTemporary(text, width, height, fontSize, forDL);
		}
		
		
		public UIDynamicButton MakeButtonForAddon(string name, int x, int y, float width = 0f, float height = 0f){
			return worldUIBase.MakeButton(name, x, y, width, height);
		}		
		
		public UIDynamicTextField MakeTextFieldForAddon(string name, int x, int y, float width = 0f, float height = 0f){
			return worldUIBase.MakeTextField(name, x, y, width, height);
		}		
		
		public UIDynamicToggle MakeToggle(string name, int x, int y, float width = 0f, float height = 0f){
			return worldUIBase.MakeToggle(name, x, y, width, height);
		}
		
		public UIDynamicSlider MakeSlider(string name, int x, int y, float min, float max, float current){
			return worldUIBase.MakeSlider(name, x, y, min, max, current);
		}

		public void RemoveButton(UIDynamicButton button){
			worldUIBase.RemoveButton(button);
		}


	}
}
